
/* command.c	87/6/16 */

#include "dsm.h"

static struct breps	*breps;
static struct motion	v_view, t_view;
static struct motion	v_ray, t_ray;
static double		v_r, v_vdegx, v_vdegy, dlt_v_r, dlt_vdeg;
static double		v_rdegx, v_rdegy, dlt_rdeg;
static double		t_tsave;
static double		t_tmin, t_tmax, t_tstep, t_bgcol, t_bgint;
static int		t_object;
static int		sw_csg_op;
static int		sw_experts, sw_shadow;
static int		sw_term, sw_BFR, sw_paint;
static int		eval_flag, i, j;
static jmp_buf		sjbuf;

command()
{
#define	COMMAND_LINE	1024
	FILE		*fp;
	long		gettme();
	int		(*istat)();
	void		onintr();
	int		fd;
	char		cmd_buf[COMMAND_LINE];

	get_tmin(&t_tmin);
	get_tmax(&t_tmax);
	get_tstep(&t_tstep);

	if (rread_count == 1) {
		if ((fp = fopen(obj_ename, "r")) == NULL)
			com_init_env();
		else {
			com_read_env(fp);
			fclose(fp);
		}
	}
	com_get_brep();

	for(;;) {
#ifdef SUN
		signal(SIGINT, SIG_IGN);
		setjmp(sjbuf);
		signal(SIGINT, onintr);
#else
		istat = signal(SIGINT, SIG_IGN);
		setjmp(sjbuf);
		if (istat != SIG_IGN)
			signal(SIGINT, onintr);
#endif

		fflush(stdout);
		fprintf(stderr,
		  "(view:%1d,%1d) (ray:%1d,%1d) (_t:%g) <%1d>",
		  (int)v_vdegx, (int)v_vdegy,
		  (int)v_rdegx, (int)v_rdegy,
		  *TIME_T_ENT, gettme()*10);
		if (!fgets(cmd_buf, COMMAND_LINE, stdin)) {
			fprintf(stderr, "\n");
			com_save_env();
			termterm();
			return(0);
		}
		restme();

		switch (*cmd_buf) {
		case 'h':
			fprintf(stderr, "--- ONCE at the head of command line ---\n");
			fprintf(stderr, "h     ... help\n");
			fprintf(stderr, "^D    ... quit\n");
			fprintf(stderr, "!     ... exec unix command\n");
			fprintf(stderr, "z     ... default environment\n");
			fprintf(stderr, "u     ... list used storage\n");
			fprintf(stderr, "i[01] ... OFF/ON csg operation\n");
			fprintf(stderr, "o[01] ... OFF/ON on experts\n");
			fprintf(stderr, "j[01] ... OFF/ON on terminal\n");
			fprintf(stderr, "p[01] ... OFF/ON shadowing\n");
			fprintf(stderr, "k[01] ... OFF/ON B.F.R.\n");
			fprintf(stderr, "l[01] ... OFF/ON painting\n");
			fprintf(stderr, "<     ... update definition\n");
			fprintf(stderr, ">     ... save as primitive\n");
			fprintf(stderr, "m     ... animation\n");
			fprintf(stderr, "--- REPEATABLE in command line ---\n");
			fprintf(stderr, "q     ... view approach\n");
			fprintf(stderr, "a     ... view away\n");
			fprintf(stderr, "e     ... view U\n");
			fprintf(stderr, "x     ... view D\n");
			fprintf(stderr, "s     ... view L\n");
			fprintf(stderr, "d     ... view R\n");
			fprintf(stderr, "t     ... ray  U\n");
			fprintf(stderr, "v     ... ray  D\n");
			fprintf(stderr, "f     ... ray  L\n");
			fprintf(stderr, "g     ... ray  R\n");
			fprintf(stderr, "n     ... scene next\n");
			fprintf(stderr, "b     ... scene before\n");
			fprintf(stderr, "w,<cr>... display\n");
			break;
		case '!':
			system(&cmd_buf[1]);
			break;
		case 'z':
			com_init_env();
			break;
		case 'u':
			status();
			break;
		case 'i':
			sw_csg_op = cmd_buf[1]-'0';
			signal(SIGINT, SIG_DFL);
			com_get_brep();
			signal(SIGINT, onintr);
			break;
		case 'o':
			sw_experts = cmd_buf[1]-'0';
			break;
		case 'p':
			sw_shadow = cmd_buf[1]-'0';
			break;
		case 'j':
			sw_term = cmd_buf[1]-'0';
			break;
		case 'k':
			sw_BFR = cmd_buf[1]-'0';
			break;
		case 'l':
			sw_paint = cmd_buf[1]-'0';
			break;
		case '<':
			com_save_env();
			signal(SIGINT, SIG_DFL);
			return(1);
			break;
		case '>':
     			if ((fd = creat(obj_pname, 0777)) < 0)
				fprintf(stderr, "can't create \"%s\"\n", obj_pname);
     			else {	
				fp = fdopen(fd, "w");
				save_brep(fp, breps);
				fclose(fp);
			}
			break;
		case 'm':
			{
			int k=-1;
			for (*TIME_T_ENT=t_tsave=t_tmin; t_tsave<=t_tmax; *TIME_T_ENT=t_tsave+=t_tstep) {
				signal(SIGINT, SIG_DFL);
				if (!com_get_brep()) {
					signal(SIGINT, onintr);
					break;
				}
				else {
					for (i=0; i<50000000; i++) {
						j+=1;
					}
					if ((k++ % 32) == 0)
						sleep(2);
					signal(SIGINT, onintr);
					com_display();
					fflush(stdout);
					fprintf(stderr, "(_t:%g)\n", *TIME_T_ENT);
				}
			}
			}
			*TIME_T_ENT=t_tsave-=t_tstep;
			break;
		default:
			for (i=0; cmd_buf[i]; i++) {
				switch (cmd_buf[i]) {	
				case 'q':
					v_r /= dlt_v_r;
					break;
				case 'a':
					v_r *= dlt_v_r;
					break;
				case 'e':
					v_vdegx -= dlt_vdeg;
					if (v_vdegx <= -360.0)
						v_vdegx += 360.0;
					break;
				case 'x':
					v_vdegx += dlt_vdeg;
					if (v_vdegx >= 360.0)
						v_vdegx -= 360.0;
					break;
				case 's':
					v_vdegy -= dlt_vdeg;
					if (v_vdegy <= -360.0)
						v_vdegy += 360.0;
					break;
				case 'd':
					v_vdegy += dlt_vdeg;
					if (v_vdegy >= 360.0)
						v_vdegy -= 360.0;
					break;
				case 't':
					v_rdegx -= dlt_rdeg;
					if (v_rdegx <= -360.0)
						v_rdegx += 360.0;
					break;
				case 'v':
					v_rdegx += dlt_rdeg;
					if (v_rdegx >= 360.0)
						v_rdegx -= 360.0;
					break;
				case 'f':
					v_rdegy -= dlt_rdeg;
					if (v_rdegy <= -360.0)
						v_rdegy += 360.0;
					break;
				case 'g':
					v_rdegy += dlt_rdeg;
					if (v_rdegy >= 360.0)
						v_rdegy -= 360.0;
					break;
				case 'n':
					*TIME_T_ENT = t_tsave += t_tstep;
					eval_flag = 0;
					break;
				case 'b':
					*TIME_T_ENT = t_tsave -= t_tstep;
					eval_flag = 0;
					break;
				case 'w':
				case '\n':
					if (!eval_flag) {
						signal(SIGINT, SIG_DFL);
						com_get_brep();
						signal(SIGINT, onintr);
					}
					com_display();
					break;
				default:
					fflush(stdout);
					fprintf(stderr, "?");
					break;
				}
			}
			break;
		}
	}
}
com_init_env()
{
	v_r      = 16.0;
	v_vdegx  = 0.0;
	v_vdegy  = 0.0;
	dlt_v_r  = 1.5;
	dlt_vdeg = 15.0;
	v_rdegx  = 0.0;
	v_rdegy  = 0.0;
	dlt_rdeg = 15.0;

	sw_csg_op  = 0;
	sw_experts = 1;
	sw_shadow  = 0;
	sw_term    = 0;
	sw_BFR     = 0;
	sw_paint   = 0;

	*TIME_T_ENT = t_tsave = t_tmin;
	eval_flag = 0;
}
com_read_env(fp) FILE *fp;
{
	fscanf(fp, "%*s %le", &v_r);
	fscanf(fp, "%*s %le", &v_vdegx);
	fscanf(fp, "%*s %le", &v_vdegy);
	fscanf(fp, "%*s %le", &dlt_v_r);
	fscanf(fp, "%*s %le", &dlt_vdeg);
	fscanf(fp, "%*s %le", &v_rdegx);
	fscanf(fp, "%*s %le", &v_rdegy);
	fscanf(fp, "%*s %le", &dlt_rdeg);

	fscanf(fp, "%*s %d", &sw_csg_op);
	fscanf(fp, "%*s %d", &sw_experts);
	fscanf(fp, "%*s %d", &sw_shadow);
	fscanf(fp, "%*s %d", &sw_term);
	fscanf(fp, "%*s %d", &sw_BFR);
	fscanf(fp, "%*s %d", &sw_paint);

	fscanf(fp, "%*s %le", &t_tsave);

	*TIME_T_ENT = t_tsave;
	eval_flag = 0;
}
com_save_env()
{
	FILE	*fp;

	if ((fp = fopen(obj_ename, "w")) == NULL) {
		fprintf(stderr, "can't create \"%s\"\n", obj_ename);
		return;
	}

	fprintf(fp, "v_r        %.18g\n", v_r);
	fprintf(fp, "v_vdegx    %.18g\n", v_vdegx);
	fprintf(fp, "v_vdegy    %.18g\n", v_vdegy);
	fprintf(fp, "dlt_v_r    %.18g\n", dlt_v_r);
	fprintf(fp, "dlt_vdeg   %.18g\n", dlt_vdeg);
	fprintf(fp, "v_rdegx    %.18g\n", v_rdegx);
	fprintf(fp, "v_rdegy    %.18g\n", v_rdegy);
	fprintf(fp, "dlt_rdeg   %.18g\n", dlt_rdeg);

	fprintf(fp, "sw_csg_op  %d\n", sw_csg_op);
	fprintf(fp, "sw_experts %d\n", sw_experts);
	fprintf(fp, "sw_shadow  %d\n", sw_shadow);
	fprintf(fp, "sw_term    %d\n", sw_term);
	fprintf(fp, "sw_BFR     %d\n", sw_BFR);
	fprintf(fp, "sw_paint   %d\n", sw_paint);

	fprintf(fp, "t_tsave    %.18g\n", t_tsave);

	fclose(fp);
}
com_get_brep()
{
	struct breps	*csg_to_brep();

	get_view(&t_view);
	get_ray(&t_ray);
	get_bgcol(&t_bgcol);
	get_bgint(&t_bgint);
	get_object(&t_object);
	breps = csg_to_brep(t_object, sw_csg_op);
	eval_flag = 1;
	return(t_object);
}
com_display()
{
	m_movz(v_r, STD_MOTION, &v_view);
	m_degx(v_vdegx, &v_view, &v_view);
	m_degy(v_vdegy, &v_view, &v_view);
	m_comp(&t_view, &v_view, &v_view);
	m_movz(0.0, STD_MOTION, &v_ray);
	m_degx(v_rdegx, &v_ray, &v_ray);
	m_degy(v_rdegy, &v_ray, &v_ray);
	m_comp(&t_ray, &v_ray, &v_ray);
	disp(&v_view, &v_ray, t_bgcol, t_bgint, sw_experts, sw_shadow, sw_term, sw_BFR, sw_paint, breps);
}
void onintr()
{
	fflush(stdout);
	fprintf(stderr, "!\n");
	longjmp(sjbuf,1);
}
