
/* csg_geometry.c	87/9/19 */

#include "dsm.h"
/* #define DEBUG */

G_f_e_cross(fac_ent, fac2_ent, xed_ent, brep_ent, brep2_ent, breps)
	int			fac_ent, fac2_ent, xed_ent, brep_ent, brep2_ent;
	struct breps		*breps;	
{
/*                                    */
/* fac x xed                          */
/*                       xed _edir    */
/*                         |/         */
/*             ------------|--------- */
/*            / (l2,m2,n2) |       /  */
/*           /     /       |      /   */
/*     +----*--------------+     /    */
/*         /             dpo5   /     */
/*        / fac            |   /      */
/*       ----------------------       */
/*                                    */
	struct brep		*brep   = breps->brep;
	struct face		*face   = breps->face;
	struct xloop		*xloop  = breps->xloop;
	struct xedge		*xedge  = breps->xedge;
	struct dpoint		*dpoint = breps->dpoint;
	struct dvect		*dvect  = breps->dvect;
	struct xedge		*tp_xed;
	register struct dpoint	*tp_dpo, *tp_dpo2, *tp_dpo3, *tp_dpo4;
	struct dpoint		tp_dpo5;
	struct dvect		*tp_dve;
	struct xedge		*tp_nxt_xed;
	struct dpoint		*tp_nxt_dpo;
	double			dabs();
	double			edirx, ediry, edirz;
	double			l1, m1, n1, l2, m2, n2;
	double			l3, m3, n3, l4, m4, n4;
	double			dx, dy, dz, ox, oy, oz;
	double			ft, fe_cos, fio;
	double			et1, et2, ee_cos, eio, tp_dbl;
	double			divio;
	double			fo_curx, fo_cury, fo_curz;
	double			fo_nxtx, fo_nxty, fo_nxtz;
	register int		cur_xlo_ent, sav_xlo_ent;
	register int		cur_xed_ent, sav_xed_ent, nxt_xed_ent;
	int			dpo_ent, dpo2_ent, dpo3_ent, dpo4_ent, dpo5_ent;
	int			ftsave, fcosign;
	int			etsave1, etsave2, eiosave, eiobound, eioexist;
	int			divbd;
	register int		ecosign;

#ifdef DEBUG
fprintf(stderr, "G_f_e_cross: fac=%d xed=%d\n", fac_ent, xed_ent);
#endif
	if (fac_ent == 0 || fac2_ent == 0 || xed_ent == 0 || brep_ent == 0 || brep2_ent == 0)
		return;

	if ((face+fac_ent)->xlotop == 0)
		return;

	tp_dpo3 = dpoint+(dpo3_ent = (xedge+xed_ent)->dp1);
	tp_dpo4 = dpoint+(dpo4_ent = (xedge+xed_ent)->dp2);
	tp_dve  = dvect+(face+fac_ent)->favect;
	edirx = tp_dpo4->x-tp_dpo3->x;
	ediry = tp_dpo4->y-tp_dpo3->y;
	edirz = tp_dpo4->z-tp_dpo3->z;
	v_sca(tp_dve->x, tp_dve->y, tp_dve->z, edirx, ediry, edirz, &fe_cos);

	if (!isnonzero(fe_cos)) /* fac // xed */
		return;

	tp_dpo = dpoint+(xedge+(xloop+(face+fac_ent)->xlotop)->xedtop)->dp1;
	v_sca(tp_dve->x, tp_dve->y, tp_dve->z, tp_dpo->x-tp_dpo3->x, tp_dpo->y-tp_dpo3->y, tp_dpo->z-tp_dpo3->z, &ft);
	ft /= fe_cos;
	tp_dpo5.x = tp_dpo3->x+edirx*ft;
	tp_dpo5.y = tp_dpo3->y+ediry*ft;
	tp_dpo5.z = tp_dpo3->z+edirz*ft;
	v_ort(tp_dve->x, tp_dve->y, tp_dve->z, (brep+brep_ent)->maxdpo+(brep+brep2_ent)->maxdpo, &l2, &m2, &n2);

	ftsave   = iswhere(ft, 0.0, 1.0);	/* -2 -1 0 1 2 */
	fcosign  = iswhere(fe_cos, 0.0, 0.0);	/* -1 0 1 */
	fio      = 0.0;		/* 0-360 0:outer 360:inner */
	eio      = 0.0;		/* 0-360 0:outer ~:boundary 360:inner */
	eiobound = 0;		/* 1: on boundary */

	cur_xlo_ent = sav_xlo_ent = (face+fac_ent)->xlotop;
	do {
		cur_xed_ent = sav_xed_ent = (xloop+cur_xlo_ent)->xedtop;
		do {
			tp_xed  = xedge+cur_xed_ent;
			tp_dpo  = dpoint+(dpo_ent  = tp_xed->dp1);
			tp_dpo2 = dpoint+(dpo2_ent = tp_xed->dp2);
			l1 = tp_dpo2->x-tp_dpo ->x;
			m1 = tp_dpo2->y-tp_dpo ->y;
			n1 = tp_dpo2->z-tp_dpo ->z;
			dx = tp_dpo ->x-tp_dpo5.x;
			dy = tp_dpo ->y-tp_dpo5.y;
			dz = tp_dpo ->z-tp_dpo5.z;

			if (isnonzero(tp_dbl = -l1*m2+l2*m1)) { /* cur_xed X dpo5-outside */
				et1 = (m2*dx-l2*dy)/tp_dbl;
				et2 = (m1*dx-l1*dy)/tp_dbl;
			}
			else if (isnonzero(tp_dbl = -m1*n2+m2*n1)) { /* cur_xed X dpo5-outside */
				et1 = (n2*dy-m2*dz)/tp_dbl;
				et2 = (n1*dy-m1*dz)/tp_dbl;
			}
			else if (isnonzero(tp_dbl = -n1*l2+n2*l1)) { /* cur_xed X dpo5-outside */
				et1 = (l2*dz-n2*dx)/tp_dbl;
				et2 = (l1*dz-n1*dx)/tp_dbl;
			}
			else { /* cur_xed // dpo5-outside */
				l3 = tp_dpo5.x-tp_dpo ->x;
				m3 = tp_dpo5.y-tp_dpo ->y;
				n3 = tp_dpo5.z-tp_dpo ->z;
				l4 = tp_dpo5.x-tp_dpo2->x;
				m4 = tp_dpo5.y-tp_dpo2->y;
				n4 = tp_dpo5.z-tp_dpo2->z;

				if (isnonzero(l3*m4-l4*m3) || isnonzero(m3*n4-m4*n3) || isnonzero(n3*l4-n4*l3)) {
					et1 = 0.5;
					et2 = 0.5;
				}
				else if (isnonzero(tp_dbl = tp_dpo2->x-tp_dpo->x)) {
					et1 = l3/tp_dbl;
					et2 = 0.0;
				}
				else if (isnonzero(tp_dbl = tp_dpo2->y-tp_dpo->y)) {
					et1 = m3/tp_dbl;
					et2 = 0.0;
				}
				else if (isnonzero(tp_dbl = tp_dpo2->z-tp_dpo->z)) {
					et1 = n3/tp_dbl;
					et2 = 0.0;
				}
				else { /*    dpo == dpo5 && dpo2 == dpo5 */
				       /* || dpo != dpo5 && dpo2 != dpo5 */
					et1 = 0.5;
					et2 = 0.5;
				}
			}

#ifdef DEBUG
fprintf(stderr, "G_f_e_cross: lmn1/2=%f %f %f %f %f %f\n", l1,m1,n1,l2,m2,n2);
#endif
			if (tp_xed->fa1 == fac_ent)
				v_vec(tp_dve->x, tp_dve->y, tp_dve->z, l1, m1, n1, &ox, &oy, &oz);
			else
				v_vec(tp_dve->x, tp_dve->y, tp_dve->z, -l1, -m1, -n1, &ox, &oy, &oz);
#ifdef DEBUG
fprintf(stderr, "G_f_e_cross: oxyz=%f %f %f\n", ox, oy, oz);
#endif
			v_sca(l2, m2, n2, ox, oy, oz, &ee_cos);

			etsave1 = iswhere(et1, 0.0, 1.0);	/* -2 -1 0 1 2 */
			etsave2 = iswhere(et2, 0.0, 1.0);	/* -2 -1 0 1 2 */
			ecosign = iswhere(ee_cos, 0.0, 0.0);	/* -1 0 1 */

#ifdef DEBUG
fprintf(stderr, "G_f_e_cross: etsave1=%d etsave2=%d ecosign=%d\n", etsave1, etsave2, ecosign);
#endif
			/*              /        */
			/*             /   dpo5  */
			/*    +-------*<-----+   */
			/*           ^  etsave2  */
			/*  etsave1 /            */
			/*         -----         */
			switch (etsave1) {
			case 0:
				switch (etsave2) {
				case -2:
					eio -= ecosign*360.0;
					break;
				case -1:
					eio -= ecosign*270.0;
					fio += fcosign*180.0;
					eiobound = 1;
					break;
				default:
					break;
				}
				break;
			case -1:
				switch (etsave2) {
				case -2:
					eio -= ecosign*180.0;
					break;
				case -1: /* dpo == dpo5 */
					/*                 nxt_dpo  */
					/*                 /        */
					/*                /  fac    */
					/*      +---*----* dpo      */
					/*         -2   -1\         */
					/*  etsave2 +dpo5+ \        */
					/*                 dpo2     */
					eio -= ecosign*135.0;
					eiobound = 1;
					if (tp_xed->fa2 == fac_ent) {
						eioexist = 0;
						nxt_xed_ent = tp_xed->link2;
						do {
							tp_nxt_xed = xedge+nxt_xed_ent;
							if (G_dpo_neq(dpo_ent, tp_nxt_xed->dp1, breps)) {
								tp_nxt_dpo = dpoint+tp_nxt_xed->dp1;
								eioexist = 1;
								break;
							}
							else if (G_dpo_neq(dpo_ent, tp_nxt_xed->dp2, breps)) {
								tp_nxt_dpo = dpoint+tp_nxt_xed->dp2;
								eioexist = 1;
								break;
							}
							if (tp_nxt_xed->fa1 == fac_ent)
								nxt_xed_ent = tp_nxt_xed->link1;
							else
								nxt_xed_ent = tp_nxt_xed->link2;
						} while (nxt_xed_ent != cur_xed_ent);
						if (eioexist) {
							v_foot(tp_dpo3->x, tp_dpo3->y, tp_dpo3->z, tp_dpo4->x, tp_dpo4->y, tp_dpo4->z, tp_dpo2->x, tp_dpo2->y, tp_dpo2->z, &fo_curx, &fo_cury, &fo_curz);
							v_foot(tp_dpo3->x, tp_dpo3->y, tp_dpo3->z, tp_dpo4->x, tp_dpo4->y, tp_dpo4->z, tp_nxt_dpo->x, tp_nxt_dpo->y, tp_nxt_dpo->z, &fo_nxtx, &fo_nxty, &fo_nxtz);
							v_deg(tp_dpo2->x, tp_dpo2->y, tp_dpo2->z, fo_curx, fo_cury, fo_curz, fo_nxtx, fo_nxty, fo_nxtz, tp_nxt_dpo->x, tp_nxt_dpo->y, tp_nxt_dpo->z, fcosign*edirx, fcosign*ediry, fcosign*edirz, &tp_dbl);
							fio += fcosign*tp_dbl;
						}
					}
					break;
				default:
					break;
				}
				break;
			case 1:
				switch (etsave2) {
				case -2:
					eio -= ecosign*180.0;
					break;
				case -1: /* dpo2 == dpo5 */
					/*                 nxt_dpo  */
					/*                 /        */
					/*                /  fac    */
					/*      +---*----* dpo2     */
					/*         -2   -1\         */
					/*  etsave2 +dpo5+ \        */
					/*                 dpo      */
					eio -= ecosign*135.0;
					eiobound = 1;
					if (tp_xed->fa1 == fac_ent) {
						eioexist = 0;
						nxt_xed_ent = tp_xed->link1;
						do {
							tp_nxt_xed = xedge+nxt_xed_ent;
							if (G_dpo_neq(dpo2_ent, tp_nxt_xed->dp1, breps)) {
								tp_nxt_dpo = dpoint+tp_nxt_xed->dp1;
								eioexist = 1;
								break;
							}
							else if (G_dpo_neq(dpo2_ent, tp_nxt_xed->dp2, breps)) {
								tp_nxt_dpo = dpoint+tp_nxt_xed->dp2;
								eioexist = 1;
								break;
							}
							if (tp_nxt_xed->fa1 == fac_ent)
								nxt_xed_ent = tp_nxt_xed->link1;
							else
								nxt_xed_ent = tp_nxt_xed->link2;
						} while (nxt_xed_ent != cur_xed_ent);
						if (eioexist) {
							v_foot(tp_dpo3->x, tp_dpo3->y, tp_dpo3->z, tp_dpo4->x, tp_dpo4->y, tp_dpo4->z, tp_dpo->x, tp_dpo->y, tp_dpo->z, &fo_curx, &fo_cury, &fo_curz);
							v_foot(tp_dpo3->x, tp_dpo3->y, tp_dpo3->z, tp_dpo4->x, tp_dpo4->y, tp_dpo4->z, tp_nxt_dpo->x, tp_nxt_dpo->y, tp_nxt_dpo->z, &fo_nxtx, &fo_nxty, &fo_nxtz);
							v_deg(tp_dpo->x, tp_dpo->y, tp_dpo->z, fo_curx, fo_cury, fo_curz, fo_nxtx, fo_nxty, fo_nxtz, tp_nxt_dpo->x, tp_nxt_dpo->y, tp_nxt_dpo->z, fcosign*edirx, fcosign*ediry, fcosign*edirz, &tp_dbl);
							fio += fcosign*tp_dbl;
						}
					}
					break;
				default:
					break;
				}
				break;
			default:
				break;
			}
			if (tp_xed->fa1 == fac_ent)
				cur_xed_ent = tp_xed->link1;
			else
				cur_xed_ent = tp_xed->link2;
		} while (cur_xed_ent != sav_xed_ent);
	} while ((cur_xlo_ent = (xloop+cur_xlo_ent)->r_link) != sav_xlo_ent);

	tp_xed = xedge+xed_ent;
	if (eiobound) {
		eiosave = 0;
		switch (ftsave) {
		case -1:
			tp_xed->bd1 = 1;
			divbd = 0;
			break;
 		case 0:
			divbd = 1;
			break;
 		case 1:
			tp_xed->bd2 = 1;
			divbd = 0;
			break;
		default:
			divbd = 0;
			break;
		}
	}
	else {
		eiosave = isabswhere(eio, 0.0, 360.0);
		divbd = 0;
	}

	switch (eiosave) {
	case -1: /* dpo5 is outside of fac */
		dpo5_ent = 0;
		divio = 0.0;
		break;
	case 0: /* dpo5 is boudary of fac */
		switch (ftsave) {
		case -2:
			dpo5_ent = 0;
			tp_xed->io1 -= fio;
			divio = 0.0;
			break;
		case -1:
			dpo5_ent = dpo3_ent;
			tp_xed->io1 -= fio;
			divio = 0.0;
			break;
		case 0:
			dpo5_ent = aloc_dpo(brep_ent, breps);
			(dpoint+dpo5_ent)->x = tp_dpo5.x;
			(dpoint+dpo5_ent)->y = tp_dpo5.y;
			(dpoint+dpo5_ent)->z = tp_dpo5.z;
			divio = fio;
			break;
		case 1:
			dpo5_ent = dpo4_ent;
			tp_xed->io2 += fio;
			divio = 0.0;
			break;
		case 2:
			dpo5_ent = 0;
			tp_xed->io2 += fio;
			divio = 0.0;
			break;
		default:
			dpo5_ent = 0;
			divio = 0.0;
			break;
		}
		break;
	case 1: /* dpo5 is inside of fac */
		switch (ftsave) {
		case -2:
			dpo5_ent = 0;
			tp_xed->io1 -= fcosign*360.0;
			divio = 0.0;
			break;
		case -1:
			dpo5_ent = dpo3_ent;
			tp_xed->io1 -= fcosign*360.0;
			divio = 0.0;
			break;
		case 0:
			dpo5_ent = aloc_dpo(brep_ent, breps);
			(dpoint+dpo5_ent)->x = tp_dpo5.x;
			(dpoint+dpo5_ent)->y = tp_dpo5.y;
			(dpoint+dpo5_ent)->z = tp_dpo5.z;
			divio = fcosign*360.0;
			break;
		case 1:
			dpo5_ent = dpo4_ent;
			tp_xed->io2 += fcosign*360.0;
			divio = 0.0;
			break;
		case 2:
			dpo5_ent = 0;
			tp_xed->io2 += fcosign*360.0;
			divio = 0.0;
			break;
		default:
			dpo5_ent = 0;
			divio = 0.0;
			break;
		}
		break;
	default:
		dpo5_ent = 0;
		divio = 0.0;
		break;
	}
#ifdef DEBUG
fprintf(stderr, "G_f_e_cross: fac_ent=%d fac2_ent=%d xed_ent=%d dpo5_ent=%d eiosave=%d ftsave=%d divio=%g\n", fac_ent, fac2_ent, xed_ent, dpo5_ent, eiosave, ftsave, divio);
#endif
	if (dpo5_ent) {
		G_xed_divide(fac2_ent, xed_ent, dpo5_ent, brep2_ent, divio, divbd, breps);
		add_pxx(fac_ent, xed_ent, dpo5_ent, breps);
	}
#ifdef DEBUG
fprintf(stderr, "G_f_e_cross: -----: xed->io1,io2=%g,%g\n", tp_xed->io1,tp_xed->io2);
#endif
}
G_e_e_cross(fac_ent, fac2_ent, xed_ent, xed2_ent, brep_ent, brep2_ent, breps)
	int			fac_ent, fac2_ent, xed_ent, xed2_ent;
	int			brep_ent, brep2_ent;
	struct breps		*breps;
{
/*            		    */
/* xed x xed2 		    */
/*        xed     xed2      */
/*        dpo     dpo3      */
/*          \     /         */
/*        t1 \   / t2       */
/*            \ /           */
/*             X dpo5       */
/*            / \           */
/*      1-t2 /   \ 1-t1     */
/*          V     V         */
/*        dpo4    dpo2      */
/*            		    */
	struct face		*face   = breps->face;
	struct xedge		*xedge  = breps->xedge;
	struct dpoint		*dpoint = breps->dpoint;
	struct dpoint		*tp_dpo, *tp_dpo2, *tp_dpo3, *tp_dpo4, *tp_dpo5;
	register struct xedge	*tp_xed, *tp_xed2;
	double			l1, m1, n1, l2, m2, n2;
	double			dx, dy, dz;
	double			t1, t2, tp_dbl;
	int			dpo_ent, dpo2_ent, dpo3_ent, dpo4_ent, dpo5_ent;
	register int		tsave1, tsave2;

#ifdef DEBUG
fprintf(stderr, "G_e_e_cross: xed=%d xed2=%d\n", xed_ent, xed2_ent);
#endif
	if (fac_ent == 0 || fac2_ent == 0 || xed_ent == 0 || xed2_ent == 0 || brep_ent == 0 || brep2_ent == 0)
		return;

	if ((face+fac_ent)->xlotop == 0)
		return;

	tp_xed  = xedge+xed_ent;
	tp_xed2 = xedge+xed2_ent;
	tp_dpo  = dpoint+(dpo_ent  = tp_xed ->dp1);
	tp_dpo2 = dpoint+(dpo2_ent = tp_xed ->dp2);
	tp_dpo3 = dpoint+(dpo3_ent = tp_xed2->dp1);
	tp_dpo4 = dpoint+(dpo4_ent = tp_xed2->dp2);
	l1 = tp_dpo2->x-tp_dpo->x;
	m1 = tp_dpo2->y-tp_dpo->y;
	n1 = tp_dpo2->z-tp_dpo->z;
	l2 = tp_dpo4->x-tp_dpo3->x;
	m2 = tp_dpo4->y-tp_dpo3->y;
	n2 = tp_dpo4->z-tp_dpo3->z;
	dx = tp_dpo ->x-tp_dpo3->x;
	dy = tp_dpo ->y-tp_dpo3->y;
	dz = tp_dpo ->z-tp_dpo3->z;

	if (isnonzero((dx*m1*n2+dy*n1*l2+dz*l1*m2)-(dx*n1*m2+dy*l1*n2+dz*m1*l2)))
		return;

	if (isnonzero(tp_dbl = -l1*m2+l2*m1)) { /* xed X xed2 */
		t1 = (m2*dx-l2*dy)/tp_dbl;
		t2 = (m1*dx-l1*dy)/tp_dbl;
	}
	else if (isnonzero(tp_dbl = -m1*n2+m2*n1)) { /* xed X xed2 */
		t1 = (n2*dy-m2*dz)/tp_dbl;
		t2 = (n1*dy-m1*dz)/tp_dbl;
	}
	else if (isnonzero(tp_dbl = -n1*l2+n2*l1)) { /* xed X xed2 */
		t1 = (l2*dz-n2*dx)/tp_dbl;
		t2 = (l1*dz-n1*dx)/tp_dbl;
	}
	else { /* xed // xed2 */
		G_xed_divide(fac_ent,  xed_ent,  dpo3_ent, brep_ent,  0.0, 1, breps);
		G_xed_divide(fac_ent,  xed_ent,  dpo4_ent, brep_ent,  0.0, 1, breps);
		G_xed_divide(fac2_ent, xed2_ent, dpo_ent,  brep2_ent, 0.0, 1, breps);
		G_xed_divide(fac2_ent, xed2_ent, dpo2_ent, brep2_ent, 0.0, 1, breps);
		return;
	}

	tsave1  = iswhere(t1, 0.0, 1.0);	/* -2 -1 0 1 2 */
	tsave2  = iswhere(t2, 0.0, 1.0);	/* -2 -1 0 1 2 */

	if (tsave1 == 0 && tsave2 == 0) {
		tp_dpo5 = dpoint+(dpo5_ent = aloc_dpo(brep_ent, breps));
		tp_dpo5->x = tp_dpo->x+l1*t1;
		tp_dpo5->y = tp_dpo->y+m1*t1;
		tp_dpo5->z = tp_dpo->z+n1*t1;
	}
	else if (tsave1 == 0 && tsave2 == -1)
		dpo5_ent = dpo3_ent;
	else if (tsave1 == 0 && tsave2 == 1)
		dpo5_ent = dpo4_ent;
	else if (tsave1 == -1 && tsave2 == 0)
		dpo5_ent = dpo_ent;
	else if (tsave1 == 1 && tsave2 == 0)
		dpo5_ent = dpo2_ent;
	else
		return;

	G_xed_divide(fac_ent,  xed_ent,  dpo5_ent, brep_ent,  0.0, 1, breps);
	G_xed_divide(fac2_ent, xed2_ent, dpo5_ent, brep2_ent, 0.0, 1, breps);
}
G_xed_divide(fac_ent, xed_ent, dpo_ent, brep_ent, io, bd, breps)
	int			fac_ent, xed_ent, dpo_ent, brep_ent;
	double			io;
	int			bd;
	struct breps		*breps;
{
/*                         			   */
/* xed -> xed-:-xed2 where			   */
/*         \   /                     \   /         */
/*          \ /                       \ /          */
/*    fa2    1   fa1     ->     fa2    2   fa1     */
/*        /~~1 (fac_ent)               1 (fac_ent) */
/*    dpo/  / \                       / \          */
/*         /   \                     /   \         */
/*                                                 */
/*         \   /                     \   /         */
/*          \ /                       \ /          */
/*    fa2    1   fa1     ->     fa2    1   fa1     */
/* (fac_ent) 1               (fac_ent) 2           */
/*          / \                       / \          */
/*         /   \                     /   \         */
/*                         			   */
	struct xedge		*xedge  = breps->xedge;
	struct dpoint		*dpoint = breps->dpoint;
	struct pxx		*pxx    = breps->pxx;
	struct xedge		*tp_xed, *tp_xed2;
	register struct xedge	*tp_cur_xed;
	register struct dpoint	*tp_dpo, *tp_dpo2, *tp_dpo3;
	struct pxx		*tp_pxx;
	double			l1, m1, n1, l2, m2, n2;
	double			t, tp_dbl;
	register int		fac2_ent;
	register int		xed2_ent;
	register int		dve_ent, dve2_ent;
	register int		pxx_ent;

	if (fac_ent == 0 || xed_ent == 0 || dpo_ent == 0 || brep_ent == 0)
		return;

	tp_xed  = xedge+xed_ent;
	tp_dpo  = dpoint+tp_xed->dp1;
	tp_dpo2 = dpoint+tp_xed->dp2;
	tp_dpo3 = dpoint+dpo_ent;

	G_dpo_neq(dpo_ent, tp_xed->dp1, breps);
	G_dpo_neq(dpo_ent, tp_xed->dp2, breps);

	l1 = tp_dpo3->x-tp_dpo->x;
	m1 = tp_dpo3->y-tp_dpo->y;
	n1 = tp_dpo3->z-tp_dpo->z;
	l2 = tp_dpo3->x-tp_dpo2->x;
	m2 = tp_dpo3->y-tp_dpo2->y;
	n2 = tp_dpo3->z-tp_dpo2->z;

	if (isnonzero(l1*m2-l2*m1) || isnonzero(m1*n2-m2*n1) || isnonzero(n1*l2-n2*l1))
		return;

	if (isnonzero(tp_dbl = tp_dpo2->x-tp_dpo->x))
		t = l1/tp_dbl;
	else if (isnonzero(tp_dbl = tp_dpo2->y-tp_dpo->y))
		t = m1/tp_dbl;
	else if (isnonzero(tp_dbl = tp_dpo2->z-tp_dpo->z))
		t = n1/tp_dbl;
	else /* tp_dpo == tp_dpo2 */
		return;

	if (iswhere(t, 0.0, 1.0))
		return;

	tp_xed2 = xedge+(xed2_ent = aloc_xed(brep_ent, breps));
	tp_xed2->fa1    = tp_xed->fa1;
	tp_xed2->fa2    = tp_xed->fa2;
	tp_xed2->a_link = xed_ent;

	if (tp_xed->fa1 == fac_ent) {
		fac2_ent = tp_xed->fa2;
		if ((xedge+tp_xed->link1)->fa1 == fac_ent)
			dve_ent = (xedge+tp_xed->link1)->dv1;
		else
			dve_ent = (xedge+tp_xed->link1)->dv2;
		if ((xedge+tp_xed->link2)->fa1 == fac2_ent)
			dve2_ent = (xedge+tp_xed->link2)->dv1;
		else
			dve2_ent = (xedge+tp_xed->link2)->dv2;

		tp_xed2->dv1 = G_dve_compl(tp_xed->dp1, tp_xed->dp2, dpo_ent, tp_xed->dv1, dve_ent, brep_ent, breps);
		iref_dve(tp_xed2->dv1, breps);
		tp_xed2->dv2 = tp_xed->dv2;
		iref_dve(tp_xed2->dv2, breps);

		if (G_dve_neq(tp_xed->dv1, dve2_ent, breps) || G_dve_neq(tp_xed->dv2, dve_ent, breps)) {
			dref_dve(tp_xed->dv2, brep_ent, breps);
			tp_xed->dv2 = G_dve_compl(tp_xed->dp2, tp_xed->dp1, dpo_ent, tp_xed->dv2, dve2_ent, brep_ent, breps);
			iref_dve(tp_xed->dv2, breps);
		}
		else {
			dref_dve(tp_xed->dv2, brep_ent, breps);
			tp_xed->dv2 = tp_xed2->dv1;
			iref_dve(tp_xed->dv2, breps);
		}

		tp_cur_xed = xedge+xed_ent;
		for (;;) {
			if (tp_cur_xed->fa1 == fac2_ent) {
				if (tp_cur_xed->link1 == xed_ent) {
					tp_cur_xed->link1 = xed2_ent;
					break;
				}
				else
					tp_cur_xed = xedge+tp_cur_xed->link1;
			}
			else {
				if (tp_cur_xed->link2 == xed_ent) {
					tp_cur_xed->link2 = xed2_ent;
					break;
				}
				else
					tp_cur_xed = xedge+tp_cur_xed->link2;
			}
		}
		tp_xed2->link1 = tp_xed->link1;
		tp_xed2->link2 = xed_ent;
		tp_xed ->link1 = xed2_ent;

		tp_xed2->dp2 = tp_xed->dp2;
		tp_xed2->dp1 = dpo_ent;
		iref_dpo(dpo_ent, breps);
		tp_xed ->dp2 = dpo_ent;
		iref_dpo(dpo_ent, breps);

		tp_xed2->io1 = tp_xed->io1;
		tp_xed2->io2 = tp_xed->io2;
		tp_xed ->io2 += io;
		tp_xed2->bd1 = tp_xed->bd2 = bd;

		tp_dpo = dpoint+tp_xed2->dp2;
		while(tp_dpo->a_link)
			tp_dpo = dpoint+tp_dpo->a_link;
		pxx_ent = tp_dpo->pxxtop;
		while (pxx_ent) {
			tp_pxx = pxx+pxx_ent;
			if (tp_pxx->xed == xed_ent)
				tp_pxx->xed = xed2_ent;
			pxx_ent = tp_pxx->r_link;
		}
	}
	else {
		fac2_ent = tp_xed->fa1;
		if ((xedge+tp_xed->link1)->fa1 == fac2_ent)
			dve_ent = (xedge+tp_xed->link1)->dv1;
		else
			dve_ent = (xedge+tp_xed->link1)->dv2;
		if ((xedge+tp_xed->link2)->fa1 == fac_ent)
			dve2_ent = (xedge+tp_xed->link2)->dv1;
		else
			dve2_ent = (xedge+tp_xed->link2)->dv2;

		tp_xed2->dv2 = G_dve_compl(tp_xed->dp2, tp_xed->dp1, dpo_ent, tp_xed->dv2, dve2_ent, brep_ent, breps);
		iref_dve(tp_xed2->dv2, breps);
		tp_xed2->dv1 = tp_xed->dv1;
		iref_dve(tp_xed2->dv1, breps);

		if (G_dve_neq(tp_xed->dv2, dve_ent, breps) || G_dve_neq(tp_xed->dv1, dve2_ent, breps)) {
			dref_dve(tp_xed->dv1, brep_ent, breps);
			tp_xed->dv1 = G_dve_compl(tp_xed->dp1, tp_xed->dp2, dpo_ent, tp_xed->dv1, dve_ent, brep_ent, breps);
			iref_dve(tp_xed->dv1, breps);
		}
		else {
			dref_dve(tp_xed->dv1, brep_ent, breps);
			tp_xed->dv1 = tp_xed2->dv2;
			iref_dve(tp_xed->dv1, breps);
		}

		tp_cur_xed = xedge+xed_ent;
		for (;;) {
			if (tp_cur_xed->fa2 == fac2_ent) {
				if (tp_cur_xed->link2 == xed_ent) {
					tp_cur_xed->link2 = xed2_ent;
					break;
				}
				else
					tp_cur_xed = xedge+tp_cur_xed->link2;
			}
			else {
				if (tp_cur_xed->link1 == xed_ent) {
					tp_cur_xed->link1 = xed2_ent;
					break;
				}
				else
					tp_cur_xed = xedge+tp_cur_xed->link1;
			}
		}
		tp_xed2->link2 = tp_xed->link2;
		tp_xed2->link1 = xed_ent;
		tp_xed ->link2 = xed2_ent;

		tp_xed2->dp1 = tp_xed->dp1;
		tp_xed2->dp2 = dpo_ent;
		iref_dpo(dpo_ent, breps);
		tp_xed ->dp1 = dpo_ent;
		iref_dpo(dpo_ent, breps);

		tp_xed2->io1 = tp_xed->io1;
		tp_xed2->io2 = tp_xed->io2;
		tp_xed ->io1 -= io;
		tp_xed2->bd2 = tp_xed->bd1 = bd;

		tp_dpo = dpoint+tp_xed2->dp1;
		while(tp_dpo->a_link)
			tp_dpo = dpoint+tp_dpo->a_link;
		pxx_ent = tp_dpo->pxxtop;
		while (pxx_ent) {
			tp_pxx = pxx+pxx_ent;
			if (tp_pxx->xed == xed_ent)
				tp_pxx->xed = xed2_ent;
			pxx_ent = tp_pxx->r_link;
		}
	}
}
G_dve_compl(dpo_ent, dpo2_ent, dpo3_ent, dve_ent, dve2_ent, brep_ent, breps)
	int			dpo_ent, dpo2_ent, dpo3_ent;
	int			dve_ent, dve2_ent, brep_ent;
	struct breps		*breps;
{
/* return dve3 where dpo-:-dpo3-:-dpo2 == dve-:-dve3-:-dve2 */
	struct dpoint		*dpoint = breps->dpoint;
	struct dvect		*dvect  = breps->dvect;
	register struct dpoint	*tp_dpo, *tp_dpo2, *tp_dpo3;
	struct dvect		*tp_dve, *tp_dve2, *tp_dve3;
	double			l1, m1, n1, l2, m2, n2;
	double			t, tp_dbl;
	register int		dve3_ent;

	if (dpo_ent == 0 || dpo2_ent == 0 || dpo3_ent == 0 || dve_ent == 0 || dve2_ent == 0 || brep_ent == 0)
		return(0);

	tp_dpo  = dpoint+dpo_ent;
	tp_dpo2 = dpoint+dpo2_ent;
	tp_dpo3 = dpoint+dpo3_ent;
	tp_dve  = dvect+dve_ent;
	tp_dve2 = dvect+dve2_ent;
	l1 = tp_dpo3->x-tp_dpo->x;
	m1 = tp_dpo3->y-tp_dpo->y;
	n1 = tp_dpo3->z-tp_dpo->z;
	l2 = tp_dpo3->x-tp_dpo2->x;
	m2 = tp_dpo3->y-tp_dpo2->y;
	n2 = tp_dpo3->z-tp_dpo2->z;

	if (isnonzero(l1*m2-l2*m1) || isnonzero(m1*n2-m2*n1) || isnonzero(n1*l2-n2*l1))
		return(0);

	if (isnonzero(tp_dbl = tp_dpo2->x-tp_dpo->x))
		t = l1/tp_dbl;
	else if (isnonzero(tp_dbl = tp_dpo2->y-tp_dpo->y))
		t = m1/tp_dbl;
	else if (isnonzero(tp_dbl = tp_dpo2->z-tp_dpo->z))
		t = n1/tp_dbl;
	else /* tp_dpo == tp_dpo2 */
		t = 0.5;

	switch (iswhere(t, 0.0, 1.0)) {
	case -1:
		return(dve_ent);
		break;
	case 1:
		return(dve2_ent);
		break;
	case 0:
		if (G_dve_neq(dve_ent, dve2_ent, breps)) {
			tp_dve3 = dvect+(dve3_ent = aloc_dve(brep_ent, breps));
			tp_dve3->x = tp_dve->x+(tp_dve2->x-tp_dve->x)*t;
			tp_dve3->y = tp_dve->y+(tp_dve2->y-tp_dve->y)*t;
			tp_dve3->z = tp_dve->z+(tp_dve2->z-tp_dve->z)*t;
			v_norm(tp_dve3->x, tp_dve3->y, tp_dve3->z, &tp_dve3->x, &tp_dve3->y, &tp_dve3->z);
			return(dve3_ent);
		}
		else
			return(dve_ent);
		break;
	default:
		return(0);
		break;
	}
}
G_f_f_newxed(op, fac_ent, fac2_ent, brep_ent, breps)
	int			op, fac_ent, fac2_ent, brep_ent;
	struct breps		*breps;
{
#define XP_MAX			100
	struct face		*face   = breps->face;
	struct xloop		*xloop  = breps->xloop;
	struct xedge		*xedge  = breps->xedge;
	struct dpoint		*dpoint = breps->dpoint;
	struct dvect		*dvect  = breps->dvect;
	struct pxx		*pxx    = breps->pxx;
	register struct xedge	*tp_xed, *tp_xed2;
	register struct dpoint	*tp_dpo, *tp_dpo2;
	struct dpoint		*tp_dpo3, *tp_dpo4;
	struct dvect		*tp_dve, *tp_dve2;
	struct pxx		*tp_pxx;
	struct xp { double t; int io, dpo; } xp[XP_MAX+1];
	double			dabs();
	double			xdirx, xdiry, xdirz;
	double			ox, oy, oz;
	double			cur_fe_cos, prv_fe_cos, nxt_fe_cos;
	double			tp_dbl;
	register int		lst_xp_ent;
	int			cur_xlo_ent, sav_xlo_ent;
	int			cur_xed_ent, sav_xed_ent;
	int			nxt_xed_ent, nyt_xed_ent;
	int			new_xed_ent, new_xed2_ent;
	register int		dpo_ent, dpo2_ent;
	int			dpo3_ent, dpo4_ent;
	int			dve_ent, dve2_ent;
	register int		pxx_ent;
	int			cosign, brkstat, tp_int;
	register int		i, j;

	if (fac_ent == 0 || fac2_ent == 0)
		return;

	if ((face+fac_ent)->xlotop == 0 || (face+fac2_ent)->xlotop == 0)
		return;

	if (G_f_f_phase(fac_ent, fac2_ent, breps) != 1)
		return;

	tp_dve  = dvect+(dve_ent  = (face+fac_ent )->favect);
	tp_dve2 = dvect+(dve2_ent = (face+fac2_ent)->favect);

	lst_xp_ent = 0;

/* fac2 X edges of fac */
	cur_xlo_ent = sav_xlo_ent = (face+fac_ent)->xlotop;
	do {
		tp_xed = xedge+(xloop+cur_xlo_ent)->xedtop;
		if (tp_xed->fa1 == fac_ent) {
			tp_dpo  = dpoint+tp_xed->dp1;
			tp_dpo2 = dpoint+tp_xed->dp2;
			tp_xed  = xedge+(cur_xed_ent = sav_xed_ent = tp_xed->link1);
		}
		else {
			tp_dpo  = dpoint+tp_xed->dp2;
			tp_dpo2 = dpoint+tp_xed->dp1;
			tp_xed  = xedge+(cur_xed_ent = sav_xed_ent = tp_xed->link2);
		}
		v_sca(tp_dve2->x, tp_dve2->y, tp_dve2->z, tp_dpo2->x-tp_dpo->x, tp_dpo2->y-tp_dpo->y, tp_dpo2->z-tp_dpo->z, &prv_fe_cos);
		if (tp_xed->fa1 == fac_ent) {
			tp_dpo  = dpoint+(dpo_ent  = tp_xed->dp1);
			tp_dpo2 = dpoint+(dpo2_ent = tp_xed->dp2);
			nxt_xed_ent = tp_xed->link1;
		}
		else {
			tp_dpo  = dpoint+(dpo_ent  = tp_xed->dp2);
			tp_dpo2 = dpoint+(dpo2_ent = tp_xed->dp1);
			nxt_xed_ent = tp_xed->link2;
		}
		v_sca(tp_dve2->x, tp_dve2->y, tp_dve2->z, tp_dpo2->x-tp_dpo->x, tp_dpo2->y-tp_dpo->y, tp_dpo2->z-tp_dpo->z, &cur_fe_cos);
		do {
			tp_xed = xedge+nxt_xed_ent;
			if (tp_xed->fa1 == fac_ent) {
				tp_dpo3 = dpoint+(dpo3_ent = tp_xed->dp1);
				tp_dpo4 = dpoint+(dpo4_ent = tp_xed->dp2);
				nyt_xed_ent = tp_xed->link1;
			}
			else {
				tp_dpo3 = dpoint+(dpo3_ent = tp_xed->dp2);
				tp_dpo4 = dpoint+(dpo4_ent = tp_xed->dp1);
				nyt_xed_ent = tp_xed->link2;
			}
			v_sca(tp_dve2->x, tp_dve2->y, tp_dve2->z, tp_dpo4->x-tp_dpo3->x, tp_dpo4->y-tp_dpo3->y, tp_dpo4->z-tp_dpo3->z, &nxt_fe_cos);

			while (tp_dpo->a_link)
				tp_dpo = dpoint+tp_dpo->a_link;
			pxx_ent = tp_dpo->pxxtop;
			while (pxx_ent) {
				tp_pxx = pxx+pxx_ent;
				tp_xed = xedge+tp_pxx->xed;
				if (tp_pxx->fac == fac2_ent && (tp_xed->fa1 == fac_ent || tp_xed->fa2 == fac_ent)) {
					if (lst_xp_ent == 0) {
						v_vec(tp_dve->x, tp_dve->y, tp_dve->z, tp_dve2->x, tp_dve2->y, tp_dve2->z, &xdirx, &xdiry, &xdirz);
						ox = tp_dpo->x;
						oy = tp_dpo->y;
						oz = tp_dpo->z;
					}
					if (++lst_xp_ent > XP_MAX) {
						fprintf(stderr, "G_f_f_newxed: current XP_MAX is %d\n", XP_MAX);
						exit(1);
					}
					if (isnonzero(xdirx))
						xp[lst_xp_ent].t = (tp_dpo->x-ox)/xdirx;
					else if (isnonzero(xdiry))
						xp[lst_xp_ent].t = (tp_dpo->y-oy)/xdiry;
					else if (isnonzero(xdirz))
						xp[lst_xp_ent].t = (tp_dpo->z-oz)/xdirz;
					else
						xp[lst_xp_ent].t = 0.0;
					if (op == C_UN) {
						if ((cosign = iswhere(cur_fe_cos, 0.0, 0.0)) >= 0)
							xp[lst_xp_ent].io = cosign;
						else if (isnonzero(prv_fe_cos))
							xp[lst_xp_ent].io = -1;
						else if ((tp_xed->fa1 == fac_ent && (tp_xed->bd1 || isabswhere(tp_xed->io1, 0.0, 360.0) == 0)) || (tp_xed->fa2 == fac_ent && (tp_xed->bd2 || isabswhere(tp_xed->io2, 0.0, 360.0) == 0)))
							xp[lst_xp_ent].io = 1;
						else
							xp[lst_xp_ent].io = 0;
					}
					else if (op == C_INT) {
						if ((tp_xed->fa1 == fac_ent && (tp_xed->bd1 || isabswhere(tp_xed->io1, 0.0, 360.0) == 0)) || (tp_xed->fa2 == fac_ent && (tp_xed->bd2 || isabswhere(tp_xed->io2, 0.0, 360.0) == 0)))
							xp[lst_xp_ent].io = 0;
						else if ((cosign = iswhere(cur_fe_cos, 0.0, 0.0)) >= 0)
							xp[lst_xp_ent].io = -cosign;
						else if (isnonzero(prv_fe_cos))
							xp[lst_xp_ent].io = 1;
						else
							xp[lst_xp_ent].io = 0;
					}
					else if (op == C_DIF) {
						if ((tp_xed->fa1 == fac_ent && (tp_xed->bd1 || isabswhere(tp_xed->io1, 0.0, 360.0) == 0)) || (tp_xed->fa2 == fac_ent && (tp_xed->bd2 || isabswhere(tp_xed->io2, 0.0, 360.0) == 0)))
							xp[lst_xp_ent].io = 0;
						else if ((cosign = iswhere(cur_fe_cos, 0.0, 0.0)) >= 0)
							xp[lst_xp_ent].io = cosign;
						/* else if (isnonzero(prv_fe_cos))
							xp[lst_xp_ent].io = -1;
						else
							xp[lst_xp_ent].io = 0;
						*/
						else
							xp[lst_xp_ent].io = -1;
					}
					xp[lst_xp_ent].dpo = dpo_ent;
				}
				pxx_ent = tp_pxx->r_link;
			}

			while (tp_dpo2->a_link)
				tp_dpo2 = dpoint+tp_dpo2->a_link;
			pxx_ent = tp_dpo2->pxxtop;
			while (pxx_ent) {
				tp_pxx = pxx+pxx_ent;
				tp_xed = xedge+tp_pxx->xed;
				if (tp_pxx->fac == fac2_ent && (tp_xed->fa1 == fac_ent || tp_xed->fa2 == fac_ent)) {
					if (lst_xp_ent == 0) {
						v_vec(tp_dve->x, tp_dve->y, tp_dve->z, tp_dve2->x, tp_dve2->y, tp_dve2->z, &xdirx, &xdiry, &xdirz);
						ox = tp_dpo2->x;
						oy = tp_dpo2->y;
						oz = tp_dpo2->z;
					}
					if (++lst_xp_ent > XP_MAX) {
						fprintf(stderr, "G_f_f_newxed: current XP_MAX is %d\n", XP_MAX);
						exit(1);
					}
					if (isnonzero(xdirx))
						xp[lst_xp_ent].t = (tp_dpo2->x-ox)/xdirx;
					else if (isnonzero(xdiry))
						xp[lst_xp_ent].t = (tp_dpo2->y-oy)/xdiry;
					else if (isnonzero(xdirz))
						xp[lst_xp_ent].t = (tp_dpo2->z-oz)/xdirz;
					else
						xp[lst_xp_ent].t = 0.0;
					if (op == C_UN) {
						if ((cosign = iswhere(cur_fe_cos, 0.0, 0.0)) <= 0)
							xp[lst_xp_ent].io = cosign;
						else if (isnonzero(nxt_fe_cos))
							xp[lst_xp_ent].io = 1;
						else if ((tp_xed->fa1 == fac_ent && (tp_xed->bd2 || isabswhere(tp_xed->io2, 0.0, 360.0) == 0)) || (tp_xed->fa2 == fac_ent && (tp_xed->bd1 || isabswhere(tp_xed->io1, 0.0, 360.0) == 0)))
							xp[lst_xp_ent].io = -1;
						else
							xp[lst_xp_ent].io = 0;
					}
					else if (op == C_INT) {
						if ((tp_xed->fa1 == fac_ent && (tp_xed->bd2 || isabswhere(tp_xed->io2, 0.0, 360.0) == 0)) || (tp_xed->fa2 == fac_ent && (tp_xed->bd1 || isabswhere(tp_xed->io1, 0.0, 360.0) == 0)))
							xp[lst_xp_ent].io = 0;
						else if ((cosign = iswhere(cur_fe_cos, 0.0, 0.0)) <= 0)
							xp[lst_xp_ent].io = -cosign;
						else if (isnonzero(nxt_fe_cos))
							xp[lst_xp_ent].io = -1;
						else
							xp[lst_xp_ent].io = 0;
					}
					else if (op == C_DIF) {
						if ((tp_xed->fa1 == fac_ent && (tp_xed->bd2 || isabswhere(tp_xed->io2, 0.0, 360.0) == 0)) || (tp_xed->fa2 == fac_ent && (tp_xed->bd1 || isabswhere(tp_xed->io1, 0.0, 360.0) == 0)))
							xp[lst_xp_ent].io = 0;
						else if ((cosign = iswhere(cur_fe_cos, 0.0, 0.0)) <= 0)
							xp[lst_xp_ent].io = cosign;
						/* else if (isnonzero(nxt_fe_cos))
							xp[lst_xp_ent].io = 1;
						else
							xp[lst_xp_ent].io = 0;
						*/
						else
							xp[lst_xp_ent].io = 1;
					}
					xp[lst_xp_ent].dpo = dpo2_ent;
				}
				pxx_ent = tp_pxx->r_link;
			}

			tp_dpo      = tp_dpo3;
			tp_dpo2     = tp_dpo4;
			dpo_ent     = dpo3_ent;
			dpo2_ent    = dpo4_ent;
			prv_fe_cos  = cur_fe_cos;
			cur_fe_cos  = nxt_fe_cos;
			cur_xed_ent = nxt_xed_ent;
			nxt_xed_ent = nyt_xed_ent;
		} while (cur_xed_ent != sav_xed_ent);
	} while ((cur_xlo_ent = (xloop+cur_xlo_ent)->r_link) != sav_xlo_ent);

/* fac X edges of fac2 */
	cur_xlo_ent = sav_xlo_ent = (face+fac2_ent)->xlotop;
	do {
		tp_xed = xedge+(xloop+cur_xlo_ent)->xedtop;
		if (tp_xed->fa1 == fac2_ent) {
			tp_dpo  = dpoint+tp_xed->dp1;
			tp_dpo2 = dpoint+tp_xed->dp2;
			tp_xed  = xedge+(cur_xed_ent = sav_xed_ent = tp_xed->link1);
		}
		else {
			tp_dpo  = dpoint+tp_xed->dp2;
			tp_dpo2 = dpoint+tp_xed->dp1;
			tp_xed  = xedge+(cur_xed_ent = sav_xed_ent = tp_xed->link2);
		}
		v_sca(tp_dve->x, tp_dve->y, tp_dve->z, tp_dpo2->x-tp_dpo->x, tp_dpo2->y-tp_dpo->y, tp_dpo2->z-tp_dpo->z, &prv_fe_cos);
		if (tp_xed->fa1 == fac2_ent) {
			tp_dpo  = dpoint+(dpo_ent  = tp_xed->dp1);
			tp_dpo2 = dpoint+(dpo2_ent = tp_xed->dp2);
			nxt_xed_ent = tp_xed->link1;
		}
		else {
			tp_dpo  = dpoint+(dpo_ent  = tp_xed->dp2);
			tp_dpo2 = dpoint+(dpo2_ent = tp_xed->dp1);
			nxt_xed_ent = tp_xed->link2;
		}
		v_sca(tp_dve->x, tp_dve->y, tp_dve->z, tp_dpo2->x-tp_dpo->x, tp_dpo2->y-tp_dpo->y, tp_dpo2->z-tp_dpo->z, &cur_fe_cos);
		do {
			tp_xed = xedge+nxt_xed_ent;
			if (tp_xed->fa1 == fac2_ent) {
				tp_dpo3 = dpoint+(dpo3_ent = tp_xed->dp1);
				tp_dpo4 = dpoint+(dpo4_ent = tp_xed->dp2);
				nyt_xed_ent = tp_xed->link1;
			}
			else {
				tp_dpo3 = dpoint+(dpo3_ent = tp_xed->dp2);
				tp_dpo4 = dpoint+(dpo4_ent = tp_xed->dp1);
				nyt_xed_ent = tp_xed->link2;
			}
			v_sca(tp_dve->x, tp_dve->y, tp_dve->z, tp_dpo4->x-tp_dpo3->x, tp_dpo4->y-tp_dpo3->y, tp_dpo4->z-tp_dpo3->z, &nxt_fe_cos);

			while (tp_dpo->a_link)
				tp_dpo = dpoint+tp_dpo->a_link;
			pxx_ent = tp_dpo->pxxtop;
			while (pxx_ent) {
				tp_pxx = pxx+pxx_ent;
				tp_xed = xedge+tp_pxx->xed;
				if (tp_pxx->fac == fac_ent && (tp_xed->fa1 == fac2_ent || tp_xed->fa2 == fac2_ent)) {
					if (lst_xp_ent == 0) {
						v_vec(tp_dve->x, tp_dve->y, tp_dve->z, tp_dve2->x, tp_dve2->y, tp_dve2->z, &xdirx, &xdiry, &xdirz);
						ox = tp_dpo->x;
						oy = tp_dpo->y;
						oz = tp_dpo->z;
					}
					if (++lst_xp_ent > XP_MAX) {
						fprintf(stderr, "G_f_f_newxed: current XP_MAX is %d\n", XP_MAX);
						exit(1);
					}
					if (isnonzero(xdirx))
						xp[lst_xp_ent].t = (tp_dpo->x-ox)/xdirx;
					else if (isnonzero(xdiry))
						xp[lst_xp_ent].t = (tp_dpo->y-oy)/xdiry;
					else if (isnonzero(xdirz))
						xp[lst_xp_ent].t = (tp_dpo->z-oz)/xdirz;
					else
						xp[lst_xp_ent].t = 0.0;
					if (op == C_UN) {
						if ((cosign = iswhere(cur_fe_cos, 0.0, 0.0)) >= 0)
							xp[lst_xp_ent].io = -cosign;
						else if (isnonzero(prv_fe_cos))
							xp[lst_xp_ent].io = 1;
						else if ((tp_xed->fa1 == fac2_ent && (tp_xed->bd1 || isabswhere(tp_xed->io1, 0.0, 360.0) == 0)) || (tp_xed->fa2 == fac2_ent && (tp_xed->bd2 || isabswhere(tp_xed->io2, 0.0, 360.0) == 0)))
							xp[lst_xp_ent].io = -1;
						else
							xp[lst_xp_ent].io = 0;
					}
					else if (op == C_INT) {
						if ((tp_xed->fa1 == fac2_ent && (tp_xed->bd1 || isabswhere(tp_xed->io1, 0.0, 360.0) == 0)) || (tp_xed->fa2 == fac2_ent && (tp_xed->bd2 || isabswhere(tp_xed->io2, 0.0, 360.0) == 0)))
							xp[lst_xp_ent].io = 0;
						else if ((cosign = iswhere(cur_fe_cos, 0.0, 0.0)) >= 0)
							xp[lst_xp_ent].io = cosign;
						else if (isnonzero(prv_fe_cos))
							xp[lst_xp_ent].io = -1;
						else
							xp[lst_xp_ent].io = 0;
					}
					else if (op == C_DIF) {
						if ((tp_xed->fa1 == fac2_ent && (tp_xed->bd1 || isabswhere(tp_xed->io1, 0.0, 360.0) == 0)) || (tp_xed->fa2 == fac2_ent && (tp_xed->bd2 || isabswhere(tp_xed->io2, 0.0, 360.0) == 0)))
							xp[lst_xp_ent].io = 0;
						else if ((cosign = iswhere(cur_fe_cos, 0.0, 0.0)) >= 0)
							xp[lst_xp_ent].io = -cosign;
						/* else if (isnonzero(prv_fe_cos))
							xp[lst_xp_ent].io = 1;
						else
							xp[lst_xp_ent].io = 0;
						*/
						else
							xp[lst_xp_ent].io = 1;
					}
					xp[lst_xp_ent].dpo = dpo_ent;
				}
				pxx_ent = tp_pxx->r_link;
			}

			while (tp_dpo2->a_link)
				tp_dpo2 = dpoint+tp_dpo2->a_link;
			pxx_ent = tp_dpo2->pxxtop;
			while (pxx_ent) {
				tp_pxx = pxx+pxx_ent;
				tp_xed = xedge+tp_pxx->xed;
				if (tp_pxx->fac == fac_ent && (tp_xed->fa1 == fac2_ent || tp_xed->fa2 == fac2_ent)) {
					if (lst_xp_ent == 0) {
						v_vec(tp_dve->x, tp_dve->y, tp_dve->z, tp_dve2->x, tp_dve2->y, tp_dve2->z, &xdirx, &xdiry, &xdirz);
						ox = tp_dpo2->x;
						oy = tp_dpo2->y;
						oz = tp_dpo2->z;
					}
					if (++lst_xp_ent > XP_MAX) {
						fprintf(stderr, "G_f_f_newxed: current XP_MAX is %d\n", XP_MAX);
						exit(1);
					}
					if (isnonzero(xdirx))
						xp[lst_xp_ent].t = (tp_dpo2->x-ox)/xdirx;
					else if (isnonzero(xdiry))
						xp[lst_xp_ent].t = (tp_dpo2->y-oy)/xdiry;
					else if (isnonzero(xdirz))
						xp[lst_xp_ent].t = (tp_dpo2->z-oz)/xdirz;
					else
						xp[lst_xp_ent].t = 0.0;
					if (op == C_UN) {
						if ((cosign = iswhere(cur_fe_cos, 0.0, 0.0)) <= 0)
							xp[lst_xp_ent].io = -cosign;
						else if (isnonzero(nxt_fe_cos))
							xp[lst_xp_ent].io = -1;
						else if ((tp_xed->fa1 == fac2_ent && (tp_xed->bd2 || isabswhere(tp_xed->io2, 0.0, 360.0) == 0)) || (tp_xed->fa2 == fac2_ent && (tp_xed->bd1 || isabswhere(tp_xed->io1, 0.0, 360.0) == 0)))
							xp[lst_xp_ent].io = 1;
						else
							xp[lst_xp_ent].io = 0;
					}
					else if (op == C_INT) {
						if ((tp_xed->fa1 == fac2_ent && (tp_xed->bd2 || isabswhere(tp_xed->io2, 0.0, 360.0) == 0)) || (tp_xed->fa2 == fac2_ent && (tp_xed->bd1 || isabswhere(tp_xed->io1, 0.0, 360.0) == 0)))
							xp[lst_xp_ent].io = 0;
						else if ((cosign = iswhere(cur_fe_cos, 0.0, 0.0)) <= 0)
							xp[lst_xp_ent].io = cosign;
						else if (isnonzero(nxt_fe_cos))
							xp[lst_xp_ent].io = 1;
						else
							xp[lst_xp_ent].io = 0;
					}
					else if (op == C_DIF) {
						if ((tp_xed->fa1 == fac2_ent && (tp_xed->bd2 || isabswhere(tp_xed->io2, 0.0, 360.0) == 0)) || (tp_xed->fa2 == fac2_ent && (tp_xed->bd1 || isabswhere(tp_xed->io1, 0.0, 360.0) == 0)))
							xp[lst_xp_ent].io = 0;
						else if ((cosign = iswhere(cur_fe_cos, 0.0, 0.0)) <= 0)
							xp[lst_xp_ent].io = -cosign;
						/* else if (isnonzero(nxt_fe_cos))
							xp[lst_xp_ent].io = -1;
						else
							xp[lst_xp_ent].io = 0;
						*/
						else
							xp[lst_xp_ent].io = -1;
					}
					xp[lst_xp_ent].dpo = dpo2_ent;
				}
				pxx_ent = tp_pxx->r_link;
			}

			tp_dpo      = tp_dpo3;
			tp_dpo2     = tp_dpo4;
			dpo_ent     = dpo3_ent;
			dpo2_ent    = dpo4_ent;
			prv_fe_cos  = cur_fe_cos;
			cur_fe_cos  = nxt_fe_cos;
			cur_xed_ent = nxt_xed_ent;
			nxt_xed_ent = nyt_xed_ent;
		} while (cur_xed_ent != sav_xed_ent);
	} while ((cur_xlo_ent = (xloop+cur_xlo_ent)->r_link) != sav_xlo_ent);

#ifdef DEBUG
for (i=1; i<=lst_xp_ent; i++) {
fprintf(stderr, "G_fac_newxed: xp-t=%f io=%d dpo=%d\n", xp[i].t, xp[i].io, xp[i].dpo);
}
#endif
/* filter xp (fill io of t-equal-xp where some xp[i].io != 0) */
	for (i=1; i<lst_xp_ent; i++) {
		if (xp[i].io == 0) {
			for (j=i+1; j<=lst_xp_ent; j++) {
				if (!isnonequ(xp[i].t, xp[j].t) && xp[j].io)
					xp[i].io = xp[j].io;
			}
		}
		if (xp[i].io) {
			brkstat = 0;
			for (j=i+1; j<=lst_xp_ent; j++) {
				if (!isnonequ(xp[i].t, xp[j].t)) {
					if (xp[i].io*xp[j].io >= 0)
						xp[j].io = xp[i].io;
					else {	
						brkstat = 1;
						break;
					}
				}
			}
			if (brkstat) {
				xp[i].io = 0;
				for (j=i+1; j<=lst_xp_ent; j++) {
					if (!isnonequ(xp[i].t, xp[j].t))
						xp[j].io = 0;
				}
			}
		}
	}

/* sorting xp (xp[i].t <= xp[j].t where i<j) */
	for (i=1; i<lst_xp_ent; i++) {
		for (j=i+1; j<=lst_xp_ent; j++) {
			if (xp[i].t > xp[j].t) {
				tp_dbl = xp[i].t;   xp[i].t   = xp[j].t;   xp[j].t   = tp_dbl;
				tp_int = xp[i].io;  xp[i].io  = xp[j].io;  xp[j].io  = tp_int;
				tp_int = xp[i].dpo; xp[i].dpo = xp[j].dpo; xp[j].dpo = tp_int;
			}
		}
	}

/* sorting xp (xp[i].io : 1 -1 in turn) */
	for (i=2; i<lst_xp_ent; i++) {
		if (xp[i-1].io && xp[i].io && xp[i+1].io && xp[i-1].io == xp[i].io && isnonequ(xp[i-1].t, xp[i].t) && xp[i].io != xp[i+1].io && !isnonequ(xp[i].t, xp[i+1].t)) {
			tp_dbl = xp[i].t;   xp[i].t   = xp[i+1].t;   xp[i+1].t   = tp_dbl;
			tp_int = xp[i].io;  xp[i].io  = xp[i+1].io;  xp[i+1].io  = tp_int;
			tp_int = xp[i].dpo; xp[i].dpo = xp[i+1].dpo; xp[i+1].dpo = tp_int;
		}
	}

/* create new edges */
	for (i=1; i<lst_xp_ent; i++) {
		if ((xp[i].io == -1 || xp[i+1].io == 1) && isnonequ(xp[i].t, xp[i+1].t)) { /* normal xed */
			tp_xed = xedge+(new_xed_ent = aloc_xed(brep_ent, breps));
			tp_xed->fa1 = fac_ent;
			tp_xed->fa2 = fac2_ent;
			tp_xed->dv1 = dve_ent;
			tp_xed->dv2 = dve2_ent;
			tp_xed->dp1 = xp[i  ].dpo;
			tp_xed->dp2 = xp[i+1].dpo;
			iref_dpo(tp_xed->dp1, breps);
			iref_dpo(tp_xed->dp2, breps);
			iref_dve(tp_xed->dv1, breps);
			iref_dve(tp_xed->dv2, breps);
			add_exx(fac_ent,  new_xed_ent, 0, breps);
			add_exx(fac2_ent, new_xed_ent, 0, breps);
			if (i+2 < lst_xp_ent && xp[i+2].io == -1)
				i++;
			else if (i+3 < lst_xp_ent && xp[i+3].io == -1)
				i += 2;
#ifdef DEBUG
fprintf(stderr, "G_f_f_newxed: xed=%d fa1=%d fa2=%d dp1=%d dp2=%d\n", new_xed_ent, tp_xed->fa1, tp_xed->fa2, tp_xed->dp1, tp_xed->dp2);
#endif
		}
		else if ((xp[i].io == 1 || xp[i+1].io == -1) && isnonequ(xp[i].t, xp[i+1].t)) { /* normal xed */
			tp_xed = xedge+(new_xed_ent = aloc_xed(brep_ent, breps));
			tp_xed->fa1 = fac_ent;
			tp_xed->fa2 = fac2_ent;
			tp_xed->dv1 = dve_ent;
			tp_xed->dv2 = dve2_ent;
			tp_xed->dp1 = xp[i+1].dpo;
			tp_xed->dp2 = xp[i  ].dpo;
			iref_dpo(tp_xed->dp1, breps);
			iref_dpo(tp_xed->dp2, breps);
			iref_dve(tp_xed->dv1, breps);
			iref_dve(tp_xed->dv2, breps);
			add_exx(fac_ent,  new_xed_ent, 0, breps);
			add_exx(fac2_ent, new_xed_ent, 0, breps);
			if (i+2 < lst_xp_ent && xp[i+2].io == 1)
				i++;
			else if (i+3 < lst_xp_ent && xp[i+3].io == 1)
				i += 2;
#ifdef DEBUG
fprintf(stderr, "G_f_f_newxed: xed=%d fa1=%d fa2=%d dp1=%d dp2=%d\n", new_xed_ent, tp_xed->fa1, tp_xed->fa2, tp_xed->dp1, tp_xed->dp2);
#endif
		}
		else if (isnonequ(xp[i].t, xp[i+1].t)) { /* dyadic xed */
			tp_xed  = xedge+(new_xed_ent  = aloc_xed(brep_ent, breps));
			tp_xed2 = xedge+(new_xed2_ent = aloc_xed(brep_ent, breps));
			tp_xed ->fa1 = tp_xed2->fa1 = fac_ent;
			tp_xed ->fa2 = tp_xed2->fa2 = fac2_ent;
			tp_xed ->dv1 = tp_xed2->dv1 = dve_ent;
			tp_xed ->dv2 = tp_xed2->dv2 = dve2_ent;
			tp_xed ->dp1 = tp_xed2->dp2 = xp[i  ].dpo;
			tp_xed ->dp2 = tp_xed2->dp1 = xp[i+1].dpo;
			iref_dpo(tp_xed ->dp1, breps);
			iref_dpo(tp_xed ->dp2, breps);
			iref_dve(tp_xed ->dv1, breps);
			iref_dve(tp_xed ->dv2, breps);
			iref_dpo(tp_xed2->dp1, breps);
			iref_dpo(tp_xed2->dp2, breps);
			iref_dve(tp_xed2->dv1, breps);
			iref_dve(tp_xed2->dv2, breps);
			add_exx(fac_ent,  new_xed_ent, new_xed2_ent, breps);
			add_exx(fac2_ent, new_xed_ent, new_xed2_ent, breps);
#ifdef DEBUG
fprintf(stderr, "G_f_f_newxed: xed=%d fa1=%d fa2=%d dp1=%d dp2=%d\n", new_xed_ent, tp_xed->fa1, tp_xed->fa2, tp_xed->dp1, tp_xed->dp2);
#endif
#ifdef DEBUG
fprintf(stderr, "G_f_f_newxed: xed=%d fa1=%d fa2=%d dp1=%d dp2=%d\n", new_xed2_ent, tp_xed2->fa1, tp_xed2->fa2, tp_xed2->dp1, tp_xed2->dp2);
#endif
		}
	}
}
G_f_f_phase(fac_ent, fac2_ent, breps)
	int			fac_ent, fac2_ent;
	struct breps		*breps;
{
/* if fac == fac2 return 2 */
/* if fac // fac2 return 0 */
/* if fac X  fac2 return 1 */
	struct face		*face   = breps->face;
	struct xloop		*xloop  = breps->xloop;
	struct xedge		*xedge  = breps->xedge;
	struct dpoint		*dpoint = breps->dpoint;
	struct dvect		*dvect  = breps->dvect;
	register struct dpoint	*tp_dpo, *tp_dpo2;
	register struct dvect	*tp_dve;
	register int		dve_ent, dve2_ent;

	if (fac_ent == 0 || fac2_ent == 0)
		return(0);

	if ((face+fac_ent)->xlotop == 0 || (face+fac2_ent)->xlotop == 0)
		return(0);

	tp_dpo   = dpoint+(xedge+(xloop+(face+fac_ent )->xlotop)->xedtop)->dp1;
	tp_dpo2  = dpoint+(xedge+(xloop+(face+fac2_ent)->xlotop)->xedtop)->dp1;
	tp_dve   = dvect+(dve_ent = (face+fac_ent )->favect);
	dve2_ent = (face+fac2_ent)->favect;

	if (G_dve_neq(dve_ent, dve2_ent, breps))
		return(1);
	else if (v_northo(tp_dpo->x-tp_dpo2->x, tp_dpo->y-tp_dpo2->y, tp_dpo->z-tp_dpo2->z, tp_dve->x, tp_dve->y, tp_dve->z))
		return(0);
	else
		return(2);
}
G_dpo_neq(dpo_ent, dpo2_ent, breps)
	register int		dpo_ent, dpo2_ent;
	register struct breps	*breps;
{
/* if dpo == dpo2 return FALSE */
/* if dpo != dpo2 return TRUE  */
	register struct dpoint	*dpoint = breps->dpoint;
	register struct dpoint	*tp_dpo, *tp_dpo2;
	register int		min_dpo_ent, min_dpo2_ent, nxt_dpo_ent;

	if (dpo_ent == 0 || dpo2_ent == 0)
		return(1);

	if (dpo_ent == dpo2_ent)
		return(0);

	tp_dpo  = dpoint+dpo_ent;
	tp_dpo2 = dpoint+dpo2_ent;

	if (isnonequ(tp_dpo->x, tp_dpo2->x) || isnonequ(tp_dpo->y, tp_dpo2->y) || isnonequ(tp_dpo->z, tp_dpo2->z))
		return(1);
	else {
		min_dpo_ent  = dpo_ent;
		min_dpo2_ent = dpo2_ent;
		while (nxt_dpo_ent = (dpoint+min_dpo_ent) ->a_link)
			min_dpo_ent  = nxt_dpo_ent;
		while (nxt_dpo_ent = (dpoint+min_dpo2_ent)->a_link)
			min_dpo2_ent = nxt_dpo_ent;
		if (min_dpo_ent > min_dpo2_ent) {
			(dpoint+min_dpo_ent)->a_link = min_dpo2_ent;
			(dpoint+dpo_ent    )->a_link = min_dpo2_ent;
			if (dpo2_ent != min_dpo2_ent)
				(dpoint+dpo2_ent)->a_link = min_dpo2_ent;
			merg_pxx(min_dpo2_ent, min_dpo_ent, breps);
		}
		else if (min_dpo_ent < min_dpo2_ent) {
			(dpoint+min_dpo2_ent)->a_link = min_dpo_ent;
			(dpoint+dpo2_ent    )->a_link = min_dpo_ent;
			if (dpo_ent != min_dpo_ent)
				(dpoint+dpo_ent)->a_link = min_dpo_ent;
			merg_pxx(min_dpo_ent, min_dpo2_ent, breps);
		}
		return(0);
	}
}
G_dve_neq(dve_ent, dve2_ent, breps)
	register int		dve_ent, dve2_ent;
	register struct breps	*breps;
{
/* if dve == dve2 return FALSE */
/* if dve != dve2 return TRUE  */
	register struct dvect	*dvect = breps->dvect;
	register struct dvect	*tp_dve, *tp_dve2;

	if (dve_ent == 0 || dve2_ent == 0)
		return(1);

	if (dve_ent == dve2_ent)
		return(0);

	tp_dve  = dvect+dve_ent;
	tp_dve2 = dvect+dve2_ent;

	return(isnonequ(tp_dve->x, tp_dve2->x) || isnonequ(tp_dve->y, tp_dve2->y) || isnonequ(tp_dve->z, tp_dve2->z));
}

