
/* csg_reconfig.c	87/12/30 */

#include "dsm.h"
/* #define DEBUG */

G_xed_comp(fac_ent, xed_ent, xed2_ent, brep_ent, l_breps, r_breps)
	int			fac_ent, xed_ent, xed2_ent, brep_ent;
	struct breps		*l_breps, *r_breps;
{
	struct xedge		*lxedge  = l_breps->xedge;
	struct xedge		*rxedge  = r_breps->xedge;
	struct dpoint		*ldpoint = l_breps->dpoint;
	struct dpoint		*rdpoint = r_breps->dpoint;
	struct xedge		*tp_xed, *tp_xed2;
	register struct dpoint	*tp_dpo, *tp_dpo2, *tp_dpo3, *tp_dpo4;
	struct dpoint		*tp_dpo5;
	double			l1, m1, n1;
	double			t1, t2;
	register int		dpo_ent;
	register int		tsave1, tsave2;

	if (fac_ent == 0 || xed_ent == 0 || xed2_ent == 0 || brep_ent == 0)
		return;

	tp_xed  = lxedge+xed_ent;
	tp_xed2 = rxedge+xed2_ent;
	if (tp_xed->fa1 == fac_ent) {
		tp_dpo  = ldpoint+tp_xed ->dp1;
		tp_dpo2 = ldpoint+tp_xed ->dp2;
		tp_dpo3 = rdpoint+tp_xed2->dp1;
		tp_dpo4 = rdpoint+tp_xed2->dp2;
	}
	else {
		tp_dpo  = ldpoint+tp_xed ->dp2;
		tp_dpo2 = ldpoint+tp_xed ->dp1;
		tp_dpo3 = rdpoint+tp_xed2->dp2;
		tp_dpo4 = rdpoint+tp_xed2->dp1;
	}
	l1 = tp_dpo2->x-tp_dpo->x;
	m1 = tp_dpo2->y-tp_dpo->y;
	n1 = tp_dpo2->z-tp_dpo->z;

	if (isnonzero(l1)) {
		t1 = (tp_dpo3->x-tp_dpo->x)/l1;
		t2 = (tp_dpo4->x-tp_dpo->x)/l1;
	}
	else if (isnonzero(m1)) {
		t1 = (tp_dpo3->y-tp_dpo->y)/m1;
		t2 = (tp_dpo4->y-tp_dpo->y)/m1;
	}
	else if (isnonzero(n1)) {
		t1 = (tp_dpo3->z-tp_dpo->z)/n1;
		t2 = (tp_dpo4->z-tp_dpo->z)/n1;
	}
	else
		return;

	tsave1  = iswhere(t1, 0.0, 1.0);	/* -2 -1 0 1 2 */
	tsave2  = iswhere(t2, 0.0, 1.0);	/* -2 -1 0 1 2 */

	if (tsave1 == 0) {
		tp_dpo5 = ldpoint+(dpo_ent = aloc_dpo(brep_ent, l_breps));
		tp_dpo5->x = tp_dpo->x+l1*t1;
		tp_dpo5->y = tp_dpo->y+m1*t1;
		tp_dpo5->z = tp_dpo->z+n1*t1;
		if (tp_xed->fa1 == fac_ent)
			G_xed_divide(fac_ent, xed_ent, dpo_ent, brep_ent, 0.0, tp_xed2->bd1, l_breps);
		else
			G_xed_divide(fac_ent, xed_ent, dpo_ent, brep_ent, 0.0, tp_xed2->bd2, l_breps);
	}
	if (tsave2 == 0) {
		tp_dpo5 = ldpoint+(dpo_ent = aloc_dpo(brep_ent, l_breps));
		tp_dpo5->x = tp_dpo->x+l1*t2;
		tp_dpo5->y = tp_dpo->y+m1*t2;
		tp_dpo5->z = tp_dpo->z+n1*t2;
		if (tp_xed->fa1 == fac_ent) {
			G_xed_divide(fac_ent, xed_ent, dpo_ent, brep_ent, 0.0, tp_xed2->bd2, l_breps);
			tp_xed->io2 += tp_xed2->io2;
			tp_xed->bd2 |= tp_xed2->bd2;
		}
		else {
			G_xed_divide(fac_ent, xed_ent, dpo_ent, brep_ent, 0.0, tp_xed2->bd1, l_breps);
			tp_xed->io1 += tp_xed2->io1;
			tp_xed->bd1 |= tp_xed2->bd1;
		}
	}

	switch (tsave1) {
	case -1:
		if (tp_xed->fa1 == fac_ent) {
			tp_xed->io1 += tp_xed2->io1;
			tp_xed->bd1 |= tp_xed2->bd1;
		}
		else {
			tp_xed->io2 += tp_xed2->io2;
			tp_xed->bd2 |= tp_xed2->bd2;
		}
		break;
	case -2:
		if (tsave2 > -1) {
			if (tp_xed->fa1 == fac_ent)
				tp_xed->io1 += tp_xed2->io1;
			else
				tp_xed->io2 += tp_xed2->io2;
		}
		break;
	default:
		break;
	}
	switch (tsave2) {
	case 1:
		if (tp_xed->fa1 == fac_ent) {
			tp_xed->io2 += tp_xed2->io2;
			tp_xed->bd2 |= tp_xed2->bd2;
		}
		else {
			tp_xed->io1 += tp_xed2->io1;
			tp_xed->bd1 |= tp_xed2->bd1;
		}
		break;
	case 2:
		if (tsave1 < 1) {
			if (tp_xed->fa1 == fac_ent)
				tp_xed->io2 += tp_xed2->io2;
			else
				tp_xed->io1 += tp_xed2->io1;
		}
		break;
	default:
		break;
	}
#ifdef DEBUG
fprintf(stderr, "G_xed_comp: fac=%d xed=%d %f %f xed2=%d\n", fac_ent, xed_ent, (lxedge+xed_ent)->io1, (lxedge+xed_ent)->io2, xed2_ent);
#endif
}
G_exx_comp(fac_ent, brep_ent, l_breps, r_breps)
	int			fac_ent, brep_ent;
	struct breps		*l_breps, *r_breps;
{
	struct face		*rface   = r_breps->face;
	struct xedge		*lxedge  = l_breps->xedge;
	struct xedge		*rxedge  = r_breps->xedge;
	struct dpoint		*ldpoint = l_breps->dpoint;
	struct dpoint		*rdpoint = r_breps->dpoint;
	struct dvect		*ldvect  = l_breps->dvect;
	struct dvect		*rdvect  = r_breps->dvect;
	struct exx		*rexx    = r_breps->exx;
	struct xedge		*tp_xed, *tp_xed2, *tp_xed3;
	register struct dpoint	*tp_dpo, *tp_dpo2, *tp_dpo3, *tp_dpo4;
	struct dvect		*tp_dve, *tp_dve2, *tp_dve3, *tp_dve4;
	struct exx		*tp_exx;
	register int		fac2_ent;
	register int		new_xed_ent, new_xed2_ent;
	register int		exx_ent, sav_exx_ent;

	if (fac_ent == 0 || brep_ent == 0)
		return;

	sav_exx_ent = 0;
	exx_ent = (rface+fac_ent)->exxtop;
	while (exx_ent) {
		tp_xed = rxedge+(tp_exx = rexx+exx_ent)->xed;
		if (tp_xed->fa1 == fac_ent)
			fac2_ent = tp_xed->fa2;
		else
			fac2_ent = tp_xed->fa1;
		if (tp_exx->d_link == 0) { /* normal xed */
			tp_dpo  = rdpoint+tp_xed->dp1;
			tp_dpo2 = rdpoint+tp_xed->dp2;
			tp_dve  = rdvect +tp_xed->dv1;
			tp_dve2 = rdvect +tp_xed->dv2;

			tp_xed2 = lxedge+(new_xed_ent = aloc_xed(brep_ent, l_breps));
			tp_xed2->fa1 = tp_xed->fa1;
			tp_xed2->fa2 = tp_xed->fa2;
			tp_dpo3 = ldpoint+(tp_xed2->dp1 = aloc_dpo(brep_ent, l_breps));
			tp_dpo4 = ldpoint+(tp_xed2->dp2 = aloc_dpo(brep_ent, l_breps));
			tp_dve3 = ldvect +(tp_xed2->dv1 = aloc_dve(brep_ent, l_breps));
			tp_dve4 = ldvect +(tp_xed2->dv2 = aloc_dve(brep_ent, l_breps));
			tp_dpo3->x = tp_dpo ->x;
			tp_dpo3->y = tp_dpo ->y;
			tp_dpo3->z = tp_dpo ->z;
			tp_dpo4->x = tp_dpo2->x;
			tp_dpo4->y = tp_dpo2->y;
			tp_dpo4->z = tp_dpo2->z;
			tp_dve3->x = tp_dve ->x;
			tp_dve3->y = tp_dve ->y;
			tp_dve3->z = tp_dve ->z;
			tp_dve4->x = tp_dve2->x;
			tp_dve4->y = tp_dve2->y;
			tp_dve4->z = tp_dve2->z;
			iref_dpo(tp_xed2->dp1, l_breps);
			iref_dpo(tp_xed2->dp2, l_breps);
			iref_dve(tp_xed2->dv1, l_breps);
			iref_dve(tp_xed2->dv2, l_breps);
			add_exx(fac_ent,  new_xed_ent, 0, l_breps);
			add_exx(fac2_ent, new_xed_ent, 0, l_breps);
		}
		else { /* dyadic xed */
			if (sav_exx_ent == 0)
				sav_exx_ent = exx_ent;
			else {
				sav_exx_ent = 0;
				tp_dpo  = rdpoint+tp_xed->dp1;
				tp_dpo2 = rdpoint+tp_xed->dp2;
				tp_dve  = rdvect +tp_xed->dv1;
				tp_dve2 = rdvect +tp_xed->dv2;

				tp_xed2 = lxedge+(new_xed_ent  = aloc_xed(brep_ent, l_breps));
				tp_xed3 = lxedge+(new_xed2_ent = aloc_xed(brep_ent, l_breps));
				tp_xed2->fa1 = tp_xed3->fa1 = tp_xed->fa1;
				tp_xed2->fa2 = tp_xed3->fa2 = tp_xed->fa2;
				tp_dpo3 = ldpoint+(tp_xed2->dp1 = tp_xed3->dp2 = aloc_dpo(brep_ent, l_breps));
				tp_dpo4 = ldpoint+(tp_xed2->dp2 = tp_xed3->dp1 = aloc_dpo(brep_ent, l_breps));
				tp_dve3 = ldvect +(tp_xed2->dv1 = tp_xed3->dv1 = aloc_dve(brep_ent, l_breps));
				tp_dve4 = ldvect +(tp_xed2->dv2 = tp_xed3->dv2 = aloc_dve(brep_ent, l_breps));
				tp_dpo3->x = tp_dpo ->x;
				tp_dpo3->y = tp_dpo ->y;
				tp_dpo3->z = tp_dpo ->z;
				tp_dpo4->x = tp_dpo2->x;
				tp_dpo4->y = tp_dpo2->y;
				tp_dpo4->z = tp_dpo2->z;
				tp_dve3->x = tp_dve ->x;
				tp_dve3->y = tp_dve ->y;
				tp_dve3->z = tp_dve ->z;
				tp_dve4->x = tp_dve2->x;
				tp_dve4->y = tp_dve2->y;
				tp_dve4->z = tp_dve2->z;
				iref_dpo(tp_xed2->dp1, l_breps);
				iref_dpo(tp_xed2->dp2, l_breps);
				iref_dve(tp_xed2->dv1, l_breps);
				iref_dve(tp_xed2->dv2, l_breps);
				iref_dpo(tp_xed3->dp1, l_breps);
				iref_dpo(tp_xed3->dp2, l_breps);
				iref_dve(tp_xed3->dv1, l_breps);
				iref_dve(tp_xed3->dv2, l_breps);
				add_exx(fac_ent,  new_xed_ent, new_xed2_ent, l_breps);
				add_exx(fac2_ent, new_xed_ent, new_xed2_ent, l_breps);
			}
		}
		exx_ent = tp_exx->r_link;
	}
}
G_fac_invert(fac_ent, breps) int fac_ent; struct breps *breps;
{
	struct face		*face  = breps->face;
	struct xloop		*xloop = breps->xloop;
	register struct xedge	*xedge = breps->xedge;
	register struct xedge	*tp_xed, *tp_xed2, *tp_xed3;
	register int		cur_xlo_ent, sav_xlo_ent;
	register int		cur_xed_ent, sav_xed_ent;
	register int		prv_xed_ent, nxt_xed_ent;
	int			nyt_xed_ent;

	if (fac_ent == 0)
		return;

	if ((face+fac_ent)->xlotop == 0)
		return;

	cur_xlo_ent = sav_xlo_ent = (face+fac_ent)->xlotop;
	do {
		tp_xed = xedge+(prv_xed_ent = (xloop+cur_xlo_ent)->xedtop);
		if (tp_xed->fa1 == fac_ent)
			tp_xed2 = xedge+(cur_xed_ent = sav_xed_ent = tp_xed->link1);
		else
			tp_xed2 = xedge+(cur_xed_ent = sav_xed_ent = tp_xed->link2);
		if (tp_xed2->fa1 == fac_ent)
			tp_xed3 = xedge+(nxt_xed_ent = tp_xed2->link1);
		else
			tp_xed3 = xedge+(nxt_xed_ent = tp_xed2->link2);
		do {
			if (tp_xed2->fa1 == fac_ent) {
				if (tp_xed3->fa1 == fac_ent) {
					tp_xed2->dv1 = tp_xed3->dv1;
					nyt_xed_ent  = tp_xed3->link1;
				}
				else {
					tp_xed2->dv1 = tp_xed3->dv2;
					nyt_xed_ent  = tp_xed3->link2;
				}
				tp_xed2->link1 = prv_xed_ent;
			}
			else {
				if (tp_xed3->fa1 == fac_ent) {
					tp_xed2->dv2 = tp_xed3->dv1;
					nyt_xed_ent  = tp_xed3->link1;
				}
				else {
					tp_xed2->dv2 = tp_xed3->dv2;
					nyt_xed_ent  = tp_xed3->link2;
				}
				tp_xed2->link2 = prv_xed_ent;
			}
			tp_xed  = xedge+(prv_xed_ent = cur_xed_ent);
			tp_xed2 = xedge+(cur_xed_ent = nxt_xed_ent);
			tp_xed3 = xedge+(nxt_xed_ent = nyt_xed_ent);
		} while (cur_xed_ent != sav_xed_ent);
	} while ((cur_xlo_ent = (xloop+cur_xlo_ent)->r_link) != sav_xlo_ent);
}
G_lxed_invert(xed_ent, breps)
	register int		xed_ent;
	register struct breps	*breps;
{
	register struct xedge	*xedge = breps->xedge;
	register struct xedge	*tp_xed;

	if (xed_ent == 0)
		return;

	tp_xed = xedge+xed_ent;
	tp_xed->io1 = 360.0-tp_xed->io1;
	tp_xed->io2 = 360.0-tp_xed->io2;
}
G_rxed_invert(xed_ent, breps)
	register int		xed_ent;
	register struct breps	*breps;
{
	register struct xedge	*xedge = breps->xedge;
	register struct xedge	*tp_xed;
	register int		tp_int;
	double			tp_dbl;

	if (xed_ent == 0)
		return;

	tp_xed = xedge+xed_ent;
	tp_dbl = tp_xed->io1; tp_xed->io1 = tp_xed->io2; tp_xed->io2 = tp_dbl;
	tp_int = tp_xed->dp1; tp_xed->dp1 = tp_xed->dp2; tp_xed->dp2 = tp_int;
}
G_dve_invert(dve_ent, breps)
	register int		dve_ent;
	register struct breps	*breps;
{
	register struct dvect	*dvect = breps->dvect;
	register struct dvect	*tp_dve;

	if (dve_ent == 0)
		return;

	tp_dve = dvect+dve_ent;
	tp_dve->x = -tp_dve->x;
	tp_dve->y = -tp_dve->y;
	tp_dve->z = -tp_dve->z;
}
G_b_b_merge(brep_ent, brep2_ent, breps)
	register int		brep_ent, brep2_ent;
	register struct breps	*breps;
{
	merg_xlo(brep_ent, brep2_ent, breps);
	merg_xed(brep_ent, brep2_ent, breps);
	merg_dpo(brep_ent, brep2_ent, breps);
	merg_dve(brep_ent, brep2_ent, breps);
}
G_f_f_merge(fac_ent, fac2_ent, breps)
	int			fac_ent, fac2_ent;
	struct breps		*breps;
{
	register struct face	*face  = breps->face;
	register struct xloop	*xloop = breps->xloop;
	register struct face	*tp_fac, *tp_fac2;
	register int		xlo_ent, xlo2_ent, xlo3_ent, xlo4_ent;

	if (fac_ent == 0 || fac2_ent == 0)
		return;

	tp_fac  = face+fac_ent;
	tp_fac2 = face+fac2_ent;

	if (tp_fac->xlotop == 0 || tp_fac2->xlotop == 0)
		return;

	if (G_f_f_phase(fac_ent, fac2_ent, breps) != 2)
		return;

	xlo_ent  = tp_fac ->xlotop;
	xlo2_ent = tp_fac2->xlotop;
	xlo3_ent = (xloop+xlo_ent )->r_link;
	xlo4_ent = (xloop+xlo2_ent)->r_link;
	(xloop+xlo_ent )->r_link = xlo4_ent;
	(xloop+xlo2_ent)->r_link = xlo3_ent;
	tp_fac2->xlotop = 0;
	tp_fac2->a_link = fac_ent;

	merg_exx(fac_ent, fac2_ent, breps);

	tp_fac->facolor = (tp_fac->facolor | tp_fac2->facolor);
	tp_fac->fasssw  = (tp_fac->fasssw  | tp_fac2->fasssw);
}
G_fac_reconfig(op, fac_ent, brep_ent, breps)
	int			op, fac_ent, brep_ent;
	struct breps		*breps;
{
#define XE_MAX			100
	struct face		*face   = breps->face;
	struct xloop		*xloop  = breps->xloop;
	struct xedge		*xedge  = breps->xedge;
	struct dpoint		*dpoint = breps->dpoint;
	struct dvect		*dvect  = breps->dvect;
	struct exx		*exx    = breps->exx;
	register struct xedge	*tp_xed, *tp_xed2, *tp_xed3;
	struct dpoint		*tp_dpo, *tp_dpo2, *tp_dpo3, *tp_dpo4;
	struct dvect		*tp_dve;
	register struct exx	*tp_exx;
	struct xe { int r_link, d_link, iostat, xedtop, xedmid, xedbot; }
				xe[XE_MAX+1];
	double			dabs(), v_deg();
	double			sdeg, tp_dbl;
	register int		lst_xe_ent;
	int			sav_xe_ent;
	int			xetop, xe2num, xe3num;
	int			cur_xlo_ent, sav_xlo_ent, nxt_xlo_ent;
	register int		cur_xed_ent, sav_xed_ent, nxt_xed_ent;
	int			top_xed_ent, bot_xed_ent, mid_xed_ent;
	int			top_dpo_ent, bot_dpo_ent;
	int			exx_ent;
	register int		nxt_xe_ent;
	int			iosave1, iosave2;
	int			giostat, liostat, iosel;
	int			brkstat, i;
	register int		j;

#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: +++fac %d+++\n", fac_ent);
#endif
	if (fac_ent == 0)
		return;

	if ((face+fac_ent)->xlotop == 0)
		return;

	tp_dve = dvect+(face+fac_ent)->favect;
	lst_xe_ent = 0;

/* extract outer edges from xloop */
	cur_xlo_ent = sav_xlo_ent = (face+fac_ent)->xlotop;
	do {
		nxt_xlo_ent = (xloop+cur_xlo_ent)->r_link;
		giostat = 0;
		cur_xed_ent = mid_xed_ent = sav_xed_ent = (xloop+cur_xlo_ent)->xedtop;
		do {
			tp_xed = xedge+cur_xed_ent;
			if (G_fac_equ(tp_xed->fa1, fac_ent, breps))
				tp_xed2 = xedge+(nxt_xed_ent = mid_xed_ent = tp_xed->link1);
			else
				tp_xed2 = xedge+(nxt_xed_ent = mid_xed_ent = tp_xed->link2);
			if (G_dpo_neq(tp_xed->dp1, tp_xed->dp2, breps)) {
				while (!G_dpo_neq(tp_xed2->dp1, tp_xed2->dp2, breps)) {
					if (G_fac_equ(tp_xed2->fa1, fac_ent, breps))
						tp_xed2 = xedge+(mid_xed_ent = tp_xed2->link1);
					else
						tp_xed2 = xedge+(mid_xed_ent = tp_xed2->link2);
				}
				iosave1 = isabswhere(tp_xed ->io1, 0.0, 360.0);
				iosave2 = isabswhere(tp_xed2->io1, 0.0, 360.0);
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: xed=%d SEEK 1 2 1 2=%f %f %f %f in1 in2=%d %d\n", tp_xed-xedge, tp_xed->io1, tp_xed->io2, tp_xed2->io1, tp_xed2->io2, iosave1, iosave2);
#endif
				if ((op == C_UN && iosave1 >= 0  && iosave2 == -1) || (op == C_INT && iosave1 == -1 && iosave2 >= 0) || (op == C_DIF && iosave1 <= 0 && iosave2 == 1)) {
				/* if ((op == C_UN && iosave1 >= 0  && iosave2 == -1) || (op == C_INT && iosave1 == -1 && iosave2 >= 0) || (op == C_DIF && iosave1 == -1 && iosave2 >= 0)) { */
					giostat = 2;
					top_xed_ent = nxt_xed_ent;
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: FOUND  top=%d mid=%d\n", top_xed_ent, mid_xed_ent);
#endif
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: dp1=%f %f %f dp2=%f %f %f\n", (dpoint+(xedge+top_xed_ent)->dp1)->x, (dpoint+(xedge+top_xed_ent)->dp1)->y, (dpoint+(xedge+top_xed_ent)->dp1)->z, (dpoint+(xedge+top_xed_ent)->dp2)->x, (dpoint+(xedge+top_xed_ent)->dp2)->y, (dpoint+(xedge+top_xed_ent)->dp2)->z);
#endif
					break;
				}
				else if ((op == C_UN && iosave1 >= 0  && iosave2 >= 0) || (op == C_INT && iosave1 == -1 && iosave2 == -1) || (op == C_DIF && iosave1 <= 0 && iosave2 <= 0))
				/* else if ((op == C_UN && iosave1 >= 0  && iosave2 >= 0) || (op == C_INT && iosave1 == -1 && iosave2 == -1) || (op == C_DIF && iosave1 == -1 && iosave2 == -1)) */
					giostat = 1;
			}
		} while ((cur_xed_ent = nxt_xed_ent) != sav_xed_ent);

		switch (giostat) {
		case 0: /* loop completely outside */
			if (++lst_xe_ent > XE_MAX) {
				fprintf(stderr, "G_fac_reconfig: current XE_MAX is %d\n", XE_MAX);
				exit(1);
			}
			xe[lst_xe_ent].r_link = 0;
			xe[lst_xe_ent].d_link = 0;
			xe[lst_xe_ent].iostat = giostat;
			xe[lst_xe_ent].xedtop = (xloop+cur_xlo_ent)->xedtop;
			xe[lst_xe_ent].xedmid = (xloop+cur_xlo_ent)->xedtop;
			xe[lst_xe_ent].xedbot = (xloop+cur_xlo_ent)->xedtop;
			break;
		case 1: /* loop completely inside */
			cur_xed_ent = sav_xed_ent = (xloop+cur_xlo_ent)->xedtop;
			do {
				tp_xed = xedge+cur_xed_ent;
				if (G_fac_equ(tp_xed->fa1, fac_ent, breps)) {
					tp_xed->fa1 = 0;
					cur_xed_ent = tp_xed->link1;
				}
				else {
					tp_xed->fa2 = 0;
					cur_xed_ent = tp_xed->link2;
				}
			} while (cur_xed_ent != sav_xed_ent);
			break;
		case 2: /* loop inside/outside */
			liostat = 0;
			cur_xed_ent = sav_xed_ent = mid_xed_ent;
			do {
				tp_xed = xedge+cur_xed_ent;
				if (G_fac_equ(tp_xed->fa1, fac_ent, breps)) {
					if (liostat == 0)
						tp_xed2 = xedge+(nxt_xed_ent = tp_xed->link1);
					else {
						tp_xed->fa1 = 0;
						tp_xed2 = xedge+(nxt_xed_ent = mid_xed_ent = tp_xed->link1);
					}
				}
				else {
					if (liostat == 0)
						tp_xed2 = xedge+(nxt_xed_ent = tp_xed->link2);
					else {
						tp_xed->fa2 = 0;
						tp_xed2 = xedge+(nxt_xed_ent = mid_xed_ent = tp_xed->link2);
					}
				}
				if (G_dpo_neq(tp_xed->dp1, tp_xed->dp2, breps)) {
					while (!G_dpo_neq(tp_xed2->dp1, tp_xed2->dp2, breps)) {
						if (G_fac_equ(tp_xed2->fa1, fac_ent, breps)) {
							if (liostat == 0)
								tp_xed2 = xedge+tp_xed2->link1;
							else
								tp_xed2 = xedge+(mid_xed_ent = tp_xed2->link1);
						}
						else {
							if (liostat == 0)
								tp_xed2 = xedge+tp_xed2->link2;
							else
								tp_xed2 = xedge+(mid_xed_ent = tp_xed2->link2);
						}
					}
					iosave1 = isabswhere(tp_xed2->io1, 0.0, 360.0);
					if ((op == C_UN && iosave1 == -1) || (op == C_INT && iosave1 >= 0) || (op == C_DIF && iosave1 == 1)) {
					/* if ((op == C_UN && iosave1 == -1) || (op == C_INT && iosave1 >= 0) || (op == C_DIF && iosave1 >= 0)) { */
						if (liostat == 1) {
							liostat = 0;
							top_xed_ent = nxt_xed_ent;
						}
					}
					else {
						if (liostat == 0) {
							liostat = 1;
							if (++lst_xe_ent > XE_MAX) {
								fprintf(stderr, "G_fac_reconfig: current XE_MAX is %d\n", XE_MAX);
								exit(1);
							}
							xe[lst_xe_ent].r_link = 0;
							xe[lst_xe_ent].d_link = 0;
							xe[lst_xe_ent].iostat = giostat;
							xe[lst_xe_ent].xedtop = top_xed_ent;
							xe[lst_xe_ent].xedmid = mid_xed_ent;
							xe[lst_xe_ent].xedbot = cur_xed_ent;
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: lst=%d iostat=%d top=%d mid=%d bot=%d\n", lst_xe_ent, xe[lst_xe_ent].iostat, xe[lst_xe_ent].xedtop, xe[lst_xe_ent].xedmid, xe[lst_xe_ent].xedbot);
#endif
						}
					}
				}
			} while ((cur_xed_ent = nxt_xed_ent) != sav_xed_ent);
			break;
		default:
			break;
		}
		free_xlo(cur_xlo_ent, brep_ent, breps);
	} while ((cur_xlo_ent = nxt_xlo_ent) != sav_xlo_ent);
	(face+fac_ent)->xlotop = 0;

/* extract boundary edges from exx */
	sav_xe_ent = 0;
	exx_ent = (face+fac_ent)->exxtop;
	while (exx_ent) {
		tp_exx = exx+exx_ent;
		if (++lst_xe_ent > XE_MAX) {
			fprintf(stderr, "G_fac_reconfig: current XE_MAX is %d\n", XE_MAX);
			exit(1);
		}
		if (tp_exx->d_link == 0) { /* normal xed */
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: normal exx %d:xed=%d d_link=%d dp1=%d dp2=%d\n", exx_ent, tp_exx->xed, tp_exx->d_link, (xedge+tp_exx->xed)->dp1, (xedge+tp_exx->xed)->dp2);
#endif
			xe[lst_xe_ent].d_link = 0;
			xe[lst_xe_ent].iostat = 2;
		}
		else { /* dyadic xed */
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: dyadic exx %d:xed=%d d_link=%d dp1=%5d dp2=%d\n", exx_ent, tp_exx->xed, tp_exx->d_link, (xedge+tp_exx->xed)->dp1, (xedge+tp_exx->xed)->dp2);
#endif
			if (sav_xe_ent == 0)
				sav_xe_ent = lst_xe_ent;
			else {
				xe[lst_xe_ent].d_link = sav_xe_ent;
				xe[sav_xe_ent].d_link = lst_xe_ent;
				sav_xe_ent = 0;
			}
			xe[lst_xe_ent].iostat = 3;
		}
		xe[lst_xe_ent].r_link = 0;
		xe[lst_xe_ent].xedtop = tp_exx->xed;
		xe[lst_xe_ent].xedmid = tp_exx->xed;
		xe[lst_xe_ent].xedbot = tp_exx->xed;
		exx_ent = tp_exx->r_link;
	}

/* loop reconfigration */
	sav_xlo_ent = 0;
	for (i=1; i<=lst_xe_ent; i++) {
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: reconfig i=%d\n", i);
#endif
		switch (xe[i].iostat) {
		case 0: /* loop completely outside */
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: completely outside\n");
#endif
			nxt_xlo_ent = aloc_xlo(brep_ent, breps);
			if (sav_xlo_ent == 0)
				(face+fac_ent)->xlotop = sav_xlo_ent = nxt_xlo_ent;
			else
				(xloop+cur_xlo_ent)->r_link = nxt_xlo_ent;
			(xloop+nxt_xlo_ent)->r_link = sav_xlo_ent;
			(xloop+nxt_xlo_ent)->xedtop = xe[i].xedtop;
			cur_xlo_ent = nxt_xlo_ent;
			break;
		case 1: /* loop completely inside */
			break;
		case 2: /* outer edges & normal xed */
			tp_xed  = xedge+(top_xed_ent = xe[i].xedtop);
			tp_xed2 = xedge+(bot_xed_ent = xe[i].xedbot);
			if (G_fac_equ(tp_xed ->fa1, fac_ent, breps))
				top_dpo_ent = tp_xed ->dp1;
			else
				top_dpo_ent = tp_xed ->dp2;
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: top_dpo=%f %f %f\n", (dpoint+top_dpo_ent)->x, (dpoint+top_dpo_ent)->y, (dpoint+top_dpo_ent)->z);
#endif
			if (G_fac_equ(tp_xed2->fa1, fac_ent, breps))
				bot_dpo_ent = tp_xed2->dp2;
			else
				bot_dpo_ent = tp_xed2->dp1;
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: bot_dpo=%f %f %f\n", (dpoint+bot_dpo_ent)->x, (dpoint+bot_dpo_ent)->y, (dpoint+bot_dpo_ent)->z);
#endif
			brkstat = 0;
			do {
				xetop = xe2num = xe3num = 0;
				for (j=i+1; j<=lst_xe_ent; j++) {
					if (xe[j].iostat == 2 || (xe[j].iostat == 3 && xe[j].d_link != i)) {
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: reconfig j=%d xedtop=%d d_link=%d\n", j, xe[j].xedtop, xe[j].d_link);
#endif
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: fa1=%d, fa2=%d, dp1=%d, dp2=%d bot_dpo_ent=%d\n", (xedge+xe[j].xedtop)->fa1, (xedge+xe[j].xedtop)->fa2, (xedge+xe[j].xedtop)->dp1, (xedge+xe[j].xedtop)->dp2, bot_dpo_ent);
#endif
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: dp1=%f %f %f\n", (dpoint+(xedge+xe[j].xedtop)->dp1)->x, (dpoint+(xedge+xe[j].xedtop)->dp1)->y, (dpoint+(xedge+xe[j].xedtop)->dp1)->z);
#endif
						if ((G_fac_equ((xedge+xe[j].xedtop)->fa1, fac_ent, breps) && !G_dpo_neq((xedge+xe[j].xedtop)->dp1, bot_dpo_ent, breps)) || (G_fac_equ((xedge+xe[j].xedtop)->fa2, fac_ent, breps) && !G_dpo_neq((xedge+xe[j].xedtop)->dp2, bot_dpo_ent, breps))) {
							if (xe[j].iostat == 2)
								xe2num++;
							else
								xe3num++;
							xe[j].r_link = xetop;
							xetop = j;
						}
						else
							xe[j].r_link = 0;
					}
				}
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: xe2num=%d xe3num=%d\n", xe2num, xe3num);
#endif
				nxt_xe_ent = 0;
				if (xe2num == 1) {
					xe[i].iostat |= 4;
					if (G_fac_equ(tp_xed2->fa1, fac_ent, breps)) {
						tp_dpo  = dpoint+tp_xed2->dp1;
						tp_dpo2 = dpoint+tp_xed2->dp2;
					}
					else {
						tp_dpo  = dpoint+tp_xed2->dp2;
						tp_dpo2 = dpoint+tp_xed2->dp1;
					}
					j = xetop;
					while (j) {
						if (xe[j].iostat == 2) {
							tp_xed3 = xedge+xe[j].xedmid;
							if (G_fac_equ(tp_xed3->fa1, fac_ent, breps)) {
								tp_dpo3 = dpoint+tp_xed3->dp1;
								tp_dpo4 = dpoint+tp_xed3->dp2;
							}
							else {
								tp_dpo3 = dpoint+tp_xed3->dp2;
								tp_dpo4 = dpoint+tp_xed3->dp1;
							}
							v_deg(tp_dpo->x, tp_dpo->y, tp_dpo->z, tp_dpo2->x, tp_dpo2->y, tp_dpo2->z, tp_dpo3->x, tp_dpo3->y, tp_dpo3->z, tp_dpo4->x, tp_dpo4->y, tp_dpo4->z, tp_dve->x, tp_dve->y, tp_dve->z, &tp_dbl);
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: deg=%f\n", tp_dbl);
#endif
							/* if (tp_xed3->fa1 && tp_xed3->fa2) */
							/* if (tp_xed3->fa1 && tp_xed3->fa2 && isabswhere(tp_dbl, 0.0, 360.0) == 0) */
							if (tp_xed3->fa1 && tp_xed3->fa2 && (isabswhere(tp_dbl, 0.0, 360.0) == 0 || ((G_fac_equ(tp_xed3->fa1, fac_ent, breps) && !G_dpo_neq(tp_xed3->dp2, top_dpo_ent, breps)) || (G_fac_equ(tp_xed3->fa2, fac_ent, breps) && !G_dpo_neq(tp_xed3->dp1, top_dpo_ent, breps)))))
								nxt_xe_ent = j;
						}
						j = xe[j].r_link;
					}
					if (nxt_xe_ent)
						xe[nxt_xe_ent].iostat |= 4;
				}
				else if (xe2num == 0 && xe3num == 1) {
					xe[i].iostat |= 4;
					if (G_fac_equ(tp_xed2->fa1, fac_ent, breps)) {
						tp_dpo  = dpoint+tp_xed2->dp1;
						tp_dpo2 = dpoint+tp_xed2->dp2;
					}
					else {
						tp_dpo  = dpoint+tp_xed2->dp2;
						tp_dpo2 = dpoint+tp_xed2->dp1;
					}
					j = xetop;
					while (j) {
						if (xe[j].iostat == 3) {
							tp_xed3 = xedge+xe[j].xedmid;
							if (G_fac_equ(tp_xed3->fa1, fac_ent, breps)) {
								tp_dpo3 = dpoint+tp_xed3->dp1;
								tp_dpo4 = dpoint+tp_xed3->dp2;
							}
							else {
								tp_dpo3 = dpoint+tp_xed3->dp2;
								tp_dpo4 = dpoint+tp_xed3->dp1;
							}
							v_deg(tp_dpo->x, tp_dpo->y, tp_dpo->z, tp_dpo2->x, tp_dpo2->y, tp_dpo2->z, tp_dpo3->x, tp_dpo3->y, tp_dpo3->z, tp_dpo4->x, tp_dpo4->y, tp_dpo4->z, tp_dve->x, tp_dve->y, tp_dve->z, &tp_dbl);
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: deg=%f\n", tp_dbl);
#endif
							/* if (tp_xed3->fa1 && tp_xed3->fa2) */
							/* if (tp_xed3->fa1 && tp_xed3->fa2 && isabswhere(tp_dbl, 0.0, 360.0) == 0) */
							if (tp_xed3->fa1 && tp_xed3->fa2 && (isabswhere(tp_dbl, 0.0, 360.0) == 0 || ((G_fac_equ(tp_xed3->fa1, fac_ent, breps) && !G_dpo_neq(tp_xed3->dp2, top_dpo_ent, breps)) || (G_fac_equ(tp_xed3->fa2, fac_ent, breps) && !G_dpo_neq(tp_xed3->dp1, top_dpo_ent, breps)))))
								nxt_xe_ent = j;
						}
						j = xe[j].r_link;
					}
					if (nxt_xe_ent) {
						xe[nxt_xe_ent].iostat |= 4;
						xe[xe[nxt_xe_ent].d_link].iostat |= 4;
						tp_xed3 = xedge+xe[xe[nxt_xe_ent].d_link].xedtop;
						if (G_fac_equ(tp_xed3->fa1, fac_ent, breps))
							tp_xed3->fa1 = 0;
						else
							tp_xed3->fa2 = 0;
					}
				}
				else if (xe2num > 0 || xe3num > 0) {
					xe[i].iostat |= 4;
					if (xe2num > 1)
						iosel = 2;
					else
						iosel = 3;
					if (G_fac_equ(tp_xed2->fa1, fac_ent, breps)) {
						tp_dpo  = dpoint+tp_xed2->dp1;
						tp_dpo2 = dpoint+tp_xed2->dp2;
					}
					else {
						tp_dpo  = dpoint+tp_xed2->dp2;
						tp_dpo2 = dpoint+tp_xed2->dp1;
					}
					if (op == C_UN)
						sdeg = -360.0;
					else if (op == C_INT || op == C_DIF)
						sdeg = 360.0;
					j = xetop;
					while (j) {
						if (xe[j].iostat == iosel) {
							tp_xed3 = xedge+xe[j].xedmid;
							if (G_fac_equ(tp_xed3->fa1, fac_ent, breps)) {
								tp_dpo3 = dpoint+tp_xed3->dp1;
								tp_dpo4 = dpoint+tp_xed3->dp2;
							}
							else {
								tp_dpo3 = dpoint+tp_xed3->dp2;
								tp_dpo4 = dpoint+tp_xed3->dp1;
							}
							v_deg(tp_dpo->x, tp_dpo->y, tp_dpo->z, tp_dpo2->x, tp_dpo2->y, tp_dpo2->z, tp_dpo3->x, tp_dpo3->y, tp_dpo3->z, tp_dpo4->x, tp_dpo4->y, tp_dpo4->z, tp_dve->x, tp_dve->y, tp_dve->z, &tp_dbl);
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: deg=%f\n", tp_dbl);
#endif
							if (tp_xed3->fa1 && tp_xed3->fa2 && isabswhere(tp_dbl, 0.0, 360.0) == 0 && ((op == C_UN && tp_dbl >= sdeg) || ((op == C_INT || op == C_DIF) && tp_dbl <= sdeg))) {
							/* if (tp_xed3->fa1 && tp_xed3->fa2 && ((isabswhere(tp_dbl, 0.0, 360.0) == 0 && ((op == C_UN && tp_dbl >= sdeg) || ((op == C_INT || op == C_DIF) && tp_dbl <= sdeg))) || (((G_fac_equ(tp_xed3->fa1, fac_ent, breps) && !G_dpo_neq(tp_xed3->dp2, top_dpo_ent, breps)) || (G_fac_equ(tp_xed3->fa2, fac_ent, breps) && !G_dpo_neq(tp_xed3->dp1, top_dpo_ent, breps))) && ((op == C_UN && tp_dbl >= sdeg) || ((op == C_INT || op == C_DIF) && tp_dbl <= sdeg))))) { */
								sdeg = tp_dbl;
								nxt_xe_ent = j;
							}
						}
						j = xe[j].r_link;
					}
					if (nxt_xe_ent) {
						xe[nxt_xe_ent].iostat |= 4;
						if (iosel == 3) {
							xe[xe[nxt_xe_ent].d_link].iostat |= 4;
							tp_xed3 = xedge+xe[xe[nxt_xe_ent].d_link].xedtop;
							if (G_fac_equ(tp_xed3->fa1, fac_ent, breps))
								tp_xed3->fa1 = 0;
							else
								tp_xed3->fa2 = 0;
						}
					}
				}
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: nxt_xe_ent=%d d_link=%d\n", nxt_xe_ent, xe[nxt_xe_ent].d_link);
#endif
				if (nxt_xe_ent) {
					if (G_fac_equ(tp_xed2->fa1, fac_ent, breps))
						tp_xed2->link1 = xe[nxt_xe_ent].xedtop;
					else
						tp_xed2->link2 = xe[nxt_xe_ent].xedtop;
					tp_xed2 = xedge+(bot_xed_ent = xe[nxt_xe_ent].xedbot);
					if (G_fac_equ(tp_xed2->fa1, fac_ent, breps))
						bot_dpo_ent = tp_xed2->dp2;
					else
						bot_dpo_ent = tp_xed2->dp1;
#ifdef DEBUG
fprintf(stderr, "G_fac_reconfig: bot_dpo=%f %f %f\n", (dpoint+bot_dpo_ent)->x, (dpoint+bot_dpo_ent)->y, (dpoint+bot_dpo_ent)->z);
#endif
					brkstat = 1;
				}
				else {
					brkstat = 0;
					break;
				}
			} while (G_dpo_neq(top_dpo_ent, bot_dpo_ent, breps));
			if (brkstat) {
				if (G_fac_equ(tp_xed2->fa1, fac_ent, breps))
					tp_xed2->link1 = top_xed_ent;
				else
					tp_xed2->link2 = top_xed_ent;
				nxt_xlo_ent = aloc_xlo(brep_ent, breps);
				if (sav_xlo_ent == 0)
					(face+fac_ent)->xlotop = sav_xlo_ent = nxt_xlo_ent;
				else
					(xloop+cur_xlo_ent)->r_link = nxt_xlo_ent;
				(xloop+nxt_xlo_ent)->r_link = sav_xlo_ent;
				(xloop+nxt_xlo_ent)->xedtop = top_xed_ent;
				cur_xlo_ent = nxt_xlo_ent;
			}
			else {
				cur_xed_ent = top_xed_ent;
				for(;;) {
					tp_xed = xedge+cur_xed_ent;
					if (G_fac_equ(tp_xed->fa1, fac_ent, breps)) {
						tp_xed->fa1 = 0;
						nxt_xed_ent = tp_xed->link1;
					}
					else {
						tp_xed->fa2 = 0;
						nxt_xed_ent = tp_xed->link2;
					}
					if (cur_xed_ent == bot_xed_ent)
						break;
					else
						cur_xed_ent = nxt_xed_ent;
				}
				break;
			}
			break;
		case 3: /* dyadic xed */
			tp_xed3 = xedge+xe[i].xedtop;
			if (G_fac_equ(tp_xed3->fa1, fac_ent, breps))
				tp_xed3->fa1 = 0;
			else
				tp_xed3->fa2 = 0;
			tp_xed3 = xedge+xe[xe[i].d_link].xedtop;
			if (G_fac_equ(tp_xed3->fa1, fac_ent, breps))
				tp_xed3->fa1 = 0;
			else
				tp_xed3->fa2 = 0;
			break;
		case 6: /* xed already used */
		case 7: /* exx already used */
			break;
		default:
			break;
		}
	}
}
G_fac_filter(fac_ent, brep_ent, breps)
	int			fac_ent, brep_ent;
	struct breps		*breps;
{
	register struct face	*face  = breps->face;
	register struct xloop	*xloop = breps->xloop;
	register struct xedge	*xedge = breps->xedge;
	register struct xedge	*tp_xed;
	register int		cur_xlo_ent, sav_xlo_ent;
	register int		prv_xlo_ent, nxt_xlo_ent;
	register int		cur_xed_ent, sav_xed_ent;
	int			brkstat;

	if (fac_ent == 0 || brep_ent == 0)
		return;

	if ((face+fac_ent)->xlotop == 0)
		return;

	cur_xlo_ent = sav_xlo_ent = (face+fac_ent)->xlotop;
	do {
		nxt_xlo_ent = (xloop+cur_xlo_ent)->r_link;
		brkstat = 0;
		cur_xed_ent = sav_xed_ent = (xloop+cur_xlo_ent)->xedtop;
		do {
			tp_xed  = xedge+cur_xed_ent;
			if (tp_xed->fa1 == 0 || tp_xed->fa2 == 0) {
				brkstat = 1;
#ifdef DEBUG
fprintf(stderr, "G_fac_filter:fac %d(%d %d) %4g %4g %4g %4g %4g %4g\n", fac_ent, tp_xed->fa1, tp_xed->fa2, (dpoint+tp_xed->dp1)->x, (dpoint+tp_xed->dp1)->y, (dpoint+tp_xed->dp1)->z, (dpoint+tp_xed->dp2)->x, (dpoint+tp_xed->dp2)->y, (dpoint+tp_xed->dp2)->z);
#endif
fprintf(stderr, "X");
			}
			if (G_fac_equ(tp_xed->fa1, fac_ent, breps))
				cur_xed_ent = tp_xed->link1;
			else
				cur_xed_ent = tp_xed->link2;
		} while (cur_xed_ent != sav_xed_ent);
		if (brkstat) {
			cur_xed_ent = sav_xed_ent = (xloop+cur_xlo_ent)->xedtop;
			do {
				tp_xed  = xedge+cur_xed_ent;
				if (G_fac_equ(tp_xed->fa1, fac_ent, breps)) {
					tp_xed->fa1 = 0;
					cur_xed_ent = tp_xed->link1;
				}
				else {
					tp_xed->fa2 = 0;
					cur_xed_ent = tp_xed->link2;
				}
			} while (cur_xed_ent != sav_xed_ent);
			(xloop+cur_xlo_ent)->xedtop = 0;
		}
	} while ((cur_xlo_ent = nxt_xlo_ent) != sav_xlo_ent);

	prv_xlo_ent = 0;
	cur_xlo_ent = sav_xlo_ent = (face+fac_ent)->xlotop;
	do {
		nxt_xlo_ent = (xloop+cur_xlo_ent)->r_link;
		if ((xloop+cur_xlo_ent)->xedtop) {
			if (prv_xlo_ent == 0)
				(face+fac_ent)->xlotop = cur_xlo_ent;
			else
				(xloop+prv_xlo_ent)->r_link = cur_xlo_ent;
			(xloop+cur_xlo_ent)->r_link = (face+fac_ent)->xlotop;
			prv_xlo_ent = cur_xlo_ent;
		}
		else
			free_xlo(cur_xlo_ent, brep_ent, breps);
	} while ((cur_xlo_ent = nxt_xlo_ent) != sav_xlo_ent);
	if (prv_xlo_ent == 0)
		(face+fac_ent)->xlotop = 0;
}
G_xed_filter(xed_ent, brep_ent, breps)
	register int		xed_ent, brep_ent;
	register struct breps	*breps;
{
	register struct xedge	*xedge = breps->xedge;
	register struct xedge	*tp_xed;

	if (xed_ent == 0 || brep_ent == 0)
		return;

	tp_xed = xedge+xed_ent;
	
	if (tp_xed->fa1 == 0 || tp_xed->fa2 == 0) {
		dref_dpo(tp_xed->dp1, brep_ent, breps);
		dref_dpo(tp_xed->dp2, brep_ent, breps);
		dref_dve(tp_xed->dv1, brep_ent, breps);
		dref_dve(tp_xed->dv2, brep_ent, breps);
		free_xed(xed_ent, brep_ent, breps);
	}
}
G_dpo_filter(dpo_ent, brep_ent, breps)
	register int		dpo_ent, brep_ent;
	register struct breps	*breps;
{
	register struct dpoint	*dpoint = breps->dpoint;

	if (dpo_ent == 0 || brep_ent == 0)
		return;

	if ((dpoint+dpo_ent)->ref == 0)
		free_dpo(dpo_ent, brep_ent, breps);
}
G_fac_proper(fac_ent, breps)
	register int		fac_ent;
	register struct breps	*breps;
{
	register struct face	*face  = breps->face;
	register struct dvect	*dvect = breps->dvect;
	register struct face	*tp_fac;

	if (fac_ent == 0)
		return;

	tp_fac = face+fac_ent;

	if (tp_fac->xlotop == 0)
		return;

	if ((dvect+tp_fac->favect)->a_link)
		tp_fac->favect = (dvect+tp_fac->favect)->a_link;
}
G_xed_proper(xed_ent, breps)
	int			xed_ent;
	struct breps		*breps;
{
	struct face		*face   = breps->face;
	register struct xedge	*xedge  = breps->xedge;
	register struct dpoint	*dpoint = breps->dpoint;
	register struct dvect	*dvect  = breps->dvect;
	register struct xedge	*tp_xed;

	if (xed_ent == 0)
		return;

	tp_xed = xedge+xed_ent;
	
	if ((face+tp_xed->fa1)->a_link)
		tp_xed->fa1 = (face+tp_xed->fa1)->a_link;
	if ((face+tp_xed->fa2)->a_link)
		tp_xed->fa2 = (face+tp_xed->fa2)->a_link;
	if ((dpoint+tp_xed->dp1)->a_link)
		tp_xed->dp1 = (dpoint+tp_xed->dp1)->a_link;
	if ((dpoint+tp_xed->dp2)->a_link)
		tp_xed->dp2 = (dpoint+tp_xed->dp2)->a_link;
	if ((dvect+tp_xed->dv1)->a_link)
		tp_xed->dv1 = (dvect+tp_xed->dv1)->a_link;
	if ((dvect+tp_xed->dv2)->a_link)
		tp_xed->dv2 = (dvect+tp_xed->dv2)->a_link;
}
G_dpo_proper(dpo_ent, breps)
	register int		dpo_ent;
	register struct breps	*breps;
{
	register struct dpoint	*dpoint = breps->dpoint;
	register struct dpoint	*tp_dpo;
	register int		nxt_dpo_ent, min_dpo_ent;

	if (dpo_ent == 0)
		return;

	min_dpo_ent = dpo_ent;
	while (nxt_dpo_ent = (dpoint+min_dpo_ent)->a_link)
		min_dpo_ent = nxt_dpo_ent;
	if (min_dpo_ent != dpo_ent) {
		(tp_dpo = dpoint+dpo_ent)->a_link = min_dpo_ent;
		(dpoint+min_dpo_ent)->ref += tp_dpo->ref;
		tp_dpo->ref = 0;
	}
}
G_fac_equ(fac_ent, fac2_ent, breps)
	register int		fac_ent, fac2_ent;
	register struct breps	*breps;
{
	register struct face	*face = breps->face;
	register struct face	*tp_fac, *tp_fac2;

	if (fac_ent == 0 || fac2_ent == 0)
		return(0);

	if (fac_ent == fac2_ent)
		return(1);

	tp_fac  = face+fac_ent;
	tp_fac2 = face+fac2_ent;

	while (tp_fac ->a_link)
		tp_fac  = face+tp_fac ->a_link;
	while (tp_fac2->a_link)
		tp_fac2 = face+tp_fac2->a_link;
	return(tp_fac == tp_fac2);
}
G_xed_equ(xed_ent, xed2_ent, l_breps, r_breps)
	register int		xed_ent, xed2_ent;
	register struct breps	*l_breps, *r_breps;
{
	register struct xedge	*lxedge = l_breps->xedge;
	register struct xedge	*rxedge = r_breps->xedge;
	register int		min_xed_ent, min_xed2_ent, nxt_xed_ent;

	if (xed_ent == 0 || xed2_ent == 0)
		return(0);

	min_xed_ent  = xed_ent;
	min_xed2_ent = xed2_ent;
	while (nxt_xed_ent = (lxedge+min_xed_ent) ->a_link)
		min_xed_ent  = nxt_xed_ent;
	while (nxt_xed_ent = (rxedge+min_xed2_ent)->a_link)
		min_xed2_ent = nxt_xed_ent;
	return(min_xed_ent == min_xed2_ent);
}

