
/* csg_traverse.c	87/8/10 */

#include "dsm.h"

csg_trav(cur_csg_ent, cur_col, cur_mot, breps)
	int		cur_csg_ent;
	double		cur_col;
	struct motion	*cur_mot;
	struct breps	*breps;
{
	struct brep	*brep   = breps->brep;
	struct face	*face   = breps->face;
	struct dpoint	*dpoint = breps->dpoint;
	struct dvect	*dvect  = breps->dvect;
	struct brep	*tp_brep;
	struct dpoint	*tp_dpo;
	struct dvect	*tp_dve;
	struct csg	*tp_csg;
	struct motion	tp_mot, tp_mot2;
	double		max();
	int		i;

	if (cur_csg_ent == 0)
		return;

	tp_csg = &csg[cur_csg_ent];
	m_comp(cur_mot, &motion[tp_csg->mot_ent], &tp_mot);
	if (cur_col < 0.0)
		cur_col = tp_csg->col;

	if (tp_csg->type == C_PRIMITIVE) {
		tp_brep = brep+(tp_csg->brep_ent = expand_prim(tp_csg->prim_ent, breps));
		tp_brep->dpocex = tp_mot.p1;
		tp_brep->dpocey = tp_mot.p2;
		tp_brep->dpocez = tp_mot.p3;
		tp_brep->maxdpo *= max(tp_csg->x, max(tp_csg->y, tp_csg->z));
		m_copy(&tp_mot, &tp_mot2);
		m_pmodif(tp_csg->x, tp_csg->y, tp_csg->z, &tp_mot, &tp_mot);
		m_vmodif(tp_csg->x, tp_csg->y, tp_csg->z, &tp_mot2, &tp_mot2);

		for (i=tp_brep->dpotop; i<tp_brep->dpotop+tp_brep->dponum; i++) {
			tp_dpo = dpoint+i;
			m_papply(&tp_mot, tp_dpo->x, tp_dpo->y, tp_dpo->z, &(tp_dpo->x), &(tp_dpo->y), &(tp_dpo->z));
		}
		for (i=tp_brep->dvetop; i<tp_brep->dvetop+tp_brep->dvenum; i++) {
			tp_dve = dvect+i;
			m_vapply(&tp_mot2, tp_dve->x, tp_dve->y, tp_dve->z, &(tp_dve->x), &(tp_dve->y), &(tp_dve->z));
		}

		if (cur_col >= 0.0) {
			for (i=tp_brep->factop; i<tp_brep->factop+tp_brep->facnum; i++)
				(face+i)->facolor = cur_col;
		}
	}
	else {
		csg_trav(tp_csg->l_link, cur_col, &tp_mot, breps);
		csg_trav(tp_csg->r_link, cur_col, &tp_mot, breps);
		tp_csg->brep_ent = csg[tp_csg->l_link].brep_ent;
	}
}
clr_breps(breps) register struct breps *breps;
{
	breps->ls_brep_ent = 0;
	breps->ls_fac_ent  = 0;
	breps->ls_xlo_ent  = 0;
	breps->ls_xed_ent  = 0;
	breps->ls_dpo_ent  = 0;
	breps->ls_dve_ent  = 0;
	breps->fre_xlo_ent = 0;
	breps->fre_xed_ent = 0;
	breps->fre_dpo_ent = 0;
	breps->fre_dve_ent = 0;
}
clr_facwork(brep_ent, breps) int brep_ent; struct breps *breps;
{
	register struct brep	*brep = breps->brep;
	register struct face	*face = breps->face;
	register struct brep	*tp_brep;
	register int		i;

	if (brep_ent == 0)
		return;

	tp_brep = brep+brep_ent;
	for (i=tp_brep->factop; i<tp_brep->factop+tp_brep->facnum; i++) {
		(face+i)->a_link = 0;
		(face+i)->exxtop = 0;
	}
}
clr_xedwork(brep_ent, breps) int brep_ent; struct breps *breps;
{
	register struct brep	*brep  = breps->brep;
	register struct xedge	*xedge = breps->xedge;
	register struct brep	*tp_brep;
	register struct xedge	*tp_xed;
	register int		i;

	if (brep_ent == 0)
		return;

	tp_brep = brep+brep_ent;
	for (tp_xed=xedge+tp_brep->xedtop, i=1; i<=tp_brep->xednum; i++) {
		tp_xed->io1    = 0.0;
		tp_xed->io2    = 0.0;
		tp_xed->bd2    = 0;
		tp_xed->bd2    = 0;
		tp_xed->a_link = 0;
		tp_xed = xedge+tp_xed->br_link;
	}
}
clr_dpowork(brep_ent, breps) int brep_ent; struct breps *breps;
{
	register struct brep	*brep   = breps->brep;
	register struct dpoint	*dpoint = breps->dpoint;
	register struct brep	*tp_brep;
	register struct dpoint	*tp_dpo;
	register int		i;

	if (brep_ent == 0)
		return;

	tp_brep = brep+brep_ent;
	for (tp_dpo=dpoint+tp_brep->dpotop, i=1; i<=tp_brep->dponum; i++) {
		tp_dpo->a_link = 0;
		tp_dpo->pxxtop = 0;
		tp_dpo = dpoint+tp_dpo->br_link;
	}
}
clr_dvework(brep_ent, breps) int brep_ent; struct breps *breps;
{
	register struct brep	*brep  = breps->brep;
	register struct dvect	*dvect = breps->dvect;
	register struct brep	*tp_brep;
	register struct dvect	*tp_dve;
	register int		i;

	if (brep_ent == 0)
		return;

	tp_brep = brep+brep_ent;
	for (tp_dve=dvect+tp_brep->dvetop, i=1; i<=tp_brep->dvenum; i++) {
		tp_dve->a_link = 0;
		tp_dve = dvect+tp_dve->br_link;
	}
}
clr_pxx(breps) register struct breps *breps;
{
	breps->ls_pxx_ent = 0;
}
clr_exx(breps) register struct breps *breps;
{
	breps->ls_exx_ent = 0;
}
aloc_xlo(brep_ent, breps) register int brep_ent; register struct breps *breps;
{
	register struct brep	*brep  = (breps->brep)+brep_ent;
	register struct xloop	*xloop = breps->xloop;
	register struct xloop	*tp_xlo;
	int			*ls_xlo_ent = &(breps->ls_xlo_ent);
	register int		i, j, k;

	if (brep_ent == 0)
		return(0);

	if (breps->fre_xlo_ent) {
		i = breps->fre_xlo_ent;
		breps->fre_xlo_ent = (xloop+breps->fre_xlo_ent)->br_link;
	}
	else {
		if ((i = ++(*ls_xlo_ent)) > XLO_SIZE) {
			fprintf(stderr, "aloc_xlo: current XLO_SIZE is %d\n", XLO_SIZE);
			exit(1);
		}
	}
	tp_xlo = xloop+i;
	if (brep->xlonum++) {
		j = brep->xlotop;
		k = (xloop+j)->bl_link;
		tp_xlo   ->bl_link = k;
		tp_xlo   ->br_link = j;
		(xloop+j)->bl_link = i;
		(xloop+k)->br_link = i;
	}
	else {
		brep->xlotop = i;
		tp_xlo->bl_link = i;
		tp_xlo->br_link = i;
	}
	tp_xlo->r_link = 0;
	tp_xlo->xedtop = 0;
	return(i);
}
aloc_xed(brep_ent, breps) register int brep_ent; register struct breps *breps;
{
	register struct brep	*brep  = (breps->brep)+brep_ent;
	register struct xedge	*xedge = breps->xedge;
	register struct xedge	*tp_xed;
	int			*ls_xed_ent = &(breps->ls_xed_ent);
	register int		i, j, k;

	if (brep_ent == 0)
		return(0);

	if (breps->fre_xed_ent) {
		i = breps->fre_xed_ent;
		breps->fre_xed_ent = (xedge+breps->fre_xed_ent)->br_link;
	}
	else {
		if ((i = ++(*ls_xed_ent)) > XED_SIZE) {
			fprintf(stderr, "aloc_xed: current XED_SIZE is %d\n", XED_SIZE);
			exit(1);
		}
	}
	tp_xed = xedge+i;
	if (brep->xednum++) {
		j = brep->xedtop;
		k = (xedge+j)->bl_link;
		tp_xed   ->bl_link = k;
		tp_xed   ->br_link = j;
		(xedge+j)->bl_link = i;
		(xedge+k)->br_link = i;
	}
	else {
		brep->xedtop = i;
		tp_xed->bl_link = i;
		tp_xed->br_link = i;
	}
	tp_xed->io1   = 0.0;
	tp_xed->io2   = 0.0;
	tp_xed->bd1   = 0;
	tp_xed->bd2   = 0;
	tp_xed->link1 = 0;
	tp_xed->link2 = 0;
	tp_xed->fa1   = 0;
	tp_xed->fa2   = 0;
	tp_xed->dp1   = 0;
	tp_xed->dp2   = 0;
	tp_xed->dv1   = 0;
	tp_xed->dv2   = 0;
	return(i);
}
aloc_dpo(brep_ent, breps) register int brep_ent; register struct breps *breps;
{
	register struct brep	*brep   = (breps->brep)+brep_ent;
	register struct dpoint	*dpoint = breps->dpoint;
	register struct dpoint	*tp_dpo;
	int			*ls_dpo_ent = &(breps->ls_dpo_ent);
	register int		i, j, k;

	if (brep_ent == 0)
		return(0);

	if (breps->fre_dpo_ent) {
		i = breps->fre_dpo_ent;
		breps->fre_dpo_ent = (dpoint+breps->fre_dpo_ent)->br_link;
	}
	else {
		if ((i = ++(*ls_dpo_ent)) > DPO_SIZE) {
			fprintf(stderr, "aloc_dpo: current DPO_SIZE is %d\n", DPO_SIZE);
			exit(1);
		}
	}
	tp_dpo = dpoint+i;
	if (brep->dponum++) {
		j = brep->dpotop;
		k = (dpoint+j)->bl_link;
		tp_dpo    ->bl_link = k;
		tp_dpo    ->br_link = j;
		(dpoint+j)->bl_link = i;
		(dpoint+k)->br_link = i;
	}
	else {
		brep->dpotop = i;
		tp_dpo->bl_link = i;
		tp_dpo->br_link = i;
	}
	tp_dpo->x      = 0.0;
	tp_dpo->y      = 0.0;
	tp_dpo->z      = 0.0;
	tp_dpo->ref    = 0;
	tp_dpo->a_link = 0;
	tp_dpo->pxxtop = 0;
	return(i);
}
aloc_dve(brep_ent, breps) register int brep_ent; register struct breps *breps;
{
	register struct brep	*brep  = (breps->brep)+brep_ent;
	register struct dvect	*dvect = breps->dvect;
	register struct dvect	*tp_dve;
	int			*ls_dve_ent = &(breps->ls_dve_ent);
	register int		i, j, k;

	if (brep_ent == 0)
		return(0);

	if (breps->fre_dve_ent) {
		i = breps->fre_dve_ent;
		breps->fre_dve_ent = (dvect+breps->fre_dve_ent)->br_link;
	}
	else {
		if ((i = ++(*ls_dve_ent)) > DVE_SIZE) {
			fprintf(stderr, "aloc_dve: current DVE_SIZE is %d\n", DVE_SIZE);
			exit(1);
		}
	}
	tp_dve = dvect+i;
	if (brep->dvenum++) {
		j = brep->dvetop;
		k = (dvect+j)->bl_link;
		tp_dve   ->bl_link = k;
		tp_dve   ->br_link = j;
		(dvect+j)->bl_link = i;
		(dvect+k)->br_link = i;
	}
	else {
		brep->dvetop = i;
		tp_dve->bl_link = i;
		tp_dve->br_link = i;
	}
	tp_dve->x      = 0.0;
	tp_dve->y      = 0.0;
	tp_dve->z      = 0.0;
	tp_dve->ref    = 0;
	tp_dve->a_link = 0;
	return(i);
}
free_xlo(xlo_ent, brep_ent, breps)
	register int		xlo_ent, brep_ent;
	register struct breps	*breps;
{
	register struct brep	*brep  = (breps->brep)+brep_ent;
	register struct xloop	*xloop = breps->xloop;
	register int		j, k;

	if (xlo_ent == 0 || brep_ent == 0)
		return;

	if (--(brep->xlonum)) {
		j = (xloop+xlo_ent)->br_link;
		k = (xloop+xlo_ent)->bl_link;
		(xloop+j)->bl_link = k;
		(xloop+k)->br_link = j;
		if (xlo_ent == brep->xlotop)
			brep->xlotop = (xloop+xlo_ent)->br_link;
	}
	else
		brep->xlotop = 0;
	(xloop+xlo_ent)->br_link = breps->fre_xlo_ent;
	breps->fre_xlo_ent = xlo_ent;
}
free_xed(xed_ent, brep_ent, breps)
	register int		xed_ent, brep_ent;
	register struct breps	*breps;
{
	register struct brep	*brep  = (breps->brep)+brep_ent;
	register struct xedge	*xedge = breps->xedge;
	register int		j, k;

	if (xed_ent == 0 || brep_ent == 0)
		return;

	if (--(brep->xednum)) {
		j = (xedge+xed_ent)->br_link;
		k = (xedge+xed_ent)->bl_link;
		(xedge+j)->bl_link = k;
		(xedge+k)->br_link = j;
		if (xed_ent == brep->xedtop)
			brep->xedtop = (xedge+xed_ent)->br_link;
	}
	else
		brep->xedtop = 0;
	(xedge+xed_ent)->br_link = breps->fre_xed_ent;
	breps->fre_xed_ent = xed_ent;
}
free_dpo(dpo_ent, brep_ent, breps)
	register int		dpo_ent, brep_ent;
	register struct breps	*breps;
{
	register struct brep	*brep   = (breps->brep)+brep_ent;
	register struct dpoint	*dpoint = breps->dpoint;
	register int		j, k;

	if (dpo_ent == 0 || brep_ent == 0)
		return;

	if (--(brep->dponum)) {
		j = (dpoint+dpo_ent)->br_link;
		k = (dpoint+dpo_ent)->bl_link;
		(dpoint+j)->bl_link = k;
		(dpoint+k)->br_link = j;
		if (dpo_ent == brep->dpotop)
			brep->dpotop = (dpoint+dpo_ent)->br_link;
	}
	else
		brep->dpotop = 0;
	(dpoint+dpo_ent)->br_link = breps->fre_dpo_ent;
	breps->fre_dpo_ent = dpo_ent;
}
free_dve(dve_ent, brep_ent, breps)
	register int		dve_ent, brep_ent;
	register struct breps	*breps;
{
	register struct brep	*brep  = (breps->brep)+brep_ent;
	register struct dvect	*dvect = breps->dvect;
	register int		j, k;

	if (dve_ent == 0 || brep_ent == 0)
		return;

	if (--(brep->dvenum)) {
		j = (dvect+dve_ent)->br_link;
		k = (dvect+dve_ent)->bl_link;
		(dvect+j)->bl_link = k;
		(dvect+k)->br_link = j;
		if (dve_ent == brep->dvetop)
			brep->dvetop = (dvect+dve_ent)->br_link;
	}
	else
		brep->dvetop = 0;
	(dvect+dve_ent)->br_link = breps->fre_dve_ent;
	breps->fre_dve_ent = dve_ent;
}
merg_xlo(brep_ent, brep2_ent, breps)
	int			brep_ent, brep2_ent;
	struct breps		*breps;
{
	register struct brep	*brep  = breps->brep;
	register struct xloop	*xloop = breps->xloop;
	register struct brep	*tp_brep, *tp_brep2;
	register int		i, j, k, l;

	if (brep_ent == 0 || brep2_ent == 0)
		return;

	tp_brep  = brep+brep_ent;
	tp_brep2 = brep+brep2_ent;
	if (tp_brep2->xlonum) {
		if (tp_brep->xlonum) {
			i = tp_brep  ->xlotop;
			j = tp_brep2 ->xlotop;
			k = (xloop+i)->bl_link;
			l = (xloop+j)->bl_link;
			(xloop+i)->bl_link = l;
			(xloop+j)->bl_link = k;
			(xloop+k)->br_link = j;
			(xloop+l)->br_link = i;
		}
		else
			tp_brep->xlotop = tp_brep2->xlotop;
		tp_brep ->xlonum += tp_brep2->xlonum;
		tp_brep2->xlotop = 0;
		tp_brep2->xlonum = 0;
	}
}
merg_xed(brep_ent, brep2_ent, breps)
	int			brep_ent, brep2_ent;
	struct breps		*breps;
{
	register struct brep	*brep  = breps->brep;
	register struct xedge	*xedge = breps->xedge;
	register struct brep	*tp_brep, *tp_brep2;
	register int		i, j, k, l;

	if (brep_ent == 0 || brep2_ent == 0)
		return;

	tp_brep  = brep+brep_ent;
	tp_brep2 = brep+brep2_ent;
	if (tp_brep2->xednum) {
		if (tp_brep->xednum) {
			i = tp_brep  ->xedtop;
			j = tp_brep2 ->xedtop;
			k = (xedge+i)->bl_link;
			l = (xedge+j)->bl_link;
			(xedge+i)->bl_link = l;
			(xedge+j)->bl_link = k;
			(xedge+k)->br_link = j;
			(xedge+l)->br_link = i;
		}
		else
			tp_brep->xedtop = tp_brep2->xedtop;
		tp_brep ->xednum += tp_brep2->xednum;
		tp_brep2->xedtop = 0;
		tp_brep2->xednum = 0;
	}
}
merg_dpo(brep_ent, brep2_ent, breps)
	int			brep_ent, brep2_ent;
	struct breps		*breps;
{
	register struct brep	*brep   = breps->brep;
	register struct dpoint	*dpoint = breps->dpoint;
	register struct brep	*tp_brep, *tp_brep2;
	register int		i, j, k, l;

	if (brep_ent == 0 || brep2_ent == 0)
		return;

	tp_brep  = brep+brep_ent;
	tp_brep2 = brep+brep2_ent;
	if (tp_brep2->dponum) {
		if (tp_brep->dponum) {
			i = tp_brep  ->dpotop;
			j = tp_brep2 ->dpotop;
			k = (dpoint+i)->bl_link;
			l = (dpoint+j)->bl_link;
			(dpoint+i)->bl_link = l;
			(dpoint+j)->bl_link = k;
			(dpoint+k)->br_link = j;
			(dpoint+l)->br_link = i;
		}
		else
			tp_brep->dpotop = tp_brep2->dpotop;
		tp_brep ->dponum += tp_brep2->dponum;
		tp_brep2->dpotop = 0;
		tp_brep2->dponum = 0;
	}
}
merg_dve(brep_ent, brep2_ent, breps)
	int			brep_ent, brep2_ent;
	struct breps		*breps;
{
	register struct brep	*brep  = breps->brep;
	register struct dvect	*dvect = breps->dvect;
	register struct brep	*tp_brep, *tp_brep2;
	register int		i, j, k, l;

	if (brep_ent == 0 || brep2_ent == 0)
		return;

	tp_brep  = brep+brep_ent;
	tp_brep2 = brep+brep2_ent;
	if (tp_brep2->dvenum) {
		if (tp_brep->dvenum) {
			i = tp_brep  ->dvetop;
			j = tp_brep2 ->dvetop;
			k = (dvect+i)->bl_link;
			l = (dvect+j)->bl_link;
			(dvect+i)->bl_link = l;
			(dvect+j)->bl_link = k;
			(dvect+k)->br_link = j;
			(dvect+l)->br_link = i;
		}
		else
			tp_brep->dvetop = tp_brep2->dvetop;
		tp_brep ->dvenum += tp_brep2->dvenum;
		tp_brep2->dvetop = 0;
		tp_brep2->dvenum = 0;
	}
}
iref_dpo(dpo_ent, breps) register int dpo_ent; register struct breps *breps;
{
	if (dpo_ent == 0)
		return;

	((breps->dpoint)+dpo_ent)->ref++;
}
iref_dve(dve_ent, breps) register int dve_ent; register struct breps *breps;
{
	if (dve_ent == 0)
		return;

	((breps->dvect)+dve_ent)->ref++;
}
dref_dpo(dpo_ent, brep_ent, breps)
	register int		dpo_ent, brep_ent;
	register struct breps	*breps;
{
	register struct dpoint	*dpoint = breps->dpoint;

	if (dpo_ent == 0 || brep_ent == 0)
		return;

	if ((dpoint+dpo_ent)->ref)
		(dpoint+dpo_ent)->ref--;
}
dref_dve(dve_ent, brep_ent, breps)
	register int		dve_ent, brep_ent;
	register struct breps	*breps;
{
	register struct dvect	*dvect = breps->dvect;

	if (dve_ent == 0 || brep_ent == 0)
		return;

	if ((dvect+dve_ent)->ref)
		(dvect+dve_ent)->ref--;
}
add_pxx(fac_ent, xed_ent, dpo_ent, breps)
	register int		fac_ent, xed_ent, dpo_ent;
	register struct breps	*breps;
{
	register struct dpoint	*dpoint = breps->dpoint;
	register struct pxx	*pxx    = breps->pxx;
	int			*ls_pxx_ent = &(breps->ls_pxx_ent);
	register struct dpoint	*tp_dpo;
	register int		i;

	if (fac_ent == 0 || xed_ent == 0 || dpo_ent == 0)
		return;

	if ((i = ++(*ls_pxx_ent)) > PXX_SIZE) {
		fprintf(stderr, "add_pxx: current PXX_SIZE is %d\n", PXX_SIZE);
		exit(1);
	}
	tp_dpo = dpoint+dpo_ent;
	while (tp_dpo->a_link)
		tp_dpo = dpoint+tp_dpo->a_link;
	(pxx+i)->r_link = tp_dpo->pxxtop;
	(pxx+i)->fac    = fac_ent;
	(pxx+i)->xed    = xed_ent;
	tp_dpo->pxxtop = i;
}
add_exx(fac_ent, xed_ent, xed2_ent, breps)
	register int		fac_ent, xed_ent, xed2_ent;
	register struct breps	*breps;
{
	register struct face	*face = breps->face;
	register struct exx	*exx  = breps->exx;
	register int		*ls_exx_ent  = &(breps->ls_exx_ent);
	register int		i;

	if (fac_ent == 0 || xed_ent == 0)
		return;

	if ((i = ++(*ls_exx_ent)) > EXX_SIZE) {
		fprintf(stderr, "add_exx: current EXX_SIZE is %d\n", EXX_SIZE);
		exit(1);
	}
	(exx+i)->r_link = (face+fac_ent)->exxtop;
	(exx+i)->d_link = 0;
	(exx+i)->xed    = xed_ent;
	(face+fac_ent)->exxtop = i;

	if (xed2_ent) {
		if ((i = ++(*ls_exx_ent)) > EXX_SIZE) {
			fprintf(stderr, "add_exx: current EXX_SIZE is %d\n", EXX_SIZE);
			exit(1);
		}
		(exx+i  )->r_link = (face+fac_ent)->exxtop;
		(exx+i  )->d_link = i-1;
		(exx+i-1)->d_link = i;
		(exx+i  )->xed    = xed2_ent;
		(face+fac_ent)->exxtop = i;
	}
}
merg_pxx(dpo_ent, dpo2_ent, breps)
	int			dpo_ent, dpo2_ent;
	struct breps		*breps;
{
	struct dpoint		*dpoint = breps->dpoint;
	register struct pxx	*pxx    = breps->pxx;
	register struct dpoint	*tp_dpo, *tp_dpo2;
	register struct pxx	*tp_pxx;

	if (dpo_ent == 0 || dpo2_ent == 0)
		return;

	tp_dpo  = dpoint+dpo_ent;
	tp_dpo2 = dpoint+dpo2_ent;
	if (tp_dpo->pxxtop) {
		tp_pxx = pxx+tp_dpo->pxxtop;
		while (tp_pxx->r_link)
			tp_pxx = pxx+tp_pxx->r_link;
		tp_pxx->r_link = tp_dpo2->pxxtop;
	}
	else
		tp_dpo->pxxtop = tp_dpo2->pxxtop;
	tp_dpo2->pxxtop = 0;
}
merg_exx(fac_ent, fac2_ent, breps)
	int			fac_ent, fac2_ent;
	struct breps		*breps;
{
	struct face		*face = breps->face;
	register struct exx	*exx  = breps->exx;
	register struct face	*tp_fac, *tp_fac2;
	register struct exx	*tp_exx;

	if (fac_ent == 0 || fac2_ent == 0)
		return;

	tp_fac  = face+fac_ent;
	tp_fac2 = face+fac2_ent;
	if (tp_fac->exxtop) {
		tp_exx = exx+tp_fac->exxtop;
		while (tp_exx->r_link)
			tp_exx = exx+tp_exx->r_link;
		tp_exx->r_link = tp_fac2->exxtop;
	}
	else
		tp_fac->exxtop = tp_fac2->exxtop;
	tp_fac2->exxtop = 0;
}

