
/* disp.c	87/7/13 */

#include "dsm.h"

disp(v_view, v_ray, t_bgcol, t_bgint, sw_experts, sw_shadow, sw_term, sw_BFR, sw_paint, breps)
	struct motion		*v_view, *v_ray;
	double			t_bgcol, t_bgint;
	int			sw_experts, sw_shadow;
	int			sw_term, sw_BFR, sw_paint;
	struct breps		*breps;
{
/*                                                      */
/* brep.inview                                          */
/*                    \             2             /	*/
/*                      \   1               1   /	*/
/*                        \         1         /		*/
/*                      1   \_______SCREEN__/   1	*/
/*                 |          \     1     /       	*/
/*        SCR_LOC  |   0        \       /        0	*/
/*                 |              \ 0 /			*/
/*                 -----------------*-----------------	*/
/*                          0       VIEW_POINT		*/
/*                                                      */
#define SQRT2			1.4142135623730951
	struct brep		*brep   = breps->brep;
	struct dpoint		*dpoint = breps->dpoint;
	struct dvect		*dvect  = breps->dvect;
	register int		*ls_brep_ent = &(breps->ls_brep_ent);
	register struct brep	*tp_brep;
	register struct dpoint	*tp_dpo;
	register struct dvect	*tp_dve;
	double			dabs();
	double			tp_x, tp_y, tp_z, tp_dbl;
	double			cs_Ox, cs_Oy, cs_Oz;
	double			cs_Xx, cs_Xy, cs_Xz;
	double			cs_Yx, cs_Yy, cs_Yz;
	double			cs_Zx, cs_Zy, cs_Zz;
	double			ray_x, ray_y, ray_z;
	char			*ttype, *getenv();
	register int		com_ent, i, j;

	if (*ls_brep_ent == 0) {
		fprintf(stderr, "disp: no solid\n");
		return;
	}

	m_inv(v_view, v_view);
	m_papply(v_view,  0.0,  0.0,  0.0, &cs_Ox, &cs_Oy, &cs_Oz);
	m_papply(v_view, 10.0,  0.0,  0.0, &cs_Xx, &cs_Xy, &cs_Xz);
	m_papply(v_view,  0.0, 10.0,  0.0, &cs_Yx, &cs_Yy, &cs_Yz);
	m_papply(v_view,  0.0,  0.0, 10.0, &cs_Zx, &cs_Zy, &cs_Zz);
	m_vapply(v_ray,   0.0,  0.0, -1.0, &ray_x, &ray_y, &ray_z);
	m_vapply(v_view, ray_x, ray_y, ray_z, &ray_x, &ray_y, &ray_z);

	for (i=1; i<=*ls_brep_ent; i++) {
		tp_brep = brep+i;
		if (tp_brep->xlonum) {
			m_papply(v_view, tp_brep->dpocex, tp_brep->dpocey, tp_brep->dpocez, &tp_x, &tp_y, &tp_z);
			if (tp_z-tp_brep->maxdpo >= SCR_LOC)
				tp_brep->inview = 0;
			else {
				tp_dbl = SQRT2*tp_brep->maxdpo-tp_z;
				if (dabs(tp_x) >= tp_dbl || dabs(tp_y) >= tp_dbl)
					tp_brep->inview = 0;
				else {
					tp_dbl = -SQRT2*tp_brep->maxdpo-tp_z;
					if (tp_z+tp_brep->maxdpo <= SCR_LOC && dabs(tp_x) <= tp_dbl && dabs(tp_y) <= tp_dbl)
						tp_brep->inview = 2;
					else
						tp_brep->inview = 1;
				}
			}
			for (tp_dpo=dpoint+(com_ent=tp_brep->dpotop), j=1; j<=tp_brep->dponum; j++) {
				m_papply(v_view, tp_dpo->x, tp_dpo->y, tp_dpo->z, &dpowrk[com_ent].x, &dpowrk[com_ent].y, &dpowrk[com_ent].z);
				tp_dpo = dpoint+(com_ent = tp_dpo->br_link);
			}
			for (tp_dve=dvect+(com_ent=tp_brep->dvetop), j=1; j<=tp_brep->dvenum; j++) {
				m_vapply(v_view, tp_dve->x, tp_dve->y, tp_dve->z, &dvewrk[com_ent].x, &dvewrk[com_ent].y, &dvewrk[com_ent].z);
				tp_dve = dvect+(com_ent = tp_dve->br_link);
			}
		}
	}

	if (sw_term) {
		ttype = getenv("TERM");
		if      (!strncmp(ttype, "GTD21", 5))
			disp_term(sw_BFR, sw_paint, cs_Ox, cs_Oy, cs_Oz, cs_Xx, cs_Xy, cs_Xz, cs_Yx, cs_Yy, cs_Yz, cs_Zx, cs_Zy, cs_Zz, ray_x, ray_y, ray_z, breps);
		else if (!strncmp(ttype, "comm", 4))
			disp_term(sw_BFR, sw_paint, cs_Ox, cs_Oy, cs_Oz, cs_Xx, cs_Xy, cs_Xz, cs_Yx, cs_Yy, cs_Yz, cs_Zx, cs_Zy, cs_Zz, ray_x, ray_y, ray_z, breps);
		else if (!strncmp(ttype, "sun", 3));
		else
			fprintf(stderr, "disp: $TERM not (GTD21, comm)\n");
	}
	if (sw_experts) {
		disp_experts(sw_BFR, sw_shadow, ray_x, ray_y, ray_z, t_bgcol, t_bgint, breps);
	}
}
termterm()
{
	char	*ttype, *getenv();

	ttype = getenv("TERM");
	if      (!strncmp(ttype, "GTD21", 5))
		g_term();
	else if (!strncmp(ttype, "comm", 4))
		g_term();
}

