
/* disp_experts.c	87/7/13 */

#include "dsm.h"

#define	SCREEN			32700.0
#define	DBMMAX			0xffff
#define	NIL			0xffff
#define	ESLN16			18
#define	SHADOWLEN		10000.0

static int	evdptr, evdofs, vcount;
static int	epbptr, erplas, esplas;

disp_experts(sw_BFR, sw_shadow, ray_x, ray_y, ray_z, t_bgcol, t_bgint, breps)
	int			sw_BFR;
	int			sw_shadow;
	double			ray_x, ray_y, ray_z, t_bgcol, t_bgint;
	struct breps		*breps;
{
	struct brep		*brep   = breps->brep;
	struct face		*face   = breps->face;
	struct xloop		*xloop  = breps->xloop;
	struct xedge		*xedge  = breps->xedge;
	int			*ls_brep_ent = &(breps->ls_brep_ent);
	struct brep		*tp_brep;
	register struct xedge	*tp_xed;
	register struct dpowrk	*tp_dpo, *tp_dpo2;
	register struct dvewrk	*tp_dve;
	double			dabs();
	double			sx1, sy1, sz1, sx2, sy2, sz2;
	double			nx, ny, nz;
	double			intens, tp_dbl;
	register int		cur_xlo_ent, sav_xlo_ent;
	register int		cur_xed_ent, sav_xed_ent;
	register int		i, j;

/* write header to DBM/S */
	evdptr = ESLN16-1;
	epbptr = DBMMAX+1;
	erplas = DBMMAX+1;
	esplas = 1;
	dbmwmm(0, NIL); /* real polygon */
	dbmwmm(1, NIL); /* shadow polygon */

/* write background to DBM/S */
	epbptr -= 9;
	dbmwmm(erplas  , epbptr);
	dbmwmm(epbptr  , NIL);
	dbmwmm(epbptr+1, (int)t_bgcol);
	dbmwmm(epbptr+2, 0);
	dbmwmm(epbptr+3, (int)t_bgint);
	dbmwmm(epbptr+4, 4);
	dbmwmm(epbptr+5, evdptr+1);
	dbmwmm(epbptr+6, evdptr+5);
	dbmwmm(epbptr+7, evdptr+9);
	dbmwmm(epbptr+8, evdptr+13);
	erplas = epbptr;
	dbmwvd(evdptr+1 , (short) -SCREEN, (short) -SCREEN, (short) SCREEN, 0);
	dbmwvd(evdptr+5 , (short) -SCREEN, (short)  SCREEN, (short) SCREEN, 0);
	dbmwvd(evdptr+9 , (short)  SCREEN, (short)  SCREEN, (short) SCREEN, 0);
	dbmwvd(evdptr+13, (short)  SCREEN, (short) -SCREEN, (short) SCREEN, 0);
	evdptr += 16;

/* create real polygons */
	for (i=1; i<=*ls_brep_ent; i++) {
		tp_brep = brep+i;
		if (tp_brep->xlonum && tp_brep->inview) {
			for (j=tp_brep->factop; j<tp_brep->factop+tp_brep->facnum; j++) {
				if (cur_xlo_ent = sav_xlo_ent = (face+j)->xlotop) {
					tp_dpo = &dpowrk[(xedge+(xloop+cur_xlo_ent)->xedtop)->dp1];
					tp_dve = &dvewrk[(face+j)->favect];
					v_sca(ray_x, ray_y, ray_z, tp_dve->x, tp_dve->y, tp_dve->z, &intens);
					if (intens < 0.0)
						(face+j)->work = 1;
					else
						(face+j)->work = -1;
					v_sca(tp_dpo->x, tp_dpo->y, tp_dpo->z, tp_dve->x, tp_dve->y, tp_dve->z, &tp_dbl);
					if (tp_dbl < 0.0) {
						p_pat_init();
						do {
							cur_xed_ent = sav_xed_ent = (xloop+cur_xlo_ent)->xedtop;
							p_pat_open();
							do {
								tp_xed = xedge+cur_xed_ent;
								if (tp_xed->fa1 == j) {
									tp_dpo = &dpowrk[tp_xed->dp1];
									tp_dve = &dvewrk[tp_xed->dv1];
									v_sca(ray_x, ray_y, ray_z, tp_dve->x, tp_dve->y, tp_dve->z, &tp_dbl);
									if (p_pat_vertex(tp_dpo->x, tp_dpo->y, tp_dpo->z, (tp_dbl < 0.0) ? (int)((-tp_dbl)*6271.0+1920.0) : 1920))
										return;
									cur_xed_ent = tp_xed->link1;
								}
								else {
									tp_dpo = &dpowrk[tp_xed->dp2];
									tp_dve = &dvewrk[tp_xed->dv2];
									v_sca(ray_x, ray_y, ray_z, tp_dve->x, tp_dve->y, tp_dve->z, &tp_dbl);
									if (p_pat_vertex(tp_dpo->x, tp_dpo->y, tp_dpo->z, (tp_dbl < 0.0) ? (int)((-tp_dbl)*6400.0+1791.0) : 1791))
										return;
									cur_xed_ent = tp_xed->link2;
								}
							} while (cur_xed_ent != sav_xed_ent);
							if (p_pat_close())
								return;
						} while ((cur_xlo_ent = (xloop+cur_xlo_ent)->r_link) != sav_xlo_ent);
						if (r_pat_execution((face+j)->facolor, (intens < 0.0) ? (int)((-intens)*6400.0+1791.0) : 1791))
							return;
					}
				}
			}
		}
	}

/* create shadow polygons */
	if (sw_shadow) {
		for (i=1; i<=*ls_brep_ent; i++) {
			tp_brep = brep+i;
			if (tp_brep->xlonum && tp_brep->inview) {
				for (tp_xed=xedge+tp_brep->xedtop, j=1; j<=tp_brep->xednum; j++) {
					if ((face+tp_xed->fa1)->work+(face+tp_xed->fa2)->work == 0) {
						if ((face+tp_xed->fa1)->work == -1) {
							tp_dpo  = &dpowrk[tp_xed->dp1];
							tp_dpo2 = &dpowrk[tp_xed->dp2];
						}
						else {
							tp_dpo  = &dpowrk[tp_xed->dp2];
							tp_dpo2 = &dpowrk[tp_xed->dp1];
						}
						sx1 = tp_dpo ->x+ray_x*SHADOWLEN;
						sy1 = tp_dpo ->y+ray_y*SHADOWLEN;
						sz1 = tp_dpo ->z+ray_z*SHADOWLEN;
						sx2 = tp_dpo2->x+ray_x*SHADOWLEN;
						sy2 = tp_dpo2->y+ray_y*SHADOWLEN;
						sz2 = tp_dpo2->z+ray_z*SHADOWLEN;

	     					if (sz1 > SCR_LOC) {
	      						tp_dbl = (SCR_LOC-tp_dpo->z)/(sz1-tp_dpo->z);
	      						sx1 = tp_dpo->x+(sx1-tp_dpo->x)*tp_dbl;
	      						sy1 = tp_dpo->y+(sy1-tp_dpo->y)*tp_dbl;
	      						sz1 = SCR_LOC;
						}
						if (sz1 > -dabs(sx1) || sz1 > -dabs(sy1)) {
							if (sx1 < -dabs(sy1)) {
								tp_dbl = (tp_dpo->x-tp_dpo->z)/(tp_dpo->x-sx1-tp_dpo->z+sz1);
	       							sx1 = tp_dpo->x+(sx1-tp_dpo->x)*tp_dbl;
	       							sy1 = tp_dpo->y+(sy1-tp_dpo->y)*tp_dbl;
	       							sz1 = sx1;
							}
							else if (sx1 > dabs(sy1)) {
								tp_dbl = (tp_dpo->x+tp_dpo->z)/(tp_dpo->x-sx1+tp_dpo->z-sz1);
								sx1 = tp_dpo->x+(sx1-tp_dpo->x)*tp_dbl;
								sy1 = tp_dpo->y+(sy1-tp_dpo->y)*tp_dbl;
								sz1 = -sx1;
							}
							if (sy1 < -dabs(sx1)) {
								tp_dbl = (tp_dpo->y-tp_dpo->z)/(tp_dpo->y-sy1-tp_dpo->z+sz1);
								sx1 = tp_dpo->x+(sx1-tp_dpo->x)*tp_dbl;
								sy1 = tp_dpo->y+(sy1-tp_dpo->y)*tp_dbl;
								sz1 = sy1;
							}
							else if (sy1 > dabs(sx1)) {
								tp_dbl = (tp_dpo->y+tp_dpo->z)/(tp_dpo->y-sy1+tp_dpo->z-sz1);
								sx1 = tp_dpo->x+(sx1-tp_dpo->x)*tp_dbl;
								sy1 = tp_dpo->y+(sy1-tp_dpo->y)*tp_dbl;
								sz1 = -sy1;
							}
						}

	     					if (sz2 > SCR_LOC) {
	      						tp_dbl = (SCR_LOC-tp_dpo2->z)/(sz2-tp_dpo2->z);
	      						sx2 = tp_dpo2->x+(sx2-tp_dpo2->x)*tp_dbl;
	      						sy2 = tp_dpo2->y+(sy2-tp_dpo2->y)*tp_dbl;
	      						sz2 = SCR_LOC;
						}
						if (sz2 > -dabs(sx2) || sz2 > -dabs(sy2)) {
							if (sx2 < -dabs(sy2)) {
								tp_dbl = (tp_dpo2->x-tp_dpo2->z)/(tp_dpo2->x-sx2-tp_dpo2->z+sz2);
	       							sx2 = tp_dpo2->x+(sx2-tp_dpo2->x)*tp_dbl;
	       							sy2 = tp_dpo2->y+(sy2-tp_dpo2->y)*tp_dbl;
	       							sz2 = sx2;
							}
							else if (sx2 > dabs(sy2)) {
								tp_dbl = (tp_dpo2->x+tp_dpo2->z)/(tp_dpo2->x-sx2+tp_dpo2->z-sz2);
								sx2 = tp_dpo2->x+(sx2-tp_dpo2->x)*tp_dbl;
								sy2 = tp_dpo2->y+(sy2-tp_dpo2->y)*tp_dbl;
								sz2 = -sx2;
							}
							if (sy2 < -dabs(sx2)) {
								tp_dbl = (tp_dpo2->y-tp_dpo2->z)/(tp_dpo2->y-sy2-tp_dpo2->z+sz2);
								sx2 = tp_dpo2->x+(sx2-tp_dpo2->x)*tp_dbl;
								sy2 = tp_dpo2->y+(sy2-tp_dpo2->y)*tp_dbl;
								sz2 = sy2;
							}
							else if (sy2 > dabs(sx2)) {
								tp_dbl = (tp_dpo2->y+tp_dpo2->z)/(tp_dpo2->y-sy2+tp_dpo2->z-sz2);
								sx2 = tp_dpo2->x+(sx2-tp_dpo2->x)*tp_dbl;
								sy2 = tp_dpo2->y+(sy2-tp_dpo2->y)*tp_dbl;
								sz2 = -sy2;
							}
						}

						p_pat_init();
						p_pat_open();
						if (p_pat_vertex(tp_dpo->x, tp_dpo->y, tp_dpo->z, 0))
							return;
						if (p_pat_vertex(tp_dpo2->x, tp_dpo2->y, tp_dpo2->z, 0))
							return;
						if (p_pat_vertex(sx2, sy2, sz2, 0))
							return;
						if (p_pat_vertex(sx1, sy1, sz1, 0))
							return;
						v_vec(ray_x, ray_y, ray_z, tp_dpo2->x-tp_dpo->x, tp_dpo2->y-tp_dpo->y, tp_dpo2->z-tp_dpo->z, &nx, &ny, &nz);
						v_sca(nx, ny, nz, tp_dpo->x, tp_dpo->y, tp_dpo->z, &tp_dbl);
						if (s_pat_execution((tp_dbl < 0.0) ? 1: 0))
							return;
					}
					tp_xed = xedge+tp_xed->br_link;
				}
			}
		}
	}

#ifdef USTATION
/* activate EXPERTS */
	expact();
#endif

#ifdef HP
/* display on HP/console */
	hpact();
#endif

#ifdef SUNVIEW
/* display on SUNVIEW/console */
	sunviewact();
#endif

#ifdef SUNX11
/* display on SUNX11 */
	sunx11act(sw_BFR, sw_shadow, breps);
#endif
}

#define	SPMAX	100
static double	sx[SPMAX+1], sy[SPMAX+1], sz[SPMAX+1];
static int	si[SPMAX+1], sp, sw;

p_pat_init()
{
	sp = 0;
	evdofs = evdptr+1;
	vcount = 0;
}
p_pat_open()
{
	sw = 1;
}
p_pat_vertex(x, y, z, i) double x, y, z; int i;
{    
	if (sw) {
		sw = 0;
		if (sp > SPMAX) {
			fprintf(stderr, "disp_experts: STACK overflow (vertex)\n");
			return(1);
		}
		sx[sp  ] = x;
		sy[sp  ] = y;
		sz[sp  ] = z;
		si[sp++] = i;
	}
	if (evdptr+4 > epbptr) {
		fprintf(stderr, "disp_experts: SLPMEM overflow (vertex)\n");
		return(1);
	}
	if (z < SCR_LOC)
		dbmwvd(evdptr+1, (int)(-x/z*SCREEN), (int)(-y/z*SCREEN), (int)((1.0-SCR_LOC/z)*SCREEN), i);
	else
		dbmwvd(evdptr+1, 0, 0, 0, 0);
	evdptr += 4;
	vcount++;
	return(0);
}
p_pat_close()
{
	double		x, y, z;
	register int	i;

	x = sx[sp-1];
	y = sy[sp-1];
	z = sz[sp-1];
	i = si[sp-1];
	if (evdptr+4 > epbptr) {
		fprintf(stderr, "disp_experts: SLPMEM overflow (vertex)\n");
		return(1);
	}
	if (z < SCR_LOC)
		dbmwvd(evdptr+1, (int)(-x/z*SCREEN), (int)(-y/z*SCREEN), (int)((1.0-SCR_LOC/z)*SCREEN), i);
	else
		dbmwvd(evdptr+1, 0, 0, 0, 0);
	evdptr += 4;
	vcount++;
	return(0);
}
r_pat_execution(fc, fi) register int fc, fi;
{
	double		x, y, z;
	register int	i;
	register int	k;

	while (--sp > 0) {
		x = sx[sp-1];
		y = sy[sp-1];
		z = sz[sp-1];
		i = si[sp-1];
		if (evdptr+4 > epbptr) {
			fprintf(stderr, "disp_experts: SLPMEM overflow (vertex)\n");
			return(1);
		}
		if (z < SCR_LOC)
			dbmwvd(evdptr+1, (int)(-x/z*SCREEN), (int)(-y/z*SCREEN), (int)((1.0-SCR_LOC/z)*SCREEN), i);
		else
			dbmwvd(evdptr+1, 0, 0, 0, 0);
		evdptr += 4;
		vcount++;
	}

	epbptr -= 5+vcount;
	if (evdptr >= epbptr) {
		fprintf(stderr, "disp_experts: SLPMEM overflow (real polygon)\n");
		return(1);
	}
	dbmwmm(erplas  , epbptr);
	dbmwmm(epbptr  , NIL);
	dbmwmm(epbptr+1, fc);
	dbmwmm(epbptr+2, 0);
	dbmwmm(epbptr+3, fi);
	dbmwmm(epbptr+4, vcount);
	for (k=0; k<vcount; k++)
		dbmwmm(epbptr+5+k, k*4+evdofs);
	erplas = epbptr;
	return(0);
}
s_pat_execution(s) register int s;
{
	register int	k;

	epbptr -= 3+vcount;
	if (evdptr >= epbptr) {
		fprintf(stderr, "disp_experts: SLPMEM overflow (shadow polygon)\n");
		return(1);
	}
	dbmwmm(esplas  , epbptr);
	dbmwmm(epbptr  , NIL);
	dbmwmm(epbptr+1, s);
	dbmwmm(epbptr+2, vcount);
	for (k=0; k<vcount; k++)
		dbmwmm(epbptr+3+k, k*4+evdofs);
	esplas = epbptr;
	return(0);
}

#ifdef USTATION
extern int	errno;
short		*SLPMEM;
unsigned short	*SLPRG0; /* r/w status */
unsigned short	*SLPRG1; /* w/o SLP select & ~bloadcast */
unsigned short	*SLPRG2; /* r/w completion flag read & clear */
unsigned short	*SLPRG3; /* w/o dbms exchange */
#else
short		SLPMEM[DBMMAX+1];
#endif

#ifdef HP
#include <starbase.c.h>
extern float	sb_xmax, sb_ymax;
extern int	sb_num_pens;
#endif

#ifdef SUNVIEW
#include <usercore.h>
extern float	sb_xmax, sb_ymax;
struct  vwsurf  *get_view_surface(/* (struct vwsurf *), argv */);
struct  vwsurf  Core_vwsurf;
struct  vwsurf  *our_surface = &Core_vwsurf;
#define MAPSIZE         114
#endif

dbmmap()
{
#ifdef USTATION
#define	DBMVIRT	0x680000
#define	DBMBASE	0x900000

	if(phys(0, DBMVIRT, 0x22000, DBMBASE)<0) {
		fprintf(stderr, "disp_experts: phys error %d\n", errno);
		exit(1);
	}
	SLPMEM = (         short *)(DBMVIRT        );
	SLPRG0 = (unsigned short *)(DBMVIRT+0x20000);
	SLPRG1 = (unsigned short *)(DBMVIRT+0x20002);
	SLPRG2 = (unsigned short *)(DBMVIRT+0x20004);
	SLPRG3 = (unsigned short *)(DBMVIRT+0x20006);
	*SLPRG1 = 0;
	*SLPRG2 = 0xff;
#endif
}
dbmwmm(addr, val) register int addr, val;
{
	SLPMEM[addr % (DBMMAX+1)] = (short) val;
}
dbmrmu(addr) register int addr;
{
	return((int) (SLPMEM[addr % (DBMMAX+1)] & 0x0000ffff));
}
dbmrms(addr) register int addr;
{
	return((int) (SLPMEM[addr % (DBMMAX+1)]));
}
dbmwvd(addr, v1, v2, v3, v4) register int addr, v1, v2, v3, v4;
{
	SLPMEM[addr  ] = (short) v1;
	SLPMEM[addr+1] = (short) v2;
	SLPMEM[addr+2] = (short) v3;
	SLPMEM[addr+3] = (short) v4;
}

#ifdef USTATION
expact()
{
	SLPMEM[2] = 0;
	if (SLPMEM[2]) {
		fprintf(stderr, "disp_experts: EXPERTS inactive...\n");
		return;
	}
	SLPMEM[2] = NIL;
	if (SLPMEM[2] != NIL) {
		fprintf(stderr, "disp_experts: EXPERTS inactive...\n");
		return;
	}

	SLPMEM[ 2] = 512; /* esln of slp1  */
	SLPMEM[ 3] = 512; /* esln of slp2  */
	SLPMEM[ 4] = 512; /* esln of slp3  */
	SLPMEM[ 5] = 512; /* esln of slp4  */
	SLPMEM[ 6] = 512; /* esln of slp5  */
	SLPMEM[ 7] = 512; /* esln of slp6  */
	SLPMEM[ 8] = 512; /* esln of slp7  */
	SLPMEM[ 9] = 512; /* esln of slp8  */
	SLPMEM[10] = 512; /* esln of slp9  */
	SLPMEM[11] = 512; /* esln of slp10 */
	SLPMEM[12] = 512; /* esln of slp11 */
	SLPMEM[13] = 512; /* esln of slp12 */
	SLPMEM[14] = 512; /* esln of slp13 */
	SLPMEM[15] = 512; /* esln of slp14 */
	SLPMEM[16] = 512; /* esln of slp15 */
	SLPMEM[17] = 512; /* esln of slp16 */

	while (!(*SLPRG2 & 1));
	*SLPRG2 = 0xfe;
	*SLPRG3 = 0;
	*SLPRG0 = 1;
	*SLPRG0 = 0;
}
#endif

#ifdef HP
hpact()
{
	register int	i, c, j;
	int		fildes;
	int		q;
	float		xm, ym;
	float		x, y;
	float		ri, imax;
	float		pts[2000];
	float		*ptr;
	int		flags;

/* clear screen */
	fildes = sbopen(1, 0, OUTDEV, INIT);
	xm = sb_xmax;
	ym = sb_ymax;
	imax = (xm > ym ? ym / 2 : xm / 2);

/* SET UP VIEWING TO FULL DEVICE LIMITS */
	vdc_extent(fildes, 0.0, 0.0, 0.0, xm/ym, 1.0, 1.0);
	view_window(fildes, 0.0, 0.0, xm, ym);

/* TRY MOVING CURSORS (IN VDC'S) */
	echo_type(fildes, 1, 1, 0.0, 0.0, 0.0); 
	for (ri=0.0; ri <= 1.0; ri += 0.01 ) 
		echo_update(fildes, 1, ri, ri, ri);
	echo_type(fildes, 1, 0, 0.0, 0.0, 0.0); 

	background_color_index(fildes, 0 % sb_num_pens);
	interior_style(fildes, INT_SOLID, TRUE);

	q = 0;
	perimeter_color_index(fildes, 0);
	flags = FALSE;

/* draw real polygons */
	epbptr = 0;
	while (dbmrmu(epbptr) != NIL) {
		epbptr = dbmrmu(epbptr);
		c = dbmrmu(epbptr+1);
		i = dbmrmu(epbptr+3);
		perimeter_color(fildes, (double)(((c>>6)&7)*i/8191.0/7.0), (double)(((c>>3)&7)*i/8191.0/7.0), (double)((c&7)*i/8191.0/7.0));
		fill_color(fildes, (double)(((c>>6)&7)*i/8191.0/7.0), (double)(((c>>3)&7)*i/8191.0/7.0), (double)((c&7)*i/8191.0/7.0));
		ptr = &pts[0];
		for (j=0; j<dbmrms(epbptr+4); j++) {
			*ptr++ = (dbmrms(dbmrms(epbptr+5+j)  )+SCREEN/2.0)/32.0;
			*ptr++ = (dbmrms(dbmrms(epbptr+5+j)+1)+SCREEN/2.0)/32.0;
			if (flags) *ptr++ = TRUE;
		}
		polygon2d(fildes, pts, j, flags);
	}

/* draw shadow polygons */
	epbptr = 1;
	while (dbmrmu(epbptr) != NIL) {
		epbptr = dbmrmu(epbptr);
		c = dbmrmu(epbptr+1);
		perimeter_color(fildes, (double)(1.0-c)/4.0, 0.0, (double)c/4.0);
		fill_color(fildes, (double)(1.0-c)/4.0, 0.0, (double)c/4.0);
		ptr = &pts[0];
		for (j=0; j<dbmrms(epbptr+2); j++) {
			*ptr++ = (dbmrms(dbmrms(epbptr+3+j)  )+SCREEN/2.0)/32.0;
			*ptr++ = (dbmrms(dbmrms(epbptr+3+j)+1)+SCREEN/2.0)/32.0;
			if (flags) *ptr++ = TRUE;
		}
		polygon2d(fildes, pts, j, flags);
	}

	gclose(fildes);
}
#endif

#ifdef SUNVIEW
start_view_surface(argv) char ** argv;
{
        get_view_surface(our_surface, argv);
        our_surface->cmapsize = 128;
        our_surface->cmapname[0] = '\0';
        if(initialize_core(BASIC, SYNCHRONOUS, TWOD))
                exit(1);
        /* initialize_device(KEYBOARD, 1); */
        if(initialize_view_surface(our_surface,FALSE))
                exit(2);
        if(select_view_surface(our_surface))
                exit(3);
        set_window(0.0,1.0,0.0,1.0);
        make_maps();
        create_temporary_segment();
}

uterminate_view_surface()
{
        /* close_temporary_segment();
        deselect_view_surface(our_surface);
        terminate_core(); */
}

sunviewact()
{
	register int	i, c, j;
	float		xm, ym;
	float		imax;
	float		x_array[2000];
	float		y_array[2000];

	new_frame();

/* draw real polygons */
	epbptr = 0;
	while (dbmrmu(epbptr) != NIL) {
		epbptr = dbmrmu(epbptr);
		c = dbmrmu(epbptr+1);
		i = dbmrmu(epbptr+3);
		set_line_index(c % 128);
		for (j=0; j<dbmrms(epbptr+4); j++) {
			x_array[j] = (dbmrms(dbmrms(epbptr+5+j)  )+SCREEN/2.0)/SCREEN;
			y_array[j] = (dbmrms(dbmrms(epbptr+5+j)+1)+SCREEN/2.0)/SCREEN;
		}
		move_abs_2(x_array[j-1], y_array[j-1]);
		polyline_abs_2(x_array, y_array, j);
	}

}

static float red[MAPSIZE+1], grn[MAPSIZE+1], blu[MAPSIZE+1];

make_maps()      
{
        int i;
 
        red[0] = 0.0;                           /* background color */
        grn[0] = 0.0;
        blu[0] = 0.0;
 
        for (i=0; i<19; i++) {
                red[i +   1] = 0.99;            /* ramp to yellow */
                grn[i +   1] = 0.055*i;
                blu[i +   1] = 0.0;
 
                red[i +  20] = 0.99-0.055*i;    /* ramp to green */
                grn[i +  20] = 0.99;
                blu[i +  20] = 0.0;
 
                red[i +  39] = 0.0;             /* ramp to turqouise */
                grn[i +  39] = 0.99;
                blu[i +  39] = 0.055*i;
 
                red[i +  58] = 0.0;             /* ramp to blue */
                grn[i +  58] = 0.99-0.055*i;
                blu[i +  58] = 0.99;
 
                red[i +  77] = 0.055*i;         /* ramp to violet */
                grn[i +  77] = 0.0;
                blu[i +  77] = 0.99;
           
                red[i +  96] = 0.99;            /* ramp to red */
                grn[i +  96] = 0.0;
                blu[i +  96] = 0.99-0.055*i;
        }
    
        define_color_indices(our_surface,0,MAPSIZE,red,grn,blu);
           
}
#endif

#ifdef SUNX11

#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <stdio.h>

extern GC XCreateGC();

int winX, winY, winW, winH;

struct _disp {
        Window  win;
        Display *dpy;
        char    *dname;
        long    fg, bg;
        GC      gc;
        Atom    kill_atom, protocol_atom;
}       display;

XSetWindowAttributes xswa;
XSizeHints      sizehint;
char    wname[32];

start_xwindow()
{
        display.dname = NULL;
        if (!(display.dpy = XOpenDisplay(display.dname))) {
                fprintf(stderr, "Cannot open displays %s\n", display.dname);
                exit(-1);
        }
        display.fg =WhitePixel(display.dpy, DefaultScreen(display.dpy));
        display.bg =BlackPixel(display.dpy, DefaultScreen(display.dpy));
        winX = 0;
        winY = 0;
        winW = SCREEN/64;
        winH = SCREEN/64;
        xswa.event_mask = 0;
        xswa.background_pixel = display.bg;
        xswa.border_pixel = display.fg;
        display.win = XCreateWindow(display.dpy,
                DefaultRootWindow(display.dpy),
                winX, winY, winW, winH, 0,
                24,
                InputOutput, DefaultVisual(display.dpy, DefaultScreen(display.dpy)),
                CWEventMask | CWBackPixel | CWBorderPixel, &xswa);
        sizehint.flags = PPosition | PSize;
        XSetNormalHints(display.dpy, display.win, &sizehint);
        display.protocol_atom = XInternAtom(display.dpy, "WM_PROTOCOLS", False);
        display.kill_atom = XInternAtom(display.dpy, "WM_DELETE_WINDOW", False);
        XSetWMProtocols(display.dpy, display.win, &display.kill_atom, 1);
        sprintf(wname, "DSM");
        XChangeProperty(display.dpy, display.win, XA_WM_NAME, XA_STRING, 8, PropModeReplace, wname, strlen(wname));
        XMapWindow(display.dpy, display.win);
        display.gc = XCreateGC(display.dpy, display.win, 0, NULL);
        XSetForeground(display.dpy, display.gc, display.fg);
        XSetBackground(display.dpy, display.gc, display.bg);
	XClearArea(display.dpy, display.win, winX, winY, winW, winH, 0);
        XSync(display.dpy, 0);
}

sunx11act(sw_BFR, sw_shadow, breps)
        int		        sw_BFR;
        int		        sw_shadow;
        struct breps            *breps;
{
	struct brep		*brep   = breps->brep;
	struct face		*face   = breps->face;
	struct xedge		*xedge  = breps->xedge;
	int			*ls_brep_ent = &(breps->ls_brep_ent);
	struct brep		*tp_brep;
	register struct xedge	*tp_xed;
        register struct dpowrk  *tp_dpo, *tp_dpo2;
        register struct dvewrk  *tp_dve, *tp_dve2;
        double                  tp_dbl, tp_dbl2;
        XPoint                  point[2000];
        XSegment                edges[2000];
	register int          	c, i, fc, j;

	XClearArea(display.dpy, display.win, winX, winY, winW, winH, 0);

/* draw real polygons */
	epbptr = 0;
	while (dbmrmu(epbptr) != NIL) {
		epbptr = dbmrmu(epbptr);
		c = dbmrmu(epbptr+1);
		i = dbmrmu(epbptr+3);
		for (j=0; j<dbmrms(epbptr+4); j++) {
			point[j].x =      (dbmrms(dbmrms(epbptr+5+j)  )+SCREEN/2.0)/64;
			point[j].y = winW-(dbmrms(dbmrms(epbptr+5+j)+1)+SCREEN/2.0)/64;
		}
		fc = (((c>>6)&7)*i/224) * 65536
                   + (((c>>3)&7)*i/224) * 256
                   + (((c   )&7)*i/224);
		XSetForeground(display.dpy, display.gc, fc);
	        XFillPolygon(display.dpy, display.win, display.gc, point, j, Complex, CoordModeOrigin);
      if (sw_shadow) {
                for (j=0; j<dbmrms(epbptr+4); j++) {
                        edges[j].x1 =      (dbmrms(dbmrms(epbptr+5+j)  )+SCREEN/2.0)/64;
                        edges[j].y1 = winW-(dbmrms(dbmrms(epbptr+5+j)+1)+SCREEN/2.0)/64;
                        if (j > 0) {
                          edges[j-1].x2 = edges[j].x1;
                          edges[j-1].y2 = edges[j].y1;
                        }
                }
                edges[j-1].x2 = edges[0].x1;
                edges[j-1].y2 = edges[0].y1;
		fc = (((c>>6)&7)*36) * 65536
                   + (((c>>3)&7)*36) * 256
                   + (((c   )&7)*36);
		XSetForeground(display.dpy, display.gc, fc);
                XDrawSegments(display.dpy, display.win, display.gc, edges, j);
      }
	}
      if (sw_BFR) {
	for (i=1; i<=*ls_brep_ent; i++) {
	        tp_brep = brep+i;
                if (tp_brep->xlonum && tp_brep->inview) {
                        for (tp_xed=xedge+tp_brep->xedtop, j=1; j<=tp_brep->xednum; j++) {
                                tp_dpo  = &dpowrk[tp_xed->dp1];
				tp_dve  = &dvewrk[(face+tp_xed->fa1)->favect];
				tp_dve2 = &dvewrk[(face+tp_xed->fa2)->favect];
				v_sca(tp_dpo->x, tp_dpo->y, tp_dpo->z, tp_dve->x, tp_dve->y, tp_dve->z, &tp_dbl);
				v_sca(tp_dpo->x, tp_dpo->y, tp_dpo->z, tp_dve2->x, tp_dve2->y, tp_dve2->z, &tp_dbl2);
				if (1) {
                                        tp_dpo  = &dpowrk[tp_xed->dp1];
					tp_dpo2 = &dpowrk[tp_xed->dp2];
					edges[0].x1 = (-tp_dpo ->x/tp_dpo ->z)*SCREEN/64+SCREEN/2/64;
					edges[0].y1 = (+tp_dpo ->y/tp_dpo ->z)*SCREEN/64+SCREEN/2/64;
					edges[0].x2 = (-tp_dpo2->x/tp_dpo2->z)*SCREEN/64+SCREEN/2/64;
					edges[0].y2 = (+tp_dpo2->y/tp_dpo2->z)*SCREEN/64+SCREEN/2/64;
					c = (face+tp_xed->fa1)->facolor | (face+tp_xed->fa2)->facolor;
					fc = (((c>>6)&7)*36) * 65536
					   + (((c>>3)&7)*36) * 256
					   + (((c   )&7)*36);
					XSetForeground(display.dpy, display.gc, fc);
					XDrawSegments(display.dpy, display.win, display.gc, edges, 1);
				}
				tp_xed = xedge+tp_xed->br_link;
                        }
                }
	}
      }
        XSync(display.dpy, 0);
}

#endif
