
/* disp_term.c	87/7/13 */

#include "dsm.h"

#define	SCREEN			1024.0
#define	RED			(7 << 6)
#define	GREEN			(7 << 3)
#define	BLUE			(7)
#define	WHITE			(511)

disp_term(sw_BFR, sw_paint, cs_Ox, cs_Oy, cs_Oz, cs_Xx, cs_Xy, cs_Xz, cs_Yx, cs_Yy, cs_Yz, cs_Zx, cs_Zy, cs_Zz, ray_x, ray_y, ray_z, breps)
	int			sw_BFR, sw_paint;
	double			cs_Ox, cs_Oy, cs_Oz;
	double			cs_Xx, cs_Xy, cs_Xz;
	double			cs_Yx, cs_Yy, cs_Yz;
	double			cs_Zx, cs_Zy, cs_Zz;
	double			ray_x, ray_y, ray_z;
	struct breps		*breps;
{
	struct brep		*brep   = breps->brep;
	struct face		*face   = breps->face;
	struct xloop		*xloop  = breps->xloop;
	struct xedge		*xedge  = breps->xedge;
	int			*ls_brep_ent = &(breps->ls_brep_ent);
	struct brep		*tp_brep;
	struct xedge		*tp_xed;
	register struct dpowrk	*tp_dpo, *tp_dpo2;
	register struct dvewrk	*tp_dve, *tp_dve2;
	double			tp_dbl, tp_dbl2;
	register int		cur_xlo_ent, sav_xlo_ent;
	register int		cur_xed_ent, sav_xed_ent;
	register int		i, j;

/* clear screen */
	g_init();

/* display filled polygons */
	if (sw_paint) {
		for (i=1; i<=*ls_brep_ent; i++) {
			tp_brep = brep+i;
			if (tp_brep->xlonum && tp_brep->inview) {
				for (j=tp_brep->factop; j<tp_brep->factop+tp_brep->facnum; j++) {
					if (cur_xlo_ent = sav_xlo_ent = (face+j)->xlotop) {
						tp_dpo = &dpowrk[(xedge+(xloop+cur_xlo_ent)->xedtop)->dp1];
						tp_dve = &dvewrk[(face+j)->favect];
						v_sca(tp_dpo->x, tp_dpo->y, tp_dpo->z, tp_dve->x, tp_dve->y, tp_dve->z, &tp_dbl);
						if (tp_dbl <= 0.0) {
							do {
								cur_xed_ent = sav_xed_ent = (xloop+cur_xlo_ent)->xedtop;
								do {
									tp_xed = xedge+cur_xed_ent;
									if (tp_xed->fa1 == j) {
										tp_dpo = &dpowrk[tp_xed->dp1];
										g_pat_vertex(tp_dpo->x, tp_dpo->y, tp_dpo->z);
										cur_xed_ent = tp_xed->link1;
									}
									else {
										tp_dpo = &dpowrk[tp_xed->dp2];
										g_pat_vertex(tp_dpo->x, tp_dpo->y, tp_dpo->z);
										cur_xed_ent = tp_xed->link2;
									}
								} while (cur_xed_ent != sav_xed_ent);
								g_pat_close();
							} while ((cur_xlo_ent = (xloop+cur_xlo_ent)->r_link) != sav_xlo_ent);
							v_sca(ray_x, ray_y, ray_z, tp_dve->x, tp_dve->y, tp_dve->z, &tp_dbl);
							g_pat_execution((face+j)->facolor, (tp_dbl < 0.0) ? (int)(-tp_dbl*200+55) : 55);
						}
					}
				}
			}
		}
	}

/* display edges */
	if (!sw_paint) {
		for (i=1; i<=*ls_brep_ent; i++) {
			tp_brep = brep+i;
			if (tp_brep->xlonum && tp_brep->inview) {
				for (tp_xed=xedge+tp_brep->xedtop, j=1; j<=tp_brep->xednum; j++) {
					tp_dpo  = &dpowrk[tp_xed->dp1];
					tp_dve  = &dvewrk[(face+tp_xed->fa1)->favect];
					tp_dve2 = &dvewrk[(face+tp_xed->fa2)->favect];
					v_sca(tp_dpo->x, tp_dpo->y, tp_dpo->z, tp_dve->x, tp_dve->y, tp_dve->z, &tp_dbl);
					v_sca(tp_dpo->x, tp_dpo->y, tp_dpo->z, tp_dve2->x, tp_dve2->y, tp_dve2->z, &tp_dbl2);
					if (!sw_BFR || (sw_BFR && (tp_dbl <= 0.0 || tp_dbl2 <= 0.0))) {
						tp_dpo  = &dpowrk[tp_xed->dp1];
						tp_dpo2 = &dpowrk[tp_xed->dp2];
						g_color((face+tp_xed->fa1)->facolor | (face+tp_xed->fa2)->facolor);
						g_draw(tp_dpo->x, tp_dpo->y, tp_dpo->z, tp_dpo2->x, tp_dpo2->y, tp_dpo2->z);
					}
					tp_xed = xedge+tp_xed->br_link;
				}
			}
		}
	}

/* display cs */
	g_color(RED);
	g_draw(cs_Ox, cs_Oy, cs_Oz, cs_Xx, cs_Xy, cs_Xz);
	g_color(GREEN);
	g_draw(cs_Ox, cs_Oy, cs_Oz, cs_Yx, cs_Yy, cs_Yz);
	g_color(BLUE);
	g_draw(cs_Ox, cs_Oy, cs_Oz, cs_Zx, cs_Zy, cs_Zz);

/* display ray */
	g_color(WHITE);
	g_draw(cs_Ox, cs_Oy, cs_Oz, cs_Ox-ray_x*10, cs_Oy-ray_y*10, cs_Oz-ray_z*10);

/* home cursor */
	g_overlay_plane();
	g_home();
}
g_init()
{
	g_overlay_plane();
	g_erase();
	g_graph_plane();
	g_erase();
	printf("\033:8;0;1F"); /* IBM5560/50 graphic-mode */
}
g_term()
{
	g_graph_plane();
	g_erase();
	g_overlay_plane();
	g_erase();
	printf("\033:8;0;0F"); /* IBM5560/50 text-mode */
}
g_overlay_plane()
{
	printf("\033:65B\033:8F");
}
g_graph_plane()
{
	printf("\033:0B\033:8F");
}
g_home()
{
	printf("\033[H");
}
g_erase()
{
	printf("\033[H\033[2J");
}
g_color(c) register int c;
{
	printf("\033:%dF", (c>>3 & 0x30)+(c>>2 & 0x0c)+(c>>1 & 0x03));
}	
g_draw(x0, y0, z0, x1, y1, z1) double x0, y0, z0, x1, y1, z1;
{    
	if (z0 >= 0.0 && z1 >= 0.0)
		return;
	else if (z0 < 0.0 && 0.0 <= z1) {
		x1 = x0-(x0-x1)/(z0-z1)*z0;
		y1 = y0-(y0-y1)/(z0-z1)*z0;
		z1 = SCR_LOC;
	}
	else if (z1 < 0.0 && 0.0 <= z0) {
		x0 = x1-(x1-x0)/(z1-z0)*z1;
		y0 = y1-(y1-y0)/(z1-z0)*z1;
		z0 = SCR_LOC;
	}

	x0 = (-x0/z0)*SCREEN;
	y0 = (-y0/z0)*SCREEN;
	x1 = (-x1/z1)*SCREEN;
	y1 = (-y1/z1)*SCREEN;

	if (x0 < -510.0 && -510.0 < x1) {
		y0 = y1-(y1-y0)/(x1-x0)*(x1+510.0);
		x0 = -510.0;
	}
	else if (x1 < -510.0 && -510.0 < x0) {
		y1 = y0-(y0-y1)/(x0-x1)*(x0+510.0);
		x1 = -510.0;
	}
	if (x0 <  510.0 &&  510.0 < x1) {
		y1 = y0-(y0-y1)/(x0-x1)*(x0-510.0);
		x1 =  510.0;
	}
	else if (x1 <  510.0 &&  510.0 < x0) {
		y0 = y1-(y1-y0)/(x1-x0)*(x1-510.0);
		x0 =  510.0;
	}

	if (y0 < -382.0 && -382.0 < y1) {
		x0 = x1-(x1-x0)/(y1-y0)*(y1+382.0);
		y0 = -382.0;
	}
	else if (y1 < -382.0 && -382.0 < y0) {
		x1 = x0-(x0-x1)/(y0-y1)*(y0+382.0);
		y1 = -382.0;
	}
	if (y0 <  382.0 &&  382.0 < y1) {
		x1 = x0-(x0-x1)/(y0-y1)*(y0-382.0);
		y1 =  382.0;
	}
	else if (y1 <  382.0 &&  382.0 < y0) {
		x0 = x1-(x1-x0)/(y1-y0)*(y1-382.0);
		y0 =  382.0;
	}

	if (x0 < -510.0 || 510.0 < x0 || y0 < -382.0 || 382.0 < y0)
		return;
	if (x1 < -510.0 || 510.0 < x1 || y1 < -382.0 || 382.0 < y1)
		return;

	printf("\033:%d;%dm\033:%d;%dd", (int)x0+512, (int)y0+384, (int)x1+512, (int)y1+384);
}

static double	sx, sy;
g_pat_vertex(x, y, z) double x, y, z;
{    
	if (z < 0.0) {
		sx = (-x/z)*SCREEN;
		sy = (-y/z)*SCREEN;
	}
	else {
		sx = 0.0;
		sy = 0.0;
	}
	printf("\033:%d;%dv", (int)sx+512, (int)sy+384);
}
g_pat_close()
{
	printf("\033:%d;%dc", (int)sx+512, (int)sy+384);
}
g_pat_execution(c, i) register int c, i;
{
	printf("\033:%d;%d;%d;%d;%dx", (int)sx+512, (int)sy+384, (c>>6 & 0x7)*i/7, (c>>3 & 0x7)*i/7, (c & 0x7)*i/7);
}

