
/* dsm.l	87/6/15 */

%e	300
%p	700
%n	100
%k	60
%a	300
%o	500

%{
#define	IDLEN_MAX 80
double		atof();
void		*malloc();
static char	*idptr, id[IDLEN_MAX+1];
static int	idlen, indx;
static int	hashval, hashsave;
static int	reserved;
%}

%%
\\.*$	;
[ \t\n]+ ;

[,;=\(\)\*\/\^\+\-] { return(*yytext); }

generic	{	return(GENERIC); }
asb	{	return(ASB); }
un	{	return(UN); }
int	{	return(INT); }
dif	{	return(DIF); }
if	{	return(IF); }
then	{	return(THEN); }
else	{	return(ELSE); }
eq	{	return(EQ); }
ne	{	return(NE); }
ge	{	return(GE); }
gt	{	return(GT); }
le	{	return(LE); }
lt	{	return(LT); }
at	{	return(AT); }
cwith	{	return(CWITH); }
wrt	{	return(WRT); }
to	{	return(TO); }

abs	{	return(ABS); }
sin	{	return(SIN); }
cos	{	return(COS); }
tan	{	return(TAN); }
asin	{	return(ASIN); }
acos	{	return(ACOS); }
atan	{	return(ATAN); }
sqrt	{	return(SQRT); }
log	{	return(LOG); }
exp	{	return(EXP); }
rnd	{	return(RND); }

\".*\" |
[#A-Za-z_][#A-Za-z0-9_\.]* {
	/* copy yytext[] --> id[] */
		if (yytext[0] == '\"') {
			for (indx=0; indx<yyleng-2 && indx<IDLEN_MAX; indx++)
				id[indx] = yytext[indx+1];
		}
		else {
			for (indx=0; indx<yyleng && indx<IDLEN_MAX; indx++)
				id[indx] = yytext[indx];
		}
		id[indx] = NULL;
		idlen = indx+1;

	/* hash */
		hashval = hashsave = hash(id);
		while (idtable[hashval].name != NULL) {
			if (!strcmp(id, idtable[hashval].name) && !strcmp(cur_fname, idtable[hashval].f_name)) {
				yylval = hashval;
				return(ID);
			}
			hashval = rehash(hashval);
			if (hashval == hashsave)
				break;
		}
		if (idtable[hashval].name != NULL) {
			yyerror("too many IDs");
			fprintf(stderr, "scanner: current IDTBL_SIZE is %d.\n", IDTBL_SIZE);
			error_retry();
		}	

	/* new identifier */
		if (!strcmp(id, "x"))
			reserved = S_X;
		else if (!strcmp(id, "y"))
			reserved = S_Y;
		else if (!strcmp(id, "z"))
			reserved = S_Z;
		else if (!strcmp(id, "col"))
			reserved = S_COL;
		else if (!strcmp(id, "movx"))
			reserved = S_MOVX;
		else if (!strcmp(id, "movy"))
			reserved = S_MOVY;
		else if (!strcmp(id, "movz"))
			reserved = S_MOVZ;
		else if (!strcmp(id, "degx"))
			reserved = S_DEGX;
		else if (!strcmp(id, "degy"))
			reserved = S_DEGY;
		else if (!strcmp(id, "degz"))
			reserved = S_DEGZ;
		else if (!strcmp(id, "rotx"))
			reserved = S_ROTX;
		else if (!strcmp(id, "roty"))
			reserved = S_ROTY;
		else if (!strcmp(id, "rotz"))
			reserved = S_ROTZ;
		else
			reserved = S_UNDEF;

		idtable[hashval].reserved = reserved;
		idtable[hashval].name = idptr = malloc(idlen);
		for (indx=0; indx<idlen; indx++)
			*idptr++ = id[indx];
		idtable[hashval].f_name = cur_fname;
		yylval = hashval;
		return(ID);
	}

[0-9\.]+[Ee][+-][0-9]+ |
[0-9\.]+ {
	/* copy yytext[] --> id[] */
		for (indx=0; indx<yyleng && indx<IDLEN_MAX; indx++)
			id[indx] = yytext[indx];
		id[indx] = NULL;
		idlen = indx+1;

	/* hash */
		hashval = hashsave = hash(id);
		while (idtable[hashval].name != NULL) {
			if (!strcmp(id, idtable[hashval].name) && !strcmp(cur_fname, idtable[hashval].f_name)) {
				yylval = hashval;
				return(NUMBER);
			}
			hashval = rehash(hashval);
			if (hashval == hashsave)
				break;
		}
		if (idtable[hashval].name != NULL) {
			yyerror("too many IDs");
			fprintf(stderr, "scanner: current IDTBL_SIZE is %d.\n", IDTBL_SIZE);
			error_retry();
		}	

	/* new number */
		idtable[hashval].name = idptr = malloc(idlen);
		for (indx=0; indx<idlen; indx++)
			*idptr++ = id[indx];
		idtable[hashval].f_name = cur_fname;
		idtable[hashval].type = T_REAL;
		idtable[hashval].op = O_CONST;
		idtable[hashval].real = atof(id);
		yylval = hashval;
		return(NUMBER);
	}
.	;

