
/* dsm.y	87/6/15 */

%token	GENERIC	ASB	UN	INT	DIF
%token	IF	THEN	ELSE
%token	EQ	NE	GE	GT	LE	LT
%token	AT	CWITH	WRT	TO

/* real functions */
%token	ABS	SIN	COS	TAN	ASIN	ACOS	ATAN
%token	SQRT	LOG	EXP	RND

/* user definitions */
%token	ID	NUMBER

%start	program
%%
program	: program ';' statement
	| statement
	;

statement : GENERIC ID '(' exp ')' {
		if ((idtable[$4].type | T_SOLID) != T_SOLID)
			yyerror("solid expected (GENERIC)");
		ftable[cur_file_ent].id_ent = $4;
		ftable[cur_file_ent].prim_ent = 0;
	}
	| ID '=' exp {
		idtable[$1].type = idtable[$3].type;
		idtable[$1].op = O_NVP;
		idtable[$1].l_link = 0;
		idtable[$1].r_link = $3;
	}
	| {
		$$ = 0;
	}
	;

exp	: IF exp THEN exp ELSE exp {
		register int	i;

		if (idtable[$4].type & idtable[$6].type) {
			if (idtable[$4].type != idtable[$6].type)
				yyerror("type mismatch (THEN ELSE)");
		}
		i = tmpid_ent();
		idtable[i].type = (idtable[$4].type | idtable[$6].type);
		idtable[i].op = O_ITEBODY;
		idtable[i].l_link = $4;
		idtable[i].r_link = $6;

		if ((idtable[$2].type | T_REAL) != T_REAL)
			yyerror("real expression expected (IF)");
		$$ = tmpid_ent();
		idtable[$$].type = idtable[i].type;
		idtable[$$].op = O_ITE;
		idtable[$$].l_link = $2;
		idtable[$$].r_link = i;
	}
	| sexp {
		$$ = $1;
	}
	;

sexp	: sexp ASB uexp {
		if ((idtable[$1].type | idtable[$3].type | T_SOLID) != T_SOLID)
			yyerror("solid expected (ASB)");
		$$ = tmpid_ent();
		idtable[$$].type = T_SOLID;
		idtable[$$].op = O_ASB;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| uexp {
		$$ = $1;
	}
	;

uexp	: uexp UN mexp {
		if ((idtable[$1].type | idtable[$3].type | T_SOLID) != T_SOLID)
			yyerror("solid expected (UN)");
		$$ = tmpid_ent();
		idtable[$$].type = T_SOLID;
		idtable[$$].op = O_UN;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| uexp INT mexp {
		if ((idtable[$1].type | idtable[$3].type | T_SOLID) != T_SOLID)
			yyerror("solid expected (INT)");
		$$ = tmpid_ent();
		idtable[$$].type = T_SOLID;
		idtable[$$].op = O_INT;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| uexp DIF mexp {
		if ((idtable[$1].type | idtable[$3].type | T_SOLID) != T_SOLID)
			yyerror("solid expected (DIF)");
		$$ = tmpid_ent();
		idtable[$$].type = T_SOLID;
		idtable[$$].op = O_DIF;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| mexp {
		$$ = $1;
	}
	;

mexp	: mexp AT lexp {
		if ((idtable[$1].type | T_SOLID) != T_SOLID)
			yyerror("solid expected (AT)");
		if ((idtable[$3].type | T_LIST) != T_LIST)
			yyerror("list expected (AT)");
		$$ = tmpid_ent();
		idtable[$$].type = T_SOLID;
		idtable[$$].op = O_AT;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| mexp CWITH lexp {
		if ((idtable[$1].type | T_SOLID) != T_SOLID)
			yyerror("solid expected (CWITH)");
		if ((idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (CWITH)");
		$$ = tmpid_ent();
		idtable[$$].type = T_SOLID;
		idtable[$$].op = O_CWITH;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| lexp {
		$$ = $1;
	}
	;

lexp	: lexp ',' nexp {
		if ((idtable[$1].type | idtable[$3].type | T_LIST) != T_LIST)
			yyerror("list expected (,)");
		$$ = tmpid_ent();
		idtable[$$].type = T_LIST;
		idtable[$$].op = O_LIST;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| lexp WRT nexp {
		if ((idtable[$1].type | idtable[$3].type | T_LIST) != T_LIST)
			yyerror("list expected (WRT)");
		$$ = tmpid_ent();
		idtable[$$].type = T_LIST;
		idtable[$$].op = O_WRT;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| lexp TO nexp {
		if ((idtable[$1].type | idtable[$3].type | T_LIST) != T_LIST)
			yyerror("list expected (TO)");
		$$ = tmpid_ent();
		idtable[$$].type = T_LIST;
		idtable[$$].op = O_TO;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| nexp {
		$$ = $1;
	}
	;

nexp	: ID '=' nexp {
		idtable[$1].type = idtable[$3].type;
		$$ = tmpid_ent();
		idtable[$$].type = T_LIST;
		idtable[$$].op = O_PARAM;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| relexp {
		$$ = $1;
	}
	;

relexp	: relexp EQ rexp {
		if ((idtable[$1].type | idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (EQ)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_EQ;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| relexp NE rexp {
		if ((idtable[$1].type | idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (NE)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_NE;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| relexp GE rexp {
		if ((idtable[$1].type | idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (GE)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_GE;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| relexp GT rexp {
		if ((idtable[$1].type | idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (GT)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_GT;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| relexp LE rexp {
		if ((idtable[$1].type | idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (LE)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_LE;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| relexp LT rexp {
		if ((idtable[$1].type | idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (LT)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_LT;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| rexp {
		$$ = $1;
	}
	;

rexp	: rexp '+' sterm {
		if ((idtable[$1].type | idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (+)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_PLUS;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| rexp '-' sterm {
		if ((idtable[$1].type | idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (-)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_MINUS;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| sterm {
		$$ = $1;
	}
	;

sterm	: '+' sterm {
		if ((idtable[$2].type | T_REAL) != T_REAL)
			yyerror("real expression expected (+)");
		$$ = $2;
	}
	| '-' sterm {
		if ((idtable[$2].type | T_REAL) != T_REAL)
			yyerror("real expression expected (-)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_NEG;
		idtable[$$].l_link = 0;
		idtable[$$].r_link = $2;
	}
	| term {
		$$ = $1;
	}
	;

term	: term '*' phrase {
		if ((idtable[$1].type | idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (*)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_MULT;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| term '/' phrase {
		if ((idtable[$1].type | idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (/)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_DIV;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| phrase {
		$$ = $1;
	}
	;

phrase	: factor '^' phrase {
		if ((idtable[$1].type | idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (^)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_POW;
		idtable[$$].l_link = $1;
		idtable[$$].r_link = $3;
	}
	| factor {
		$$ = $1;
	}
	;

factor	: ABS '(' exp ')' {
		if ((idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (ABS)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_ABS;
		idtable[$$].l_link = 0;
		idtable[$$].r_link = $3;
	}
	| SIN '(' exp ')' {
		if ((idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (SIN)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_SIN;
		idtable[$$].l_link = 0;
		idtable[$$].r_link = $3;
	}
	| COS '(' exp ')' {
		if ((idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (COS)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_COS;
		idtable[$$].l_link = 0;
		idtable[$$].r_link = $3;
	}
	| TAN '(' exp ')' {
		if ((idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (TAN)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_TAN;
		idtable[$$].l_link = 0;
		idtable[$$].r_link = $3;
	}
	| ASIN '(' exp ')' {
		if ((idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (ASIN)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_ASIN;
		idtable[$$].l_link = 0;
		idtable[$$].r_link = $3;
	}
	| ACOS '(' exp ')' {
		if ((idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (ACOS)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_ACOS;
		idtable[$$].l_link = 0;
		idtable[$$].r_link = $3;
	}
	| ATAN '(' exp ')' {
		if ((idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (ATAN)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_ATAN;
		idtable[$$].l_link = 0;
		idtable[$$].r_link = $3;
	}
	| SQRT '(' exp ')' {
		if ((idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (SQRT)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_SQRT;
		idtable[$$].l_link = 0;
		idtable[$$].r_link = $3;
	}
	| LOG '(' exp ')' {
		if ((idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (LOG)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_LOG;
		idtable[$$].l_link = 0;
		idtable[$$].r_link = $3;
	}
	| EXP '(' exp ')' {
		if ((idtable[$3].type | T_REAL) != T_REAL)
			yyerror("real expression expected (EXP)");
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_EXP;
		idtable[$$].l_link = 0;
		idtable[$$].r_link = $3;
	}
	| RND '(' ')' {
		$$ = tmpid_ent();
		idtable[$$].type = T_REAL;
		idtable[$$].op = O_RND;
		idtable[$$].l_link = 0;
		idtable[$$].r_link = 0;
	}
	| ID '(' ')' {
		struct	stat	stbuf;
		char		*dirname();
		register int	i;

		if (*idtable[$1].name == '/') {
			idptr = malloc(strlen(idtable[$1].name)+1);
			strcpy(idptr, idtable[$1].name);
		}
		else {
			idptr = malloc(strlen(cur_wd)+strlen(idtable[$1].name)+1);
			strcpy(idptr, cur_wd);
			strcat(idptr, idtable[$1].name);
		}
		for (i=1; i<=last_file_ent; i++) {
			if (!strcmp(idptr, ftable[i].name))
				break;
		}
		if (i > last_file_ent) {
     			if (stat(idptr, &stbuf)) {
				fprintf(stderr, "\ncan't get status of %s.\n", idptr);
				exit(1);
			}
			for (i=1; i<=last_file_ent; i++) {
				if (stbuf.st_ino == ftable[i].st_ino && stbuf.st_dev == ftable[i].st_dev)
					break;
			}
		}
		if (i > last_file_ent) {
			if (++last_file_ent > FTBL_SIZE) {
				yyerror("too many files");
				fprintf(stderr, "parser: current FTBL_SIZE is %d.\n", FTBL_SIZE);
				error_retry();
			}
			ftable[last_file_ent].name   = idptr;
			ftable[last_file_ent].cwd    = dirname(idptr);
			ftable[last_file_ent].st_ino = stbuf.st_ino;
			ftable[last_file_ent].st_dev = stbuf.st_dev;
			i = last_file_ent;
		}
		else
			free(idptr);
		idtable[$1].type = T_SOLID;
		idtable[$1].op = O_FILE;
		idtable[$1].f_ent = i;
		idtable[$$].l_link = 0;
		idtable[$$].r_link = 0;
		$$ = $1;
	}
	| ID '(' exp ')' {
		struct	stat	stbuf;
		char		*dirname();
		register int	i;

		if ((idtable[$3].type | T_LIST) != T_LIST)
			yyerror("list expected (ID())");
		if (*idtable[$1].name == '/') {
			idptr = malloc(strlen(idtable[$1].name)+1);
			strcpy(idptr, idtable[$1].name);
		}
		else {
			idptr = malloc(strlen(cur_wd)+strlen(idtable[$1].name)+1);
			strcpy(idptr, cur_wd);
			strcat(idptr, idtable[$1].name);
		}
		for (i=1; i<=last_file_ent; i++) {
			if (!strcmp(idptr, ftable[i].name))
				break;
		}
		if (i > last_file_ent) {
     			if (stat(idptr, &stbuf)) {
				fprintf(stderr, "\ncan't get status of %s.\n", idptr);
				exit(1);
			}
			for (i=1; i<=last_file_ent; i++) {
				if (stbuf.st_ino == ftable[i].st_ino && stbuf.st_dev == ftable[i].st_dev)
					break;
			}
		}
		if (i > last_file_ent) {
			if (++last_file_ent > FTBL_SIZE) {
				yyerror("too many files");
				fprintf(stderr, "parser: current FTBL_SIZE is %d.\n", FTBL_SIZE);
				error_retry();
			}
			ftable[last_file_ent].name   = idptr;
			ftable[last_file_ent].cwd    = dirname(idptr);
			ftable[last_file_ent].st_ino = stbuf.st_ino;
			ftable[last_file_ent].st_dev = stbuf.st_dev;
			i = last_file_ent;
		}
		else
			free(idptr);
		$$ = tmpid_ent();
		idtable[$$].type = T_SOLID;
		idtable[$$].op = O_FILE;
		idtable[$$].f_ent = i;
		idtable[$$].l_link = 0;
		idtable[$$].r_link = $3;
	}
	| ID {
		$$ = $1;
	}
	| NUMBER {
		$$ = $1;
	}
	| '(' exp ')' {
		$$ = $2;
	}
	;
%%

#include "dsm.h"
#include "lex.yy.c"

init_t()
{
	int	i, j;

	i = tmpid_ent();
	idtable[i].type = T_REAL;
	idtable[i].op = O_CONST;
	idtable[i].real = 0.0;
	j = sysid_ent("_t");
	idtable[j].type = T_REAL;
	idtable[j].op = O_NVP;
	idtable[j].l_link = 0;
	idtable[j].r_link = i;

	TIME_T_ENT = &idtable[i].real;
}
tmpid_ent()
{
	char	id[10];

/* get tmp_id */
	sprintf(id, "$%-d", ++last_tmpid_ent);
	return(sysid_ent(id));
}
sysid_ent(id) char *id;
{
	void	*malloc();
	char	*idptr;
	int	idlen, indx;
	int	hashval, hashsave;

/* hash */
	hashval = hashsave = hash(id);
	while (idtable[hashval].name != NULL) {
		if (!strcmp(id, idtable[hashval].name))
			return(hashval);
		hashval = rehash(hashval);
		if (hashval == hashsave)
			break;
	}
	if (idtable[hashval].name != NULL) {
		yyerror("too many IDs");
		fprintf(stderr, "parser: current IDTBL_SIZE is %d.\n", IDTBL_SIZE);
		error_retry();
	}	

/* new identifier */
	idlen = strlen(id)+1;
	idtable[hashval].name = idptr = malloc(idlen);
	for (indx=0; indx<idlen; indx++)
		*idptr++ = id[indx];
	idtable[hashval].f_name = cur_fname;
	return(hashval);
}
hash(s) register char *s;
{
	register int	hashval;
	
	for (hashval=0; *s!=NULL;)
	  	hashval += *s++;
	return(hashval % IDTBL_SIZE+1);
}
yyerror(s) char *s;
{
	if (++y_errnum == 1)
		fprintf(stderr, "\n");
#if 0
	if (y_errline < yylineno) {
		y_errline = yylineno;
		fprintf(stderr, "\"%s\", line %d: %s.\n", cur_fname, y_errline, s);
	}
#else
	fprintf(stderr, "\"%s\", line \"%s\": %s.\n", cur_fname, yytext, s);
#endif
}
error_retry()
{
	if (rread_count > 1) {
		fprintf(stderr, "retry...");
		execlp(program_name, program_name, obj_fname, 0);
	}
	else
		exit(1);
}

