
/* handle_solid	87/6/15 */

#include "dsm.h"

init_breps()
{
	breps1.brep   = brep1;
	breps1.face   = face1;
	breps1.xloop  = xloop1;
	breps1.xedge  = xedge1;
	breps1.dpoint = dpoint1;
	breps1.dvect  = dvect1;
	breps1.pxx    = pxx1;
	breps1.exx    = exx1;

#ifdef DIADIC
	breps2.brep   = brep2;
	breps2.face   = face2;
	breps2.xloop  = xloop2;
	breps2.xedge  = xedge2;
	breps2.dpoint = dpoint2;
	breps2.dvect  = dvect2;
	breps2.pxx    = pxx2;
	breps2.exx    = exx2;
#endif
}
read_prim(fp) FILE *fp;
{
	struct prim	*tp_prim;
	struct pface	*tp_pfac;
	struct pxloop	*tp_pxlo;
	struct pxedge	*tp_pxed;
	struct pdpoint	*tp_pdpo;
	struct pdvect	*tp_pdve;
        register int	pfacofs, pxloofs, pxedofs, pdpoofs, pdveofs;
	int		sum;

/* append to prim */
	if (++lst_prim_ent > PRIM_SIZE) {
		yyerror("too many files");
		fprintf(stderr, "read_prim: current PRIM_SIZE is %d\n", PRIM_SIZE);
		error_retry();
	}

/* store current pointer */
	tp_prim = &prim[lst_prim_ent];
	tp_prim->pfactop = (pfacofs = lst_pfac_ent)+1;
	tp_prim->pxlotop = (pxloofs = lst_pxlo_ent)+1;
	tp_prim->pxedtop = (pxedofs = lst_pxed_ent)+1;
	tp_prim->pdpotop = (pdpoofs = lst_pdpo_ent)+1;
	tp_prim->pdvetop = (pdveofs = lst_pdve_ent)+1;

/* read pface */
	fscanf(fp, "%d", &sum);
	tp_prim->pfacnum = sum;
	for (lst_pfac_ent=pfacofs+1; lst_pfac_ent<=pfacofs+sum; lst_pfac_ent++) {
		if (lst_pfac_ent > PFAC_SIZE) {
			yyerror("too many pface");
			fprintf(stderr, "read_prim: current PFAC_SIZE is %d\n", PFAC_SIZE);
			error_retry();
		}
		tp_pfac = &pface[lst_pfac_ent];
		fscanf(fp, "%d %d %d %d",
			&(tp_pfac->facolor), &(tp_pfac->fasssw),
			&(tp_pfac->favect), &(tp_pfac->xlotop));
	}
	lst_pfac_ent--;

/* read pxloop */
	fscanf(fp, "%d", &sum);
	tp_prim->pxlonum = sum;
	for (lst_pxlo_ent=pxloofs+1; lst_pxlo_ent<=pxloofs+sum; lst_pxlo_ent++) {
		if (lst_pxlo_ent > PXLO_SIZE) {
			yyerror("too many pxloop");
			fprintf(stderr, "read_prim: current PXLO_SIZE is %d\n", PXLO_SIZE);
			error_retry();
		}
		tp_pxlo = &pxloop[lst_pxlo_ent];
		fscanf(fp, "%d %d", &(tp_pxlo->r_link), &(tp_pxlo->xedtop));
	}
	lst_pxlo_ent--;

/* read pxedge */
	fscanf(fp, "%d", &sum);
	tp_prim->pxednum = sum;
	for (lst_pxed_ent=pxedofs+1; lst_pxed_ent<=pxedofs+sum; lst_pxed_ent++) {
		if (lst_pxed_ent > PXED_SIZE) {
			yyerror("too many pxedge");
			fprintf(stderr, "read_prim: current PXED_SIZE is %d\n", PXED_SIZE);
			error_retry();
		}
		tp_pxed = &pxedge[lst_pxed_ent];
		fscanf(fp, "%d %d %d %d %d %d %d %d",
			&(tp_pxed->link1), &(tp_pxed->link2),
			&(tp_pxed->fa1), &(tp_pxed->fa2),
			&(tp_pxed->dp1), &(tp_pxed->dp2),
			&(tp_pxed->dv1), &(tp_pxed->dv2));
	}
	lst_pxed_ent--;

/* read pmaxdpoint */
	fscanf(fp, "%le", &(tp_prim->pmaxdpo));

/* read pdpoint */
	fscanf(fp, "%d", &sum);
	tp_prim->pdponum = sum;
	for (lst_pdpo_ent=pdpoofs+1; lst_pdpo_ent<=pdpoofs+sum; lst_pdpo_ent++) {
		if (lst_pdpo_ent > PDPO_SIZE) {
			yyerror("too many pdpoint");
			fprintf(stderr, "read_prim: current PDPO_SIZE is %d\n", PDPO_SIZE);
			error_retry();
		}
		tp_pdpo = &pdpoint[lst_pdpo_ent];
	 	fscanf(fp, "%le %le %le %d",
			&(tp_pdpo->x), &(tp_pdpo->y), &(tp_pdpo->z), &(tp_pdpo->ref));
	}
	lst_pdpo_ent--;

/* read pdvect */
	fscanf(fp, "%d", &sum);
	tp_prim->pdvenum = sum;
	for (lst_pdve_ent=pdveofs+1; lst_pdve_ent<=pdveofs+sum; lst_pdve_ent++) {
		if (lst_pdve_ent > PDVE_SIZE) {
			yyerror("too many pdvect");
			fprintf(stderr, "read_prim: current PDVE_SIZE is %d\n", PDVE_SIZE);
			error_retry();
		}
		tp_pdve = &pdvect[lst_pdve_ent];
		fscanf(fp, "%le %le %le %d",
			&(tp_pdve->x), &(tp_pdve->y), &(tp_pdve->z), &(tp_pdve->ref));
		v_norm(tp_pdve->x, tp_pdve->y, tp_pdve->z, &(tp_pdve->x), &(tp_pdve->y), &(tp_pdve->z));
	}
	lst_pdve_ent--;

	return(lst_prim_ent);
}
expand_prim(prim_ent, breps) int prim_ent; struct breps *breps;
{
	struct brep	*brep   = breps->brep;
	struct face	*face   = breps->face;
	struct xloop	*xloop  = breps->xloop;
	struct xedge	*xedge  = breps->xedge;
	struct dpoint	*dpoint = breps->dpoint;
	struct dvect	*dvect  = breps->dvect;
	int		*ls_brep_ent = &(breps->ls_brep_ent);
	int		*ls_fac_ent  = &(breps->ls_fac_ent);
	int		*ls_xlo_ent  = &(breps->ls_xlo_ent);
	int		*ls_xed_ent  = &(breps->ls_xed_ent);
	int		*ls_dpo_ent  = &(breps->ls_dpo_ent);
	int		*ls_dve_ent  = &(breps->ls_dve_ent);
	struct prim	*tp_prim;
	struct pface	*tp_pfac;
	struct pxloop	*tp_pxlo;
	struct pxedge	*tp_pxed;
	struct pdpoint	*tp_pdpo;
	struct pdvect	*tp_pdve;
	struct brep	*tp_brep;
	struct face	*tp_fac;
	struct xloop	*tp_xlo;
	struct xedge	*tp_xed;
	struct dpoint	*tp_dpo;
	struct dvect	*tp_dve;
        int		pfacofs, pxloofs, pxedofs, pdpoofs, pdveofs;
        register int	facofs, xloofs, xedofs, dpoofs, dveofs;
	register int	i;

	if (++(*ls_brep_ent) > BREP_SIZE) {
		fprintf(stderr, "expand_prim: current BREP_SIZE is %d\n", BREP_SIZE);
		exit(1);
	}

/* store current pointer */
	tp_prim = &prim[prim_ent];
	pfacofs = tp_prim->pfactop-1;
	pxloofs = tp_prim->pxlotop-1;
	pxedofs = tp_prim->pxedtop-1;
	pdpoofs = tp_prim->pdpotop-1;
	pdveofs = tp_prim->pdvetop-1;
	tp_brep = brep+(*ls_brep_ent);
	tp_brep->factop = (facofs = *ls_fac_ent)+1;
	tp_brep->xlotop = (xloofs = *ls_xlo_ent)+1;
	tp_brep->xedtop = (xedofs = *ls_xed_ent)+1;
	tp_brep->dpotop = (dpoofs = *ls_dpo_ent)+1;
	tp_brep->dvetop = (dveofs = *ls_dve_ent)+1;
	tp_brep->facnum = tp_prim->pfacnum;
	tp_brep->xlonum = tp_prim->pxlonum;
	tp_brep->xednum = tp_prim->pxednum;
	tp_brep->dponum = tp_prim->pdponum;
	tp_brep->dvenum = tp_prim->pdvenum;

/* expand face */
	for (i=1; i<=tp_brep->facnum; i++, (*ls_fac_ent)++) {
		if (*ls_fac_ent > FAC_SIZE) {
			fprintf(stderr, "expand_prim: current FAC_SIZE is %d\n", FAC_SIZE);
			exit(1);
		}
		tp_pfac = &pface[pfacofs+i];
		tp_fac = face+facofs+i;
		tp_fac->facolor = tp_pfac->facolor;
		tp_fac->fasssw  = tp_pfac->fasssw;
		tp_fac->favect  = tp_pfac->favect+dveofs;
		tp_fac->a_link  = 0;
		tp_fac->xlotop  = tp_pfac->xlotop+xloofs;
		tp_fac->exxtop  = 0;
		tp_fac->pe      = 0;
	}

/* expand xloop */
	for (i=1; i<=tp_brep->xlonum; i++, (*ls_xlo_ent)++) {
		if (*ls_xlo_ent > XLO_SIZE) {
			fprintf(stderr, "expand_prim: current XLO_SIZE is %d\n", XLO_SIZE);
			exit(1);
		}
		tp_pxlo = &pxloop[pxloofs+i];
		tp_xlo = xloop+xloofs+i;
		tp_xlo->bl_link = xloofs+i-1;
		tp_xlo->br_link = xloofs+i+1;
		tp_xlo->r_link  = tp_pxlo->r_link+xloofs;
		tp_xlo->xedtop  = tp_pxlo->xedtop+xedofs;
	}
	(xloop+xloofs+1              )->bl_link = xloofs+tp_brep->xlonum;
	(xloop+xloofs+tp_brep->xlonum)->br_link = xloofs+1;

/* expand xedge */
	for (i=1; i<=tp_brep->xednum; i++, (*ls_xed_ent)++) {
		if (*ls_xed_ent > XED_SIZE) {
			fprintf(stderr, "expand_prim: current XED_SIZE is %d\n", XED_SIZE);
			exit(1);
		}
		tp_pxed = &pxedge[pxedofs+i];
		tp_xed = xedge+xedofs+i;
		tp_xed->io1 = 0.0;
		tp_xed->io2 = 0.0;
		tp_xed->bd1 = 0;
		tp_xed->bd2 = 0;
		tp_xed->bl_link = xedofs+i-1;
		tp_xed->br_link = xedofs+i+1;
		tp_xed->a_link  = 0;
		tp_xed->link1   = tp_pxed->link1+xedofs;
		tp_xed->link2   = tp_pxed->link2+xedofs;
		tp_xed->fa1     = tp_pxed->fa1+facofs;
		tp_xed->fa2     = tp_pxed->fa2+facofs;
		tp_xed->dp1     = tp_pxed->dp1+dpoofs;
		tp_xed->dp2     = tp_pxed->dp2+dpoofs;
		tp_xed->dv1     = tp_pxed->dv1+dveofs;
		tp_xed->dv2     = tp_pxed->dv2+dveofs;
	}
	(xedge+xedofs+1              )->bl_link = xedofs+tp_brep->xednum;
	(xedge+xedofs+tp_brep->xednum)->br_link = xedofs+1;

/* expand maxdpo */
	tp_brep->maxdpo = tp_prim->pmaxdpo;

/* expand dpoint */
	for (i=1; i<=tp_brep->dponum; i++, (*ls_dpo_ent)++) {
		if (*ls_dpo_ent > DPO_SIZE) {
			fprintf(stderr, "expand_prim: current DPO_SIZE is %d\n", DPO_SIZE);
			exit(1);
		}
		tp_pdpo = &pdpoint[pdpoofs+i];
		tp_dpo = dpoint+dpoofs+i;
	 	tp_dpo->x = tp_pdpo->x;
		tp_dpo->y = tp_pdpo->y;
		tp_dpo->z = tp_pdpo->z;
		tp_dpo->ref     = tp_pdpo->ref;
		tp_dpo->bl_link = dpoofs+i-1;
		tp_dpo->br_link = dpoofs+i+1;
		tp_dpo->a_link  = 0;
		tp_dpo->pxxtop  = 0;
	}
	(dpoint+dpoofs+1              )->bl_link = dpoofs+tp_brep->dponum;
	(dpoint+dpoofs+tp_brep->dponum)->br_link = dpoofs+1;

/* expand dvect */
	for (i=1; i<=tp_brep->dvenum; i++, (*ls_dve_ent)++) {
		if (*ls_dve_ent > DVE_SIZE) {
			fprintf(stderr, "expand_prim: current DVE_SIZE is %d\n", DVE_SIZE);
			exit(1);
		}
		tp_pdve = &pdvect[pdveofs+i];
		tp_dve = dvect+dveofs+i;
		tp_dve->x = tp_pdve->x;
		tp_dve->y = tp_pdve->y;
		tp_dve->z = tp_pdve->z;
		tp_dve->ref     = tp_pdve->ref;
		tp_dve->bl_link = dveofs+i-1;
		tp_dve->br_link = dveofs+i+1;
		tp_dve->a_link  = 0;
	}
	(dvect+dveofs+1              )->bl_link = dveofs+tp_brep->dvenum;
	(dvect+dveofs+tp_brep->dvenum)->br_link = dveofs+1;

	return(*ls_brep_ent);
}
save_brep(fp, breps) FILE *fp; struct breps *breps;
{
	struct brep	*brep   = breps->brep;
	struct face	*face   = breps->face;
	struct xloop	*xloop  = breps->xloop;
	struct xedge	*xedge  = breps->xedge;
	struct dpoint	*dpoint = breps->dpoint;
	struct dvect	*dvect  = breps->dvect;
	int		*ls_brep_ent = &(breps->ls_brep_ent);
	struct brep	*tp_brep;
	struct face	*tp_fac;
	struct xloop	*tp_xlo;
	struct xedge	*tp_xed;
	struct dpoint	*tp_dpo;
	struct dvect	*tp_dve;
	double		getmaxdpo();
	register int	newnum, sum, i, j;

	for (newnum=1, i=1; i<=*ls_brep_ent; i++) {
		tp_brep = brep+i;
		for (j=tp_brep->factop; j<tp_brep->factop+tp_brep->facnum; j++) {
			tp_fac = face+j;
			if (tp_fac->xlotop)
				tp_fac->work = newnum++;
		}
	}
	for (newnum=1, i=1; i<=*ls_brep_ent; i++) {
		tp_brep = brep+i;
		for (tp_xlo=xloop+tp_brep->xlotop, j=1; j<=tp_brep->xlonum; j++) {
			tp_xlo->bl_link = newnum++;
			tp_xlo = xloop+tp_xlo->br_link;
		}
	}
	for (newnum=1, i=1; i<=*ls_brep_ent; i++) {
		tp_brep = brep+i;
		for (tp_xed=xedge+tp_brep->xedtop, j=1; j<=tp_brep->xednum; j++) {
			tp_xed->bl_link = newnum++;
			tp_xed = xedge+tp_xed->br_link;
		}
	}
	for (newnum=1, i=1; i<=*ls_brep_ent; i++) {
		tp_brep = brep+i;
		for (tp_dpo=dpoint+tp_brep->dpotop, j=1; j<=tp_brep->dponum; j++) {
			tp_dpo->bl_link = newnum++;
			tp_dpo = dpoint+tp_dpo->br_link;
		}
	}
	for (newnum=1, i=1; i<=*ls_brep_ent; i++) {
		tp_brep = brep+i;
		for (tp_dve=dvect+tp_brep->dvetop, j=1; j<=tp_brep->dvenum; j++) {
			tp_dve->bl_link = newnum++;
			tp_dve = dvect+tp_dve->br_link;
		}
	}

/* write face */
	for (sum=0, i=1; i<=*ls_brep_ent; i++) {
		tp_brep = brep+i;
		for (j=tp_brep->factop; j<tp_brep->factop+tp_brep->facnum; j++) {
			if ((face+j)->xlotop)
				sum++;
		}
	}
	fprintf(fp, "%d\n", sum);
	for (i=1; i<=*ls_brep_ent; i++) {
		tp_brep = brep+i;
		for (j=tp_brep->factop; j<tp_brep->factop+tp_brep->facnum; j++) {
			tp_fac = face+j;
			if (tp_fac->xlotop)
				fprintf(fp, "%d %d %d %d\n",
					tp_fac->facolor,
					tp_fac->fasssw,
					(dvect+tp_fac->favect)->bl_link,
					(xloop+tp_fac->xlotop)->bl_link);
		}
	}

/* write xloop */
	for (sum=0, i=1; i<=*ls_brep_ent; i++)
		sum += (brep+i)->xlonum;
	fprintf(fp, "%d\n", sum);
	for (i=1; i<=*ls_brep_ent; i++) {
		tp_brep = brep+i;
		for (tp_xlo=xloop+tp_brep->xlotop, j=1; j<=tp_brep->xlonum; j++) {
			fprintf(fp, "%d %d\n",
				(xloop+tp_xlo->r_link)->bl_link,
				(xedge+tp_xlo->xedtop)->bl_link);
			tp_xlo = xloop+tp_xlo->br_link;
		}
	}

/* write xedge */
	for (sum=0, i=1; i<=*ls_brep_ent; i++)
		sum += (brep+i)->xednum;
	fprintf(fp, "%d\n", sum);
	for (i=1; i<=*ls_brep_ent; i++) {
		tp_brep = brep+i;
		for (tp_xed=xedge+tp_brep->xedtop, j=1; j<=tp_brep->xednum; j++) {
			fprintf(fp, "%d %d %d %d %d %d %d %d\n",
				(xedge+tp_xed->link1)->bl_link,
				(xedge+tp_xed->link2)->bl_link,
				(face+tp_xed->fa1)->work,
				(face+tp_xed->fa2)->work,
				(dpoint+tp_xed->dp1)->bl_link,
				(dpoint+tp_xed->dp2)->bl_link,
				(dvect+tp_xed->dv1)->bl_link,
				(dvect+tp_xed->dv2)->bl_link);
			tp_xed = xedge+tp_xed->br_link;
		}
	}

/* write maxdpo */
	fprintf(fp, "%.18g\n", getmaxdpo(breps));

/* write dpoint */
	for (sum=0, i=1; i<=*ls_brep_ent; i++)
		sum += (brep+i)->dponum;
	fprintf(fp, "%d\n", sum);
	for (i=1; i<=*ls_brep_ent; i++) {
		tp_brep = brep+i;
		for (tp_dpo=dpoint+tp_brep->dpotop, j=1; j<=tp_brep->dponum; j++) {
	 		fprintf(fp, "%.18g %.18g %.18g %d\n",
				tp_dpo->x, tp_dpo->y, tp_dpo->z, tp_dpo->ref);
			tp_dpo = dpoint+tp_dpo->br_link;
		}
	}

/* write dvect */
	for (sum=0, i=1; i<=*ls_brep_ent; i++)
		sum += (brep+i)->dvenum;
	fprintf(fp, "%d\n", sum);
	for (i=1; i<=*ls_brep_ent; i++) {
		tp_brep = brep+i;
		for (tp_dve=dvect+tp_brep->dvetop, j=1; j<=tp_brep->dvenum; j++) {
			fprintf(fp, "%.18g %.18g %.18g %d\n",
				tp_dve->x, tp_dve->y, tp_dve->z, tp_dve->ref);
			tp_dve = dvect+tp_dve->br_link;
		}
	}
}
double getmaxdpo(breps) struct breps *breps;
{
	register struct brep	*brep   = breps->brep;
	register struct dpoint	*dpoint = breps->dpoint;
	int			*ls_brep_ent = &(breps->ls_brep_ent);
	register struct brep	*tp_brep;
	register struct dpoint	*tp_dpo;
	double			tp_dbl;
	double			retval;
	register int		i, j;

	retval = 0.0;
	for (i=1; i<=*ls_brep_ent; i++) {
		tp_brep = brep+i;
		for (tp_dpo=dpoint+tp_brep->dpotop, j=1; j<=tp_brep->dponum; j++) {
			v_len(tp_dpo->x, tp_dpo->y, tp_dpo->z, &tp_dbl);
			if (retval < tp_dbl)
				retval = tp_dbl;
			tp_dpo = dpoint+tp_dpo->br_link;
		}
	}
	return(retval);
}

