
/* tbl_to_csg.c	87/6/18 */

#include "dsm.h"

get_tmin(t_tmin) double *t_tmin;
{
	struct motion	dmy_mot;
	int		dmy_alias;
	int		dmy_csg_ent;
	int		tp_id_ent;

	c_errnum = 0;
	last_csg_ent = 0;
	last_motion_ent = 0;

	if (tp_id_ent = tbl_srch("_tmin", ftable[1].name)) {
		if (tbl_trav(ftable[1].name, tp_id_ent, L_UNDEF, &dmy_alias, &dmy_csg_ent, &dmy_mot, t_tmin) != R_REAL)
			csg_error(tp_id_ent, "_tmin not real");
		if (c_errnum)
			*t_tmin = 0.0;
	}
	else
		*t_tmin = 0.0;
}
get_tmax(t_tmax) double *t_tmax;
{
	struct motion	dmy_mot;
	int		dmy_alias;
	int		dmy_csg_ent;
	int		tp_id_ent;

	c_errnum = 0;
	last_csg_ent = 0;
	last_motion_ent = 0;

	if (tp_id_ent = tbl_srch("_tmax", ftable[1].name)) {
		if (tbl_trav(ftable[1].name, tp_id_ent, L_UNDEF, &dmy_alias, &dmy_csg_ent, &dmy_mot, t_tmax) != R_REAL)
			csg_error(tp_id_ent, "_tmax not real");
		if (c_errnum)
			*t_tmax = 0.0;
	}
	else
		*t_tmax = 0.0;
}
get_tstep(t_tstep) double *t_tstep;
{
	struct motion	dmy_mot;
	int		dmy_alias;
	int		dmy_csg_ent;
	int		tp_id_ent;

	c_errnum = 0;
	last_csg_ent = 0;
	last_motion_ent = 0;

	if (tp_id_ent = tbl_srch("_tstep", ftable[1].name)) {
		if (tbl_trav(ftable[1].name, tp_id_ent, L_UNDEF, &dmy_alias, &dmy_csg_ent, &dmy_mot, t_tstep) != R_REAL)
			csg_error(tp_id_ent, "_tstep not real");
		if (c_errnum)
			*t_tstep = 1.0;
	}
	else
		*t_tstep = 1.0;
}
get_view(t_view) struct motion *t_view;
{
	double		dmy_real;
	int		dmy_alias;
	int		dmy_csg_ent;
	int		tp_id_ent;

	c_errnum = 0;
	last_csg_ent = 0;
	last_motion_ent = 0;

	if (tp_id_ent = tbl_srch("_view", ftable[1].name)) {
		if (tbl_trav(ftable[1].name, tp_id_ent, L_MOTION, &dmy_alias, &dmy_csg_ent, t_view, &dmy_real) != R_MOTION)
			csg_error(tp_id_ent, "_view not motion");
		if (c_errnum)
			m_copy(STD_MOTION, t_view);
	}
	else
		m_copy(STD_MOTION, t_view);
}
get_ray(t_ray) struct motion *t_ray;
{
	double		dmy_real;
	int		dmy_alias;
	int		dmy_csg_ent;
	int		tp_id_ent;

	c_errnum = 0;
	last_csg_ent = 0;
	last_motion_ent = 0;

	if (tp_id_ent = tbl_srch("_ray", ftable[1].name)) {
		if (tbl_trav(ftable[1].name, tp_id_ent, L_MOTION, &dmy_alias, &dmy_csg_ent, t_ray, &dmy_real) != R_MOTION)
			csg_error(tp_id_ent, "_ray not motion");
		if (c_errnum)
			m_copy(STD_MOTION, t_ray);
	}
	else
		m_copy(STD_MOTION, t_ray);
}
get_bgcol(t_bgcol) double *t_bgcol;
{
	struct motion	dmy_mot;
	int		dmy_alias;
	int		dmy_csg_ent;
	int		tp_id_ent;

	c_errnum = 0;
	last_csg_ent = 0;
	last_motion_ent = 0;

	if (tp_id_ent = tbl_srch("_bgcol", ftable[1].name)) {
		if (tbl_trav(ftable[1].name, tp_id_ent, L_UNDEF, &dmy_alias, &dmy_csg_ent, &dmy_mot, &t_bgcol) != R_REAL)
			csg_error(tp_id_ent, "_bgcol not real");
		if (c_errnum)
			*t_bgcol = 0.0;
	}
	else
		*t_bgcol = 0.0;
}
get_bgint(t_bgint) double *t_bgint;
{
	struct motion	dmy_mot;
	int		dmy_alias;
	int		dmy_csg_ent;
	int		tp_id_ent;

	c_errnum = 0;
	last_csg_ent = 0;
	last_motion_ent = 0;

	if (tp_id_ent = tbl_srch("_bgint", ftable[1].name)) {
		if (tbl_trav(ftable[1].name, tp_id_ent, L_UNDEF, &dmy_alias, &dmy_csg_ent, &dmy_mot, t_bgint) != R_REAL)
			csg_error(tp_id_ent, "_bgint not real");
		if (c_errnum)
			*t_bgint = 0.0;
	}
	else
		*t_bgint = 0.0;
}
get_object(t_object) int *t_object;
{
	struct motion	dmy_mot;
	double		dmy_real;
	int		dmy_alias;

	c_errnum = 0;
	last_csg_ent = 0;
	last_motion_ent = 0;

	if (ftable[1].id_ent) {
		if (tbl_trav(ftable[1].name, ftable[1].id_ent, L_UNDEF, &dmy_alias, t_object, &dmy_mot, &dmy_real) != R_CSG)
			csg_error(ftable[1].id_ent, "object not solid");
		if (c_errnum)
			*t_object = 0;
	}
	else if (ftable[1].prim_ent)
		*t_object = csg_ent(C_PRIMITIVE, ftable[1].prim_ent, 0, 1.0, 1.0, 1.0, -1.0);
	else {
		csg_error(ftable[1].id_ent, "object not solid");
		*t_object = 0;
	}
}

