
/* tbl_traverse.c	87/6/18 */

#include "dsm.h"

tbl_trav(gen_fname, cur_id_ent, cur_type, ret_alias, ret_csg_ent, ret_mot, ret_real)
	char			*gen_fname;
	register int		cur_id_ent, cur_type;
	register int		*ret_alias;
	register int		*ret_csg_ent;
	register struct motion	*ret_mot;
	register double		*ret_real;
{
	struct motion		tp_mot, tp_mot2;
	double			o_eq(), o_ne(), o_ge(), o_gt(), o_le(), o_lt();
	double			o_plus(), o_minus(), o_mult(), o_div();
	double			o_neg(), o_abs();
	double			tp_real, tp_real2;
	double			(*real_func)();
	static double		prim_x, prim_y, prim_z, prim_col;
	int			csg_func;
	int			tp_ali, tp_ali2;
	int			tp_csg_ent, tp_csg2_ent;
	int			tp_type;
	int			a_link_head;
	int			cur_op;

	if (idtable[cur_id_ent].wanted == W_YES) {
		csg_error(cur_id_ent, "cyclic definition");
		return(R_UNDEF);
	}
	idtable[cur_id_ent].wanted = W_YES;

	cur_op = idtable[cur_id_ent].op;

	if (cur_op & OM_ETC) {
		switch (cur_op) {
		case O_FILE:
			if (ftable[idtable[cur_id_ent].f_ent].id_ent) {
				a_link_head = 0;
				if (idtable[cur_id_ent].r_link) {
					if (tbl_trav(ftable[idtable[cur_id_ent].f_ent].name, idtable[cur_id_ent].r_link, L_GENERIC, &a_link_head, &tp_csg_ent, &tp_mot, &tp_real) != R_PARAM) {
						csg_error(cur_id_ent, "illegal parameter < ID(exp) >");
						idtable[cur_id_ent].wanted = W_NO;
						return(R_UNDEF);
					}
				}
				if (tbl_trav(gen_fname, ftable[idtable[cur_id_ent].f_ent].id_ent, cur_type, &tp_ali, ret_csg_ent, &tp_mot, &tp_real) == R_CSG) {
					while (a_link_head) {
						tp_ali = a_link_head;
						a_link_head = idtable[a_link_head].a_link;
						idtable[tp_ali].alias = 0;
						idtable[tp_ali].a_link = 0;
					}
					idtable[cur_id_ent].wanted = W_NO;
					return(R_CSG);
				}
				else {
					csg_error(cur_id_ent, "illegal generic < ID(exp) >");
					idtable[cur_id_ent].wanted = W_NO;
					return(R_UNDEF);
				}
			}
			else {
				prim_x = prim_y = prim_z = 1.0;
				prim_col = -1.0;
				if (idtable[cur_id_ent].r_link) {
					if (tbl_trav(gen_fname, idtable[cur_id_ent].r_link, L_PRIMITIVE, &tp_ali, &tp_csg_ent, &tp_mot, &tp_real) != R_PARAM) {
						csg_error(cur_id_ent, "illegal parameter < ID(exp) >");
						idtable[cur_id_ent].wanted = W_NO;
						return(R_UNDEF);
					}
				}
				if (prim_x > 0.0 && prim_y > 0.0 && prim_z > 0.0) {
					*ret_csg_ent = csg_ent(C_PRIMITIVE, ftable[idtable[cur_id_ent].f_ent].prim_ent, 0, prim_x, prim_y, prim_z, prim_col);
					idtable[cur_id_ent].wanted = W_NO;
					return(R_CSG);
				}
				else {
					csg_error(cur_id_ent, "parameter must be positive");
					idtable[cur_id_ent].wanted = W_NO;
					return(R_UNDEF);
				}
			}
			break;
		case O_ITE:
			if (tbl_trav(gen_fname, idtable[cur_id_ent].l_link, cur_type, &tp_ali, &tp_csg_ent, &tp_mot, &tp_real) == R_REAL) {
				if (tp_real != 0.0)
					tp_type = tbl_trav(gen_fname, idtable[idtable[cur_id_ent].r_link].l_link, cur_type, ret_alias, ret_csg_ent, ret_mot, ret_real);
				else
					tp_type = tbl_trav(gen_fname, idtable[idtable[cur_id_ent].r_link].r_link, cur_type, ret_alias, ret_csg_ent, ret_mot, ret_real);
				idtable[cur_id_ent].wanted = W_NO;
				return(tp_type);
			}
			else {
				csg_error(cur_id_ent, "real expression expected < IF exp THEN exp ELSE exp >");
				idtable[cur_id_ent].wanted = W_NO;
				return(R_UNDEF);
			}
			break;
		case O_NVP:
			if (idtable[cur_id_ent].alias)
				tp_type = tbl_trav(gen_fname, idtable[cur_id_ent].alias, cur_type, ret_alias, ret_csg_ent, ret_mot, ret_real);
			else
				tp_type = tbl_trav(gen_fname, idtable[cur_id_ent].r_link, cur_type, ret_alias, ret_csg_ent, ret_mot, ret_real);
			idtable[cur_id_ent].wanted = W_NO;
			return(tp_type);
			break;
		case O_PARAM:
			switch (cur_type) {
			case L_GENERIC:
				if (*ret_alias = tbl_srch(idtable[idtable[cur_id_ent].l_link].name, gen_fname))
					idtable[*ret_alias].alias = idtable[cur_id_ent].r_link;
				idtable[cur_id_ent].wanted = W_NO;
				return(R_PARAM);
				break;
			case L_PRIMITIVE:
			 	if (tbl_trav(gen_fname, idtable[cur_id_ent].r_link, cur_type, &tp_ali, &tp_csg_ent, &tp_mot, &tp_real) == R_REAL) {
			 		switch (idtable[idtable[cur_id_ent].l_link].reserved) {
					case S_X:
						prim_x = tp_real;
						break;
					case S_Y:
						prim_y = tp_real;
						break;
					case S_Z:
						prim_z = tp_real;
						break;
					case S_COL:
						prim_col = tp_real;
						break;
					default:
						csg_error(cur_id_ent, "illegal parameter < ID=nexp >");
						idtable[cur_id_ent].wanted = W_NO;
						return(R_UNDEF);
						break;
					}
					idtable[cur_id_ent].wanted = W_NO;
					return(R_PARAM);
				}
				else {
					csg_error(cur_id_ent, "real expression expected < ID=nexp >");
					idtable[cur_id_ent].wanted = W_NO;
					return(R_UNDEF);
				}
				break;
			case L_MOTION:
			 	if (tbl_trav(gen_fname, idtable[cur_id_ent].r_link, cur_type, &tp_ali, &tp_csg_ent, &tp_mot, &tp_real) == R_REAL) {
			 		switch (idtable[idtable[cur_id_ent].l_link].reserved) {
					case S_MOVX:
						m_movx(tp_real, STD_MOTION, ret_mot);
						break;
					case S_MOVY:
						m_movy(tp_real, STD_MOTION, ret_mot);
						break;
					case S_MOVZ:
						m_movz(tp_real, STD_MOTION, ret_mot);
						break;
					case S_DEGX:
						m_degx(tp_real, STD_MOTION, ret_mot);
						break;
					case S_DEGY:
						m_degy(tp_real, STD_MOTION, ret_mot);
						break;
					case S_DEGZ:
						m_degz(tp_real, STD_MOTION, ret_mot);
						break;
					case S_ROTX:
						m_rotx(tp_real, STD_MOTION, ret_mot);
						break;
					case S_ROTY:
						m_roty(tp_real, STD_MOTION, ret_mot);
						break;
					case S_ROTZ:
						m_rotz(tp_real, STD_MOTION, ret_mot);
						break;
					default:
						csg_error(cur_id_ent, "illegal motion < ID=nexp >");
						idtable[cur_id_ent].wanted = W_NO;
						return(R_UNDEF);
						break;
					}
					idtable[cur_id_ent].wanted = W_NO;
					return(R_MOTION);
				}
				else {
					csg_error(cur_id_ent, "real expression expected < ID=nexp >");
					idtable[cur_id_ent].wanted = W_NO;
					return(R_UNDEF);
				}
				break;
			default:
				csg_error(cur_id_ent, "unknown parameter < ID=nexp >");
				idtable[cur_id_ent].wanted = W_NO;
				return(R_UNDEF);
				break;
			}
			break;
		case O_AT:
			if (tbl_trav(gen_fname, idtable[cur_id_ent].l_link, cur_type, &tp_ali, ret_csg_ent, &tp_mot, &tp_real) == R_CSG
			 && tbl_trav(gen_fname, idtable[cur_id_ent].r_link, L_MOTION, &tp_ali2, &tp_csg2_ent, &tp_mot2, &tp_real2) == R_MOTION) {
				mot_ent(*ret_csg_ent, &tp_mot2);
				idtable[cur_id_ent].wanted = W_NO;
				return(R_CSG);
			}
			else {
				csg_error(cur_id_ent, "solid at a location expected < mexp AT lexp >");
				idtable[cur_id_ent].wanted = W_NO;
				return(R_UNDEF);
			}
			break;
		case O_CWITH:
			if (tbl_trav(gen_fname, idtable[cur_id_ent].l_link, cur_type, &tp_ali, ret_csg_ent, &tp_mot, &tp_real) == R_CSG
			 && tbl_trav(gen_fname, idtable[cur_id_ent].r_link, cur_type, &tp_ali2, &tp_csg2_ent, &tp_mot2, &tp_real2) == R_REAL) {
				csg[*ret_csg_ent].col = round(tp_real2);
				idtable[cur_id_ent].wanted = W_NO;
				return(R_CSG);
			}
			else {
				csg_error(cur_id_ent, "colored solid expected < mexp CWITH lexp >");
				idtable[cur_id_ent].wanted = W_NO;
				return(R_UNDEF);
			}
			break;
		case O_LIST:
			switch (cur_type) {
			case L_GENERIC:
				if (tbl_trav(gen_fname, idtable[cur_id_ent].l_link, L_GENERIC, &tp_ali, &tp_csg_ent, &tp_mot, &tp_real) == R_PARAM
			 	 && tbl_trav(gen_fname, idtable[cur_id_ent].r_link, L_GENERIC, &tp_ali2, &tp_csg2_ent, &tp_mot2, &tp_real2) == R_PARAM) {
					if (tp_ali && tp_ali2) {
						idtable[tp_ali2].a_link = tp_ali;
						*ret_alias = tp_ali2;
					}
					else if (tp_ali2)
						*ret_alias = tp_ali2;
					else
						*ret_alias = tp_ali;
					idtable[cur_id_ent].wanted = W_NO;
					return(R_PARAM);
				}
				else {
					csg_error(cur_id_ent, "generic parameter expected < lexp,nexp >");
					idtable[cur_id_ent].wanted = W_NO;
					return(R_UNDEF);
				}
				break;
			case L_PRIMITIVE:
				if (tbl_trav(gen_fname, idtable[cur_id_ent].l_link, L_PRIMITIVE, &tp_ali, &tp_csg_ent, &tp_mot, &tp_real) == R_PARAM
			 	 && tbl_trav(gen_fname, idtable[cur_id_ent].r_link, L_PRIMITIVE, &tp_ali2, &tp_csg2_ent, &tp_mot2, &tp_real2) == R_PARAM) {
					idtable[cur_id_ent].wanted = W_NO;
					return(R_PARAM);
				}
				else {
					csg_error(cur_id_ent, "primitive parameter expected < lexp,nexp >");
					idtable[cur_id_ent].wanted = W_NO;
					return(R_UNDEF);
				}
				break;
			case L_MOTION:
				if (tbl_trav(gen_fname, idtable[cur_id_ent].l_link, L_MOTION, &tp_ali, &tp_csg_ent, &tp_mot, &tp_real) == R_MOTION
			 	 && tbl_trav(gen_fname, idtable[cur_id_ent].r_link, L_MOTION, &tp_ali2, &tp_csg2_ent, &tp_mot2, &tp_real2) == R_MOTION) {
					m_comp(&tp_mot2, &tp_mot, ret_mot);
					idtable[cur_id_ent].wanted = W_NO;
					return(R_MOTION);
				}
				else {
					csg_error(cur_id_ent, "motion expected < lexp,nexp >");
					idtable[cur_id_ent].wanted = W_NO;
					return(R_UNDEF);
				}
				break;
			default:
				csg_error(cur_id_ent, "unknown list < lexp,nexp >");
				idtable[cur_id_ent].wanted = W_NO;
				return(R_UNDEF);
				break;
			}
			break;
		case O_WRT:
			if (tbl_trav(gen_fname, idtable[cur_id_ent].l_link, L_MOTION, &tp_ali, &tp_csg_ent, &tp_mot, &tp_real) == R_MOTION
			 && tbl_trav(gen_fname, idtable[cur_id_ent].r_link, L_MOTION, &tp_ali2, &tp_csg2_ent, &tp_mot2, &tp_real2) == R_MOTION) {
				m_inv(&tp_mot2, ret_mot);
				m_comp(&tp_mot, ret_mot, ret_mot);
				m_comp(&tp_mot2, ret_mot, ret_mot);
				idtable[cur_id_ent].wanted = W_NO;
				return(R_MOTION);
			}
			else {
				csg_error(cur_id_ent, "motion expected < lexp WRT nexp >");
				idtable[cur_id_ent].wanted = W_NO;
				return(R_UNDEF);
			}
			break;
		case O_TO:
			if (tbl_trav(gen_fname, idtable[cur_id_ent].l_link, L_MOTION, &tp_ali, &tp_csg_ent, &tp_mot, &tp_real) == R_MOTION) {
				m_inv(&tp_mot, &tp_mot);
				if (tbl_trav(gen_fname, idtable[cur_id_ent].r_link, L_MOTION, &tp_ali2, &tp_csg2_ent, &tp_mot2, &tp_real2) == R_MOTION) {
					m_comp(&tp_mot2, &tp_mot, ret_mot);
					idtable[cur_id_ent].wanted = W_NO;
					return(R_MOTION);
				}
				else {
					csg_error(cur_id_ent, "motion expected < lexp TO nexp >");
					idtable[cur_id_ent].wanted = W_NO;
					return(R_UNDEF);
				}
			}
			else {
				csg_error(cur_id_ent, "motion expected < lexp TO nexp >");
				idtable[cur_id_ent].wanted = W_NO;
				return(R_UNDEF);
			}
			break;
		}
	}
	else if (cur_op & OM_SOLID) {
		switch (cur_op) {
		case O_ASB:
			csg_func = C_ASB;
			goto csgp2;
		case O_UN:
			csg_func = C_UN;
			goto csgp2;
		case O_INT:
			csg_func = C_INT;
			goto csgp2;
		case O_DIF:
			csg_func = C_DIF;
csgp2:			if (tbl_trav(gen_fname, idtable[cur_id_ent].l_link, cur_type, &tp_ali, &tp_csg_ent, &tp_mot, &tp_real) == R_CSG
			 && tbl_trav(gen_fname, idtable[cur_id_ent].r_link, cur_type, &tp_ali2, &tp_csg2_ent, &tp_mot2, &tp_real2) == R_CSG) {
				*ret_csg_ent = csg_ent(csg_func, tp_csg_ent, tp_csg2_ent, 1.0, 1.0, 1.0, -1.0);
				idtable[cur_id_ent].wanted = W_NO;
				return(R_CSG);
			}
			else {
				csg_error(cur_id_ent, "solid expected < exp ASB/UN/INT/DIF exp >");
				idtable[cur_id_ent].wanted = W_NO;
				return(R_UNDEF);
			}
			break;
		}
	}
	else if (cur_op & OM_REAL) {
		switch (cur_op) {
		case O_EQ:
			real_func = o_eq;
			goto realp2;
		case O_NE:
			real_func = o_ne;
			goto realp2;
		case O_GE:
			real_func = o_ge;
			goto realp2;
		case O_GT:
			real_func = o_gt;
			goto realp2;
		case O_LE:
			real_func = o_le;
			goto realp2;
		case O_LT:
			real_func = o_lt;
			goto realp2;
		case O_PLUS:
			real_func = o_plus;
			goto realp2;
		case O_MINUS:
			real_func = o_minus;
			goto realp2;
		case O_MULT:
			real_func = o_mult;
			goto realp2;
		case O_DIV:
			real_func = o_div;
			goto realp2;
		case O_NEG:
			real_func = o_neg;
			goto realp1;
		case O_ABS:
			real_func = o_abs;
			goto realp1;
		case O_POW:
			real_func = pow;
realp2:			if (tbl_trav(gen_fname, idtable[cur_id_ent].l_link, cur_type, &tp_ali, &tp_csg_ent, &tp_mot, &tp_real) == R_REAL
			 && tbl_trav(gen_fname, idtable[cur_id_ent].r_link, cur_type, &tp_ali2, &tp_csg2_ent, &tp_mot2, &tp_real2) == R_REAL) {
				*ret_real = real_func(tp_real, tp_real2);
				idtable[cur_id_ent].wanted = W_NO;
				return(R_REAL);
			}
			else {
				csg_error(cur_id_ent, "real expression expected < exp OP exp >");
				idtable[cur_id_ent].wanted = W_NO;
				return(R_UNDEF);
			}
			break;
		case O_SIN:
			real_func = sin;
			goto realp1;
		case O_COS:
			real_func = cos;
			goto realp1;
		case O_TAN:
			real_func = tan;
			goto realp1;
		case O_ASIN:
			real_func = asin;
			goto realp1;
		case O_ACOS:
			real_func = acos;
			goto realp1;
		case O_ATAN:
			real_func = atan;
			goto realp1;
		case O_SQRT:
			real_func = sqrt;
			goto realp1;
		case O_LOG:
			real_func = log;
			goto realp1;
		case O_EXP:
			real_func = exp;
realp1:			if (tbl_trav(gen_fname, idtable[cur_id_ent].r_link, cur_type, &tp_ali, &tp_csg_ent, &tp_mot, &tp_real) == R_REAL) {
				*ret_real = real_func(tp_real);
				idtable[cur_id_ent].wanted = W_NO;
				return(R_REAL);
			}
			else {
				csg_error(cur_id_ent, "real expression expected < FUNC(exp) >");
				idtable[cur_id_ent].wanted = W_NO;
				return(R_UNDEF);
			}
			break;
		case O_RND:
			*ret_real = (double)rand()/32767.0;
			idtable[cur_id_ent].wanted = W_NO;
			return(R_REAL);
			break;
		case O_CONST:
			*ret_real = idtable[cur_id_ent].real;
			idtable[cur_id_ent].wanted = W_NO;
			return(R_REAL);
			break;
		}
	}
	else {
		csg_error(cur_id_ent, "undefined");
		idtable[cur_id_ent].wanted = W_NO;
		return(R_UNDEF);
	}
}
double o_eq(x, y) double x, y;
{
	return((x == y) ? 1.0 : 0.0);
}
double o_ne(x, y) double x, y;
{
	return((x != y) ? 1.0 : 0.0);
}
double o_ge(x, y) double x, y;
{
	return((x >= y) ? 1.0 : 0.0);
}
double o_gt(x, y) double x, y;
{
	return((x > y) ? 1.0 : 0.0);
}
double o_le(x, y) double x, y;
{
	return((x <= y) ? 1.0 : 0.0);
}
double o_lt(x, y) double x, y;
{
	return((x < y) ? 1.0 : 0.0);
}
double o_plus(x, y) double x, y;
{
	return(x+y);
}
double o_minus(x, y) double x, y;
{
	return(x-y);
}
double o_mult(x, y) double x, y;
{
	return(x*y);
}
double o_div(x, y) double x, y;
{
#define	LARGE_DOUBLE	1.0e+10

	if (y == 0.0) {
		if (x == 0.0)
			return(0.0);
		else if (x > 0)
			return( LARGE_DOUBLE);
		else
			return(-LARGE_DOUBLE);
	}
 	else
		return(x/y);
}
double o_neg(x) double x;
{
	return(-x);
}
double o_abs(x) double x;
{
	return((x >= 0.0) ? x : -x);
}
tbl_srch(id, fname) register char *id, *fname;
{
	register int	hashval, hashsave;

	hashval = hashsave = hash(id);
	while (idtable[hashval].name != NULL) {
		if (!strcmp(id, idtable[hashval].name) && !strcmp(fname, idtable[hashval].f_name))
			return(hashval);
		hashval = rehash(hashval);
		if (hashval == hashsave)
			break;
	}
	return(0);
}
csg_ent(type, left, right, x, y, z, col)
	int	type, left, right;
	double	x, y, z, col;
{
	if (++last_csg_ent > CSG_SIZE) {
		csg_error(0, "too many CSG operations");
		fprintf(stderr, "csg_ent: current CSG_SIZE is %d\n", CSG_SIZE);
		exit(1);
	}

	csg[last_csg_ent].mot_ent = 0;
	csg[last_csg_ent].x = x;
	csg[last_csg_ent].y = y;
	csg[last_csg_ent].z = z;
	csg[last_csg_ent].col = round(col);

	switch (type) {
	case C_PRIMITIVE:
		csg[last_csg_ent].type = type;
		csg[last_csg_ent].l_link = 0;
		csg[last_csg_ent].r_link = 0;
		csg[last_csg_ent].prim_ent = left;
		break;
	case C_ASB:
	case C_UN:
	case C_INT:
	case C_DIF:
		if (csg[left].type == C_ASB || csg[right].type == C_ASB)
			csg[last_csg_ent].type = C_ASB;
		else
			csg[last_csg_ent].type = type;
		csg[last_csg_ent].l_link = left;
		csg[last_csg_ent].r_link = right;
		csg[left].p_link = last_csg_ent;
		csg[right].p_link = last_csg_ent;
		csg[last_csg_ent].prim_ent = 0;
		break;
	default:
		csg[last_csg_ent].type = C_UNDEF;
		csg[last_csg_ent].l_link = 0;
		csg[last_csg_ent].r_link = 0;
		csg[last_csg_ent].p_link = 0;
		csg[last_csg_ent].prim_ent = 0;
		break;
	}
	return(last_csg_ent);
}
init_mot()
{
	STD_MOTION = &motion[0];

	STD_MOTION->u1 = 1.0;
	STD_MOTION->u2 = 0.0;
	STD_MOTION->u3 = 0.0;
	STD_MOTION->v1 = 0.0;
	STD_MOTION->v2 = 1.0;
	STD_MOTION->v3 = 0.0;
	STD_MOTION->w1 = 0.0;
	STD_MOTION->w2 = 0.0;
	STD_MOTION->w3 = 1.0;
	STD_MOTION->p1 = 0.0;
	STD_MOTION->p2 = 0.0;
	STD_MOTION->p3 = 0.0;
}
mot_ent(csg_ent, mot) int csg_ent; struct motion *mot;
{
	struct motion	*cur_mot;

	if (csg[csg_ent].mot_ent == 0) {
		if (++last_motion_ent > MOTION_SIZE) {
			csg_error(0, "too many MOTIONs");
			fprintf(stderr, "mot_ent: current MOTION_SIZE is %d\n", MOTION_SIZE);
			exit(1);
		}
		csg[csg_ent].mot_ent = last_motion_ent;
		cur_mot = &motion[last_motion_ent];
		m_copy(mot, cur_mot);
	}
	else {
		cur_mot = &motion[csg[csg_ent].mot_ent];
		m_comp(mot, cur_mot, cur_mot);
	}
}
csg_error(errid, s) int errid; char *s;
{
#define	C_ERROR_MAX	3

	c_errnum++;
	if (c_errnum <= C_ERROR_MAX) {
		while (errid && *idtable[errid].name == '$')
			errid = idtable[errid].l_link;
		fprintf(stderr, "\"%s\", %s: %s\n", idtable[errid].f_name, idtable[errid].name, s);
	}
}

