
/* mkblo.c	87/9/8 */

#include <stdio.h>
#include <math.h>

mkblo(fp, n, ss) register FILE *fp; register int n, ss;
{
#define	PI	(double) 3.1415926535897932
#define	SQRT3	(double) 1.7320508075688774
	register int	i;

	if (n != 4) {
		fprintf(stderr, "'n' for BLO must be 4...\n");
		exit(1);
	}
	if (ss != 0) {
		fprintf(stderr, "'sssw' for BLO must be 'ssoff'...\n");
		exit(1);
	}

/* face */
	fprintf(fp, "%d\n", 6);
  /* facolor, fasssw, favect, xlotop */
	for (i=1; i<=4; i++)
		fprintf(fp, "%d %d %d %d\n", 511, ss, i, i);
	fprintf(fp, "%d %d %d %d\n", 511, 0, 5, 5);
	fprintf(fp, "%d %d %d %d\n", 511, 0, 6, 6);

/* xloop */
	fprintf(fp, "%d\n", 6);
  /* r_link, xedtop */
	for (i=1; i<=4; i++)
		fprintf(fp, "%d %d\n", i, i);
	fprintf(fp, "%d %d\n", 5, 1);
	fprintf(fp, "%d %d\n", 6, 5);

/* xedge */
	fprintf(fp, "%d\n", 12);
  /* link1, link2, fa1, fa2, dp1, dp2, dv1, dv2 */
	for (i=1; i<=4; i++)
		fprintf(fp, "%d %d %d %d %d %d %d %d\n",
			i%4+1, i+8, 5, i,
			i, i%4+1, 5, i);
	for (i=1; i<=4; i++)
		fprintf(fp, "%d %d %d %d %d %d %d %d\n",
			i%4+9, (i+2)%4+5, i, 6,
			i+4, i%4+5, i, 6);
	for (i=1; i<=4; i++)
		fprintf(fp, "%d %d %d %d %d %d %d %d\n",
			i+4, (i+2)%4+1, i, (i+2)%4+1,
			i, i+4, i, (i+2)%4+1);

/* dpomax */
	fprintf(fp, "%.18g\n", SQRT3);

/* dpoint */
	fprintf(fp, "%d\n", 8);
  /* x, y, z, ref */
	fprintf(fp, "%.18g %.18g %.18g %d\n",  1.0, -1.0, -1.0, 3);
	fprintf(fp, "%.18g %.18g %.18g %d\n",  1.0,  1.0, -1.0, 3);
	fprintf(fp, "%.18g %.18g %.18g %d\n", -1.0,  1.0, -1.0, 3);
	fprintf(fp, "%.18g %.18g %.18g %d\n", -1.0, -1.0, -1.0, 3);

	fprintf(fp, "%.18g %.18g %.18g %d\n",  1.0, -1.0,  1.0, 3);
	fprintf(fp, "%.18g %.18g %.18g %d\n",  1.0,  1.0,  1.0, 3);
	fprintf(fp, "%.18g %.18g %.18g %d\n", -1.0,  1.0,  1.0, 3);
	fprintf(fp, "%.18g %.18g %.18g %d\n", -1.0, -1.0,  1.0, 3);

/* dvect */
	fprintf(fp, "%d\n", 6);
  /* x, y, z, ref */
	fprintf(fp, "%.18g %.18g %.18g %d\n",  1.0,  0.0,  0.0, 5);
	fprintf(fp, "%.18g %.18g %.18g %d\n",  0.0,  1.0,  0.0, 5);
	fprintf(fp, "%.18g %.18g %.18g %d\n", -1.0,  0.0,  0.0, 5);
	fprintf(fp, "%.18g %.18g %.18g %d\n",  0.0, -1.0,  0.0, 5);

	fprintf(fp, "%.18g %.18g %.18g %d\n",  0.0,  0.0, -1.0, 5);
	fprintf(fp, "%.18g %.18g %.18g %d\n",  0.0,  0.0,  1.0, 5);
}

