
/* mkcon.c	87/9/8 */

#include <stdio.h>
#include <math.h>

mkcon(fp, n, ss) register FILE *fp; register int n, ss;
{
#define	PI	(double) 3.1415926535897932
#define	SQRT2	(double) 1.4142135623730951
	double		th;
	register int	i;

/* face */
	fprintf(fp, "%d\n", n+2);
  /* facolor, fasssw, favect, xlotop */
	for (i=1; i<=n; i++)
		fprintf(fp, "%d %d %d %d\n", 511, ss, i, i);
	fprintf(fp, "%d %d %d %d\n", 511, 0, n+1, n+1);
	fprintf(fp, "%d %d %d %d\n", 511, 0, n+2, n+2);

/* xloop */
	fprintf(fp, "%d\n", n+2);
  /* r_link, xedtop */
	for (i=1; i<=n; i++)
		fprintf(fp, "%d %d\n", i, i);
	fprintf(fp, "%d %d\n", n+1, 1);
	fprintf(fp, "%d %d\n", n+2, n+1);

/* xedge */
	fprintf(fp, "%d\n", n*3);
  /* link1, link2, fa1, fa2, dp1, dp2, dv1, dv2 */
	if (ss) {
		for (i=1; i<=n; i++)
			fprintf(fp, "%d %d %d %d %d %d %d %d\n",
				i%n+1, i+n*2, n+1, i,
				i, i%n+1, n+1, i%n+1+n+2);
		for (i=1; i<=n; i++)
			fprintf(fp, "%d %d %d %d %d %d %d %d\n",
				i%n+1+n*2, (i+n-2)%n+n+1, i, n+2,
				n+1, n+1, i+n+2, n+2);
		for (i=1; i<=n; i++)
			fprintf(fp, "%d %d %d %d %d %d %d %d\n",
				i+n, (i+n-2)%n+1, i, (i+n-2)%n+1,
				i, n+1, i+n+2, i+n+2);
	}
	else {
		for (i=1; i<=n; i++)
			fprintf(fp, "%d %d %d %d %d %d %d %d\n",
				i%n+1, i+n*2, n+1, i,
				i, i%n+1, n+1, i);
		for (i=1; i<=n; i++)
			fprintf(fp, "%d %d %d %d %d %d %d %d\n",
				i%n+1+n*2, (i+n-2)%n+n+1, i, n+2,
				n+1, n+1, i, n+2);
		for (i=1; i<=n; i++)
			fprintf(fp, "%d %d %d %d %d %d %d %d\n",
				i+n, (i+n-2)%n+1, i, (i+n-2)%n+1,
				i, n+1, i, (i+n-2)%n+1);
	}

/* dpomax */
	fprintf(fp, "%.18g\n", SQRT2);

/* dpoint */
	fprintf(fp, "%d\n", n+1);
  /* x, y, z, ref */
	for (i=0; i<n; i++) {
		th = i*PI*2/n;
	 	fprintf(fp, "%.18g %.18g %.18g %d\n", cos(th), sin(th), 0.0, 3);
	}
	fprintf(fp, "%.18g %.18g %.18g %d\n", 0.0, 0.0, 1.0, n*3);

/* dvect */
	if (ss) {
		fprintf(fp, "%d\n", n*2+2);
  /* x, y, z, ref */
		for (i=0; i<n; i++) {
			th = i*PI*2/n+PI/n;
	 		fprintf(fp, "%.18g %.18g %.18g %d\n",
				cos(th), sin(th), cos(PI/n), 1);
		}
		fprintf(fp, "%.18g %.18g %.18g %d\n", 0.0, 0.0, -1.0, n+1);
		fprintf(fp, "%.18g %.18g %.18g %d\n", 0.0, 0.0,  1.0, n+1);
		for (i=0; i<n; i++) {
			th = i*PI*2/n;
	 		fprintf(fp, "%.18g %.18g %.18g %d\n",
				cos(th), sin(th), 1.0, 4);
		}
	}
	else {
		fprintf(fp, "%d\n", n+2);
  /* x, y, z, ref */
		for (i=0; i<n; i++) {
			th = i*PI*2/n+PI/n;
	 		fprintf(fp, "%.18g %.18g %.18g %d\n",
				cos(th), sin(th), cos(PI/n), 5);
		}
		fprintf(fp, "%.18g %.18g %.18g %d\n", 0.0, 0.0, -1.0, n+1);
		fprintf(fp, "%.18g %.18g %.18g %d\n", 0.0, 0.0,  1.0, n+1);
	}
}

