
/* mksph.c	87/9/8 */

#include <stdio.h>
#include <math.h>

mksph(fp, n, ss) register FILE *fp; register int n, ss;
{
#define	PI	(double) 3.1415926535897932
#define	SQRT2	(double) 1.4142135623730951
	double		r, z, th;
	register int	i, j;
	register int	evofs, sploc, nploc;

	if (n % 2) {
		fprintf(stderr, "'n' for SPH must be 6,8,10,12...\n");
		exit(1);
	}

	evofs = n*n/2;
	sploc = (n/2-1)*n+1; nploc = (n/2-1)*n+2;

/* face */
	fprintf(fp, "%d\n", n*n/2);
  /* facolor, fasssw, favect, xlotop */
	for (i=0; i<n/2; i++)
		for (j=1; j<=n; j++)
			fprintf(fp, "%d %d %d %d\n", 511, ss, i*n+j, i*n+j);

/* xloop */
	fprintf(fp, "%d\n", n*n/2);
  /* r_link, xedtop */
	for (i=0; i<n/2; i++)
		for (j=1; j<=n; j++)
			fprintf(fp, "%d %d\n", i*n+j, i*n+j);

/* xedge */
	fprintf(fp, "%d\n", (n-1)*n);
  /* link1, link2, fa1, fa2, dp1, dp2, dv1, dv2 */
	if (ss) {
		for (j=1; j<=n; j++)
			fprintf(fp, "%d %d %d %d %d %d %d %d\n",
				j+evofs, ((j+n-2)%n+1), j, ((j+n-2)%n+1),
				sploc, j, sploc+evofs, j+evofs);
		for (i=1; i<=n/2-2; i++)
			for (j=1; j<=n; j++)
				fprintf(fp, "%d %d %d %d %d %d %d %d\n",
					i*n+j+evofs, (i-1)*n+((j+n-2)%n+1)+evofs,
					i*n+j, i*n+((j+n-2)%n+1),
					(i-1)*n+j, i*n+j,
					(i-1)*n+j+evofs, i*n+j+evofs);
		for (j=1; j<=n; j++)
			fprintf(fp, "%d %d %d %d %d %d %d %d\n",
				j%n+1+(n/2-1)*n, ((j+n-2)%n+1)+evofs+(n/2-2)*n,
				(n/2-1)*n+j, (n/2-1)*n+((j+n-2)%n+1),
				(n/2-2)*n+j, nploc,
				(n/2-2)*n+j+evofs, nploc+evofs);
		for (i=0; i<=n/2-2; i++)
			for (j=1; j<=n; j++)
				fprintf(fp, "%d %d %d %d %d %d %d %d\n",
					i*n+j%n+1, (i+1)*n+j, i*n+j, (i+1)*n+j,
					i*n+j, i*n+j%n+1,
					i*n+j+evofs, i*n+j%n+1+evofs);
	}
	else {
		for (j=1; j<=n; j++)
			fprintf(fp, "%d %d %d %d %d %d %d %d\n",
				j+evofs, ((j+n-2)%n+1), j, ((j+n-2)%n+1),
				sploc, j, j, ((j+n-2)%n+1));
		for (i=1; i<=n/2-2; i++)
			for (j=1; j<=n; j++)
				fprintf(fp, "%d %d %d %d %d %d %d %d\n",
					i*n+j+evofs, (i-1)*n+((j+n-2)%n+1)+evofs,
					i*n+j, i*n+((j+n-2)%n+1),
					(i-1)*n+j, i*n+j,
					i*n+j, i*n+((j+n-2)%n+1));
		for (j=1; j<=n; j++)
			fprintf(fp, "%d %d %d %d %d %d %d %d\n",
				j%n+1+(n/2-1)*n, ((j+n-2)%n+1)+evofs+(n/2-2)*n,
				(n/2-1)*n+j, (n/2-1)*n+((j+n-2)%n+1),
				(n/2-2)*n+j, nploc,
				(n/2-1)*n+j, (n/2-1)*n+((j+n-2)%n+1));
		for (i=0; i<=n/2-2; i++)
			for (j=1; j<=n; j++)
				fprintf(fp, "%d %d %d %d %d %d %d %d\n",
					i*n+j%n+1, (i+1)*n+j, i*n+j, (i+1)*n+j,
					i*n+j, i*n+j%n+1, i*n+j, (i+1)*n+j);
	}

/* dpomax */
	fprintf(fp, "%.18g\n", 1.0);

/* dpoint */
	fprintf(fp, "%d\n", (n/2-1)*n+2);
  /* x, y, z, ref */
	for (i=1; i<n/2; i++) {
		r =  sin(i*PI*2/n);
		z = -cos(i*PI*2/n);
		for (j=0; j<n; j++) {
			th = j*PI*2/n;
	 		fprintf(fp, "%.18g %.18g %.18g %d\n",
				r*cos(th), r*sin(th), z, 4);
		}
	}
 	fprintf(fp, "%.18g %.18g %.18g %d\n", 0.0, 0.0, -1.0, n);
 	fprintf(fp, "%.18g %.18g %.18g %d\n", 0.0, 0.0,  1.0, n);

/* dvect */
	if (ss) {
		fprintf(fp, "%d\n", n*n/2+(n/2-1)*n+2);
  /* x, y, z, ref */
		for (i=1; i<=n/2; i++) {
			r = cos((i-1)*PI*2/n)-cos(i*PI*2/n);
			z = cos(PI/n)*(sin((i-1)*PI*2/n)-sin(i*PI*2/n));
			for (j=0; j<n; j++) {
				th = j*PI*2/n+PI/n;
	 			fprintf(fp, "%.18g %.18g %.18g %d\n",
					r*cos(th), r*sin(th), z, 1);
			}
		}
		for (i=1; i<n/2; i++) {
			r =  sin(i*PI*2/n);
			z = -cos(i*PI*2/n);
			for (j=0; j<n; j++) {
				th = j*PI*2/n;
	 			fprintf(fp, "%.18g %.18g %.18g %d\n",
					r*cos(th), r*sin(th), z, 4);
			}
		}
		fprintf(fp, "%.18g %.18g %.18g %d\n", 0.0, 0.0, -1.0, n);
		fprintf(fp, "%.18g %.18g %.18g %d\n", 0.0, 0.0,  1.0, n);
	}
	else {
		fprintf(fp, "%d\n", n*n/2);
  /* x, y, z, ref */
		i = 1;
		r = cos((i-1)*PI*2/n)-cos(i*PI*2/n);
		z = cos(PI/n)*(sin((i-1)*PI*2/n)-sin(i*PI*2/n));
		for (j=0; j<n; j++) {
			th = j*PI*2/n+PI/n;
	 		fprintf(fp, "%.18g %.18g %.18g %d\n",
				r*cos(th), r*sin(th), z, 4);
		}
		for (i=2; i<n/2; i++) {
			r = cos((i-1)*PI*2/n)-cos(i*PI*2/n);
			z = cos(PI/n)*(sin((i-1)*PI*2/n)-sin(i*PI*2/n));
			for (j=0; j<n; j++) {
				th = j*PI*2/n+PI/n;
	 			fprintf(fp, "%.18g %.18g %.18g %d\n",
					r*cos(th), r*sin(th), z, 5);
			}
		}
		i = n/2;
		r = cos((i-1)*PI*2/n)-cos(i*PI*2/n);
		z = cos(PI/n)*(sin((i-1)*PI*2/n)-sin(i*PI*2/n));
		for (j=0; j<n; j++) {
			th = j*PI*2/n+PI/n;
	 		fprintf(fp, "%.18g %.18g %.18g %d\n",
				r*cos(th), r*sin(th), z, 4);
		}
	}
}

