

/* mkwed.c	87/9/8 */

#include <stdio.h>
#include <math.h>

mkwed(fp, n, ss) register FILE *fp; register int n, ss;
{
#define	SQRT2	(double) 1.4142135623730951
	register int	i;

	if (n != 3) {
		fprintf(stderr, "'n' for WED must be 3...\n");
		exit(1);
	}
	if (ss != 0) {
		fprintf(stderr, "'sssw' for WED must be 'ssoff'...\n");
		exit(1);
	}

/* face */
	fprintf(fp, "%d\n", 5);
  /* facolor, fasssw, favect, xlotop */
	for (i=1; i<=3; i++)
		fprintf(fp, "%d %d %d %d\n", 511, ss, i, i);
	fprintf(fp, "%d %d %d %d\n", 511, 0, 4, 4);
	fprintf(fp, "%d %d %d %d\n", 511, 0, 5, 5);

/* xloop */
	fprintf(fp, "%d\n", 5);
  /* r_link, xedtop */
	for (i=1; i<=3; i++)
		fprintf(fp, "%d %d\n", i, i);
	fprintf(fp, "%d %d\n", 4, 1);
	fprintf(fp, "%d %d\n", 5, 4);

/* xedge */
	fprintf(fp, "%d\n", 9);
  /* link1, link2, fa1, fa2, dp1, dp2, dv1, dv2 */
	for (i=1; i<=3; i++)
		fprintf(fp, "%d %d %d %d %d %d %d %d\n",
			i%3+1, i+6, 4, i,
			i, i%3+1, 4, i);
	for (i=1; i<=3; i++)
		fprintf(fp, "%d %d %d %d %d %d %d %d\n",
			i%3+7, (i+1)%3+4, i, 5,
			i+3, i%3+4, i, 5);
	for (i=1; i<=3; i++)
		fprintf(fp, "%d %d %d %d %d %d %d %d\n",
			i+3, (i+1)%3+1, i, (i+1)%3+1,
			i, i+3, i, (i+1)%3+1);

/* dpomax */
	fprintf(fp, "%.18g\n", SQRT2);

/* dpoint */
	fprintf(fp, "%d\n", 6);
  /* x, y, z, ref */
	fprintf(fp, "%.18g %.18g %.18g %d\n",  1.0,  0.0,  0.0, 3);
	fprintf(fp, "%.18g %.18g %.18g %d\n",  0.0,  1.0,  0.0, 3);
	fprintf(fp, "%.18g %.18g %.18g %d\n",  0.0,  0.0,  0.0, 3);

	fprintf(fp, "%.18g %.18g %.18g %d\n",  1.0,  0.0,  1.0, 3);
	fprintf(fp, "%.18g %.18g %.18g %d\n",  0.0,  1.0,  1.0, 3);
	fprintf(fp, "%.18g %.18g %.18g %d\n",  0.0,  0.0,  1.0, 3);

/* dvect */
	fprintf(fp, "%d\n", 5);
  /* x, y, z, ref */
	fprintf(fp, "%.18g %.18g %.18g %d\n",  1.0,  1.0,  0.0, 5);
	fprintf(fp, "%.18g %.18g %.18g %d\n", -1.0,  0.0,  0.0, 5);
	fprintf(fp, "%.18g %.18g %.18g %d\n",  0.0, -1.0,  0.0, 5);

	fprintf(fp, "%.18g %.18g %.18g %d\n",  0.0,  0.0, -1.0, 5);
	fprintf(fp, "%.18g %.18g %.18g %d\n",  0.0,  0.0,  1.0, 5);
}

